* moni.ASM Monitorprogramm fr MVUS 332 Version: 31.12.97 EPROM-Version

RAMbase equ     $200000
;ROMbase equ     $200000
ROMbase equ     0

;stapel  equ     $100780    ; Stapel im oberen TPURAM
;bereg   equ     $100790    ; Benutzerregister ber Stapel
;        org     $50000     ; TEST ---ab $5.0000----------------------- TEST
;stapel  equ     $110000    ; Stapel im oberen TPURAM
;bereg   equ     $110010    ; Benutzerregister ber Stapel
;        org     0          ; Vektortabelle  fr EPROM-Version
;        org     $100000    ; Vektortabelle  fr EPROM-Version

stapel  equ     RAMbase+$10000; Stapel im oberen RAM
bereg   equ     RAMbase+$10010; Benutzerregister ber Stapel

        org     ROMbase    ; Vektortabelle  fr RAM-Version

        dc.l    stapel     ; A7  = Stapelzeiger SSP
        dc.l    start      ; PC  = Startadresse
        dc.l    berr       ; #2  $08 Typ $c Busfehler
        dc.l    aerr       ; #3  $0c Typ $c Adrefehler
        dc.l    cerr       ; #4  $10 Typ $0 Codefehler ILLEGAL
        dc.l    derr       ; #5  $14 Typ $2 Divisionsfehler /0
        dc.l    chkx       ; #6  $18 Typ $2 Befehle CHK und CHK2
        dc.l    trpx       ; #7  $1c Typ $2 Befehle TRAPcc und TRAPV
        dc.l    perr       ; #8  $20 Typ $0 Privilegfehler
        dc.l    trac       ; #9  $24 Typ $2 TRACE T-Bits
        dc.l    eaxx       ; #10 $28 Typ $0 Emulator $Axxx-Code
        dc.l    efxx       ; #11 $2c Typ $0 Emulator $Fxxx-Code
        dc.l    bkpt       ; #12 $30 Typ $2 Hardware-Breakpoint
        dc.l    resx       ; #13 $34 Typ -- reserviert Coprozessor
        dc.l    ferr       ; #14 $38 Typ $0 Formatfehler bei RTE
        dc.l    inot       ; #15 $3c Typ $0 Interrupt nicht init
        dcb.l   8,resx     ; #16-#23 Typ -- reserviert
        dc.l    ierr       ; #24 $60 Typ $0 Interruptfehler (falscher)
        dc.l    int1       ; #25 $64 Typ $0 Eigenvektor Ebene 1
        dc.l    int2       ; #26 $68 Typ $0 Eigenvektor Ebene 2
        dc.l    int3       ; #27 $6c Typ $0 Eigenvektor Ebene 3
        dc.l    int4       ; #28 $70 Typ $0 Eigenvektor Ebene 4
        dc.l    int5       ; #29 $74 Typ $0 Eigenvektor Ebene 5
        dc.l    int6       ; #30 $78 Typ $0 Eigenvektor Ebene 6
        dc.l    int7       ; #31 $7c Typ $0 Eigenvektor Ebene 7 NMI
        dc.l    trap0      ; #32 $80 Typ $0 TRAP #0
        dc.l    trap1      ; #33 $84 Typ $0 TRAP #1
        dc.l    trap2      ; #34 $88 Typ $0 TRAP #2
        dc.l    trap3      ; #35 $8c Typ $0 TRAP #3
        dc.l    trap4      ; #36 $90 Typ $0 TRAP #4
        dc.l    trap5      ; #37 $94 Typ $0 TRAP #5
        dc.l    trap6      ; #38 $98 Typ $0 TRAP #6
        dc.l    trap7      ; #39 $9c Typ $0 TRAP #7
        dc.l    trap8      ; #40 $a0 Typ $0 TRAP #8
        dc.l    trap9      ; #41 $a4 Typ $0 TRAP #9
        dc.l    trap10     ; #42 $a8 Typ $0 TRAP #10
        dc.l    trap11     ; #43 $ac Typ $0 TRAP #11
        dc.l    trap12     ; #44 $b0 Typ $0 TRAP #12
        dc.l    trap13     ; #45 $b4 Typ $0 TRAP #13
        dc.l    trap14     ; #46 $b8 Typ $0 TRAP #14
        dc.l    trap15     ; #47 $bc Typ $0 TRAP #15
        dcb.l   8,resx    ; #48-63 $c0 - $fc reserviert
        dcb.l   8,resx    ; #48-63 $c0 - $fc reserviert
* #64-255  $100 - $3fc Benutzervektoren nicht besetzt
*
* Ein-/Ausgabe-Basisprogramme hardware- und systemabhngig
* AUSZ: Zeichen aus D0.B auf Terminal ausgeben
ausz    btst    #0,SCSRH   ; Sender frei ?
        beq.b   ausz       ; nein: warten
        move.b  d0,SCDRL   ; ja: nach Sender
        rts
* EINT: Eingabe testen: C=1: Zeichen in D0.B  C=0: kein Zeichen
eint    btst    #6,SCSRL   ; Zeichen im Empfnger?
        beq.b   eint1      ; nein: C=0 setzen
        move.b  SCDRL,d0   ; ja: abholen nach D0.B
        ori     #1,CCR     ; C=1 setzen: Zeichen in D0.B
        rts
eint1   andi    #$FE,CCR   ; C=0 setzen: kein Zeichen
        rts
* EINZ: Zeichen von Terminal nach D0.B lesen
einz    btst    #6,SCSRL   ; Zeichen im Empfnger?
        beq.b   einz       ; nein: warten
        move.b  SCDRL,d0   ; ja: abholen nach D0.B
        rts
* Eingabe-Unterprogramme systemUNabhngig
* EINZE:  Zeichen von Terminal nach D0.B lesen mit Echo
einze  bsr.b    einz       ; lesen
       bsr.b    ausz       ; Echo
       rts
* DEKO: Hexazeichen in D0.B decodieren C=1: Nicht-Hexa-Zeichen
deko   cmpi.b   #'0',d0    ; kleiner Ziffer 0 ?
       bcs.b    dekof      ; ja: nicht Hexaziffer
       cmpi.b   #'9',d0    ; grer Ziffer 9 ?
       bhi.b    deko1      ; ja: weiter versuchen
       subi.b   #$30,d0    ; Ziffer 0..9 dekodieren
       rts                 ; C = 0: war Hexa-Ziffer
deko1  cmpi.b   #'A',d0    ; kleiner Ziffer A ?
       bcs.b    dekof      ; ja: nicht Hexa-Ziffer
       cmpi.b   #'F',d0    ; grer Ziffer F ?
       bhi.b    deko2      ; ja: weiter versuchen
       subi.b   #$37,d0    ; Ziffer A..F dekodieren
       rts                 ; C = 0: war Hexa-Ziffer
deko2  cmpi.b   #'a',d0    ; kleiner Ziffer a ?
       bcs.b    dekof      ; ja: nicht Hexa-Ziffer
       cmpi.b   #'f',d0    ; grer Ziffer f ?
       bhi.b    dekof      ; ja: war nicht a..f
       subi.b   #$57,d0    ; Ziffer a..f dekodieren
       rts                 ; C = 0: war Hexa-Ziffer
dekof  ori      #1,ccr     ; C = 1: keine Hexa-Ziffer
       rts
* EINAD: lz ADR>123456 cr lz nach D0.L  Fehler: Hupe BS Punkt = $0000
einad  move.l   d1,-(a7)   ; D1 retten
einad0 bsr      dileer     ; Leerzeichen
       move.l   #'Adr$',d0 ; Meldung
       bsr      dizei4     ; ausgeben
       clr.l    d1         ; Adresse 0 vorgegeben
einad1 bsr      einze      ; Zeichen mit Echo lesen
       bsr      deko       ; dekodieren
       bcs.b    einad2     ; C = 1: kein Hexazeichen
       lsl.l    #4,d1      ; alten Wert nach links
       or.b     d0,d1      ; neue Stelle dazu
       bra.b    einad1     ; weitere Stellen
einad2 cmpi.b   #8,d0      ; BS-Zeichen
       beq.b    einad0     ; ja: neue Eingabe
       cmpi.b   #$20,d0    ; Steuer- oder Leerzeichen ?
       bls.b    einad4     ; ja: Ende der Eingabe
       cmpi.b   #'.',d0    ; Punkt fr 0000 und Ende ?
       beq.b    einad3     ; ja: rechtes Wort 0000
       bsr      difehl     ; Hupe und BS Steuerzeichen ausgeben
       bra.b    einad1     ; neue Versuche
einad3 move.l   #'0000',d0 ; Echo fr . ist 0000
       bsr      dizei4     ;
       bsr      dileer     ; und Leerzeichen
       swap     d1         ; alt.xxxx
       clr.w    d1         ; alt.0000
einad4 move.l   d1,d0      ; Adresse nach D0
       move.l   (a7)+,d1   ; d1 zurck
       rts
* EINNI: lesen mit Echo Hexa dekodieren C = 1 : Nicht-Hexa
einni  bsr      einze      ; Zeichen mit Echo lesen
       bsr      deko       ; Dekodierversuch
       bcc.b    einni1     ; gut: war hexa
       bsr      difehl     ; Hupe und BS Steuerzeichen ausgeben
       bra.b    einni      ; neuer Versuch
einni1 rts                 ; bis Hexa-Ziffer Nibble in D0.B
* EINNO: lesen ohne Echo Hexa dekodieren C=1: Nicht-Hexa
einno  bsr      einz       ; Zeichen ohne Echo lesen
       bsr      deko       ; Dekodierversuch
       bcc.b    einno1     ; gut: war hexa
       bsr      difehl     ; Hupe und BS Steuerzeichen ausgeben
       bra.b    einno      ; neuer Versuch
einno1 rts                 ; bis Hexa-Ziffer Nibble in D0.B
* EINZM: Meldung, Prompt und Zahl nach D0.L
einzm  move.l   #'Wert',d0 ; Meldung und
       bsr      dizei4     ; neue Zeile
* EINZP: Prompt und Zahl nach D0.L
einzp  move.l   #' -> ',d0 ; Prompt
       bsr      dizei4     ; ausgeben
* EINZA: Zahl nach D0.L +- dezimal   +-$ hexa
einza  movem.l  d1/d2,-(a7) ; D1 und D2 retten
       clr.l    d1         ; Zahl lschen
       clr.l    d2         ; Vorzeichen + vorbesetzt
einza1 bsr      einze      ; 1. Zeichen mit Echo
       cmpi.b   #'+',d0    ; + Vorzeichen ?
       beq.b    einza1     ; ja: D2 = 0 vorbesetzt
       cmpi.b   #'-',d0    ; - Vorzeichen ?
       bne.b    einza2     ; nein:
       addq     #1,d2      ; ja: D2 = 1 <> 0 gesetzt
       bra.b    einza1     ; weiter
einza2 cmpi.b   #'$',d0    ; Hexa-Eingabe ?
       beq.b    einza4     ; ja:
* dezimale Eingabe endet mit Nicht-Ziffer 0 - 9
einza3 cmpi.b   #'0',d0    ; Ziffernbereich ?
       bcs.b    einza5     ; Nicht-Ziffer: Ende
       cmpi.b   #'9',d0    ; Ziffernbereich ?
       bhi.b    einza5     ; Nicht-Ziffer: Ende
       subi.b   #$30,d0    ; Ziffer dekodieren
       mulu.l   #10,d1     ; alten Wert * 10
       extb.l   d0         ; neue Ziffer ausdehnen
       add.l    d0,d1      ; und addieren
       bsr      einze      ; neues Zeichen im Echo
       bra.b    einza3     ; verarbeiten
* hexadezimale Eingabe endet mit Nicht-Ziffer 0-9,a-f,A-F
einza4 bsr      einze      ; Zeichen im Echo lesen
       bsr      deko       ; und dekodieren
       bcs.b    einza5     ; war Nicht-Hexa-Ziffer: Ende
       lsl.l    #4,d1      ; alten Wert nach links
       or.b     d0,d1      ; neue Ziffer dazu
       bra.b    einza4     ; und weiter gehts
* Ende der Eingabe durch Nicht-Ziffer ohne Kontrollen !!!
einza5 move.l   d1,d0      ; bergabe in D0.L
       tst.l    d2         ; negatives Vorzeichen ?
       beq.b    einza6     ; nein: Wert bleibt
       neg.l    d0         ; ja: Zweierkomplement
einza6 movem.l  (a7)+,d1/d2 ; D1 und D2 zurck
       rts
* Ausgabe-Unterprogramme (aus DISASM) fr Zeichen und Speicherinhalte 
* dizei: D0.L retten und Zeichen aus D0.B ausgeben
dizei   movem.l d0,-(a7)   ; D0.L retten   BSR dizei
dizei1  bsr     ausz       ; Einsprung fr BRA dizei1
        movem.l (A7)+,d0   ; D0.L zurck
        rts                ; Rcksprung
dileer  movem.l d0,-(a7)   ; D0.L retten
        move.b  #$20,d0    ; lz laden
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
didoll  movem.l d0,-(a7)   ; D0.L retten
        move.b  #'$',d0    ; Dollar $ laden
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
diraut  movem.l d0,-(a7)   ; D0.L retten
        move.b  #'#',d0    ; Raute # 
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
dipunk  movem.l d0,-(a7)   ; D0.L retten
        move.b  #'.',d0    ; Punkt .
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
dikomm  movem.l d0,-(a7)   ; D0.L retten
        move.b  #$2c,d0    ; Komma ,
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
dikauf  movem.l d0,-(a7)   ; D0.L retten
        move.b  #$28,d0    ; Klammer auf (
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
dikzu   movem.l d0,-(a7)   ; D0.L retten
        move.b  #$29,d0    ; Klammer zu )
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
distri  movem.l d0,-(a7)   ; D0.L retten
        move.b  #'/',d0    ; Trennstrich / laden
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
didopp  movem.l d0,-(a7)   ; D0.L retten
        move.b  #':',d0    ; Doppelpunkt :
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
diglei  movem.l d0,-(a7)   ; D0.L retten
        move.b  #'=',d0    ; Gleichheitszeichen =
        bra.b   dizei1     ; ausgeben, D0.L zurck und Rcksprung
* Ausgabe von 2 konstanten Zeichen aus D0.W
dipfei  movem.l d0,-(a7)   ; D0.L retten
        move.w  #'=>',d0   ; => fr Bcc DBcc JMP
dipfei1 bsr     dizei2     ; ausgeben
        movem.l (a7)+,d0   ; D0.L zurck
        rts                ;
dineuz  movem.l d0,-(a7)   ; D0.L retten
        move.w  #$0d0a,d0  ; cr lf fr neue Zeile
        bra.b   dipfei1    ;
difehl  movem.l d0,-(a7)   ; D0.L retten
        move.w  #$0708,d0  ; Hupe BS Rckschritt
        bra.b   dipfei1    ;
* Mehrere Zeichen aus D0.W und D0.L ausgeben
dizei2  ror.w   #8,d0      ; 2 Zeichen aus D0.W ausgeben
        bsr     dizei      ;
        ror.w   #8,d0      ;
        bsr     dizei      ;
        rts                ;
dizei4n bsr.b   dineuz     ; cr lf und 4 Zeichen aus D0.L
dizei4  tst.l   d0         ; D0 = 0 ?
        beq.b   dizei41    ; ja: A0 = Textadresse bis $00
        swap    d0         ; nein: 4 Zeichen aus D0.L ausgeben
        bsr.b   dizei2     ; erst High-Wort
        swap    d0         ;
        bsr.b   dizei2     ; dann Low-Wort
        rts                ;
dizei41 movem.l d0/a0,-(a7) ; D0 und A0 retten
dizei42 move.b  (a0)+,d0   ; Zeichen laden
        tst.b   d0         ; Endemarke 0 ?
        beq.b   dizei43    ; ja: Ende
        bsr     dizei      ; nein: Zeichen ausgeben
        bra.b   dizei42    ; weiter im Text
dizei43 movem.l (a7)+,d0/a0 ; D0 und A0 zurck
        rts                ;
* Ausgabe-Unterprogramme fr Speicherinhalte hexadezimal 
dinibbr bsr     diraut     ; # ausgeben
dinibbd bsr     didoll     ; $ ausgeben
dinibb  movem.l d0,-(a7)   ; D0.L retten   BSR dinibb
dinibb1 andi.b  #$0f,d0    ; Einsprung fr BRA dinib1
        addi.b  #'0',d0    ; codieren
        cmpi.b  #'9',d0    ; <= Ziffer 9 ?
        bls.b   dinibb2    ; ja: Ziffer 0 - 9
        addi.b  #7,d0      ; nein: Ziffer A - F
dinibb2 bra     dizei1     ; ausgeben, D0.L zurck und Rcksprung
dibyter bsr     diraut     ; # ausgeben
dibyted bsr     didoll     ; $ ausgeben
dibyte  ror.b   #4,d0      ; High-Nibble zuerst
        bsr.b   dinibb     ; ausgeben
        ror.b   #4,d0      ; dann Low-Nibble
        bsr.b   dinibb     ; ausgeben
        rts                ;
didezir bsr     diraut     ; # ausgeben D0.L dezimal ausgeben
didezi  movem.l d0-d3,-(a7) ; Register retten 
        clr.l   d3         ; D3.L = 0: fhrende Nullen
        move.l  #1000000000,d2  ; Divisor
didezi1 divul.l d2,d1:d0   ; D0.L : D2.L Quot = D0.L Rest = D1.L
        tst.b   d0         ; Stelle Null ?
        bne.b   didezi2    ; nein: ausgeben
        tst.l   d3         ; ja: waren schon Stellen da ?
        beq.b   didezi3    ; nein: fhrende Null unterdrcken
didezi2 addq.l  #1,d3      ; D3.L != 0: jetzt immer Nullen ausgeben
        addi.b  #'0',d0    ; Quotient = Stelle codieren
        bsr.b   dinibb     ; und ausgeben
didezi3 move.l  d1,d0      ; Rest wird neuer Dividend
        divu.l  #10,d2     ; D2.L : 10   Quot = D2.l Rest verloren
        cmpi.l  #1,d2      ; Divisor = 1 ?
        bne.b   didezi1    ; nein: weiter machen
        addi.b  #'0',d0    ; ja: letzte Stelle immer codieren
        bsr.b   dinibb     ; und ausgeben 
        movem.l (a7)+,d0-d3 ; Register zurck
        rts                ;
diwortr bsr     diraut     ; # ausgeben
diwortd bsr     didoll     ; $ ausgeben
diwort  ror.w   #8,d0      ; High-Byte zuerst
        bsr.b   dibyte     ; ausgeben
        ror.w   #8,d0      ; dann Low-Byte
        bsr.b   dibyte     ; ausgeben
        rts                ;
dilangr bsr     diraut     ; # ausgeben
dilangd bsr     didoll     ; $ ausgeben
dilang  swap    d0         ; High-Wort zuerst
        bsr.b   diwort     ; ausgeben
        bsr     dipunk     ; Trenn-Punkt
        swap    d0         ; dann Low-Wort
        bsr.b   diwort     ; ausgeben
        rts                ;
diadd   movem.l d0,-(a7)   ; cr lf $xx.xxxx aus A0.L ausgeben
        move.l  #$0d0a2024,d0 ; cr lf lz $
        bsr     dizei4     ; ausgeben
        move.l  a0,d0      ; D0.L = Adresse
diadd1  swap    d0         ; D0.B = High-Byte
        bsr     dibyte     ; ausgeben
        bsr     dipunk     ; Punkt
        swap    d0         ; D0.W = Low-Wort
        bsr.b   diwort     ; ausgeben
        movem.l (a7)+,d0   ;
        rts                ;
diaddd  movem.l d0,-(a7)   ; $xx.xxxx aus D0.L ausgeben
        bsr     didoll     ; $ausgeben
        bra.b   diadd1     ; xx.xxxx ausgeben
* Binre Ausgabe von Monitor-Version 7.7.97 bernommen
* AUSBIN: Nibble aus D0.B binr ausgeben
ausbin movem.l  d0/d1,-(a7) ; D0 D1 retten
       ror.w    #4,d0      ; B3 hchste Bit zuerst
       moveq    #3,d1      ; Zhler fr 4 Bits
ausbi1 rol.w    #1,d0      ; hchstes Bit zuerst
       andi.b   #1,d0      ; Maske
       bsr      dinibb     ; ausgeben
       dbra     d1,ausbi1  ;
       movem.l  (a7)+,d0/d1 ; D0 D1 zurck
       rts
* AUSBI: Byte binr ausgeben aus D0.B
ausbi  move.l   d0,-(a7)   ; D0 retten
       ror.l    #4,d0      ; High-Nibble
       bsr.b    ausbin     ; binr
       bsr      dipunk     ; Trennpunkt
       rol.l    #4,d0      ; Low-Nibble
       bsr.b    ausbin     ; binr
       move.l   (a7)+,d0   ; D0 zurck
       rts
* AUSWI: Wort binr ausgeben aus D0.W
auswi  move.l   D0,-(a7)    ; D0 retten
       ror.l    #8,d0       ; High-Byte
       bsr.b    ausbi       ; binr
       bsr      dipunk      ; Trennpunkt
       rol.l    #8,d0       ; Low-Byte
       bsr.b    ausbi       ; binr
       move.l   (a7)+,d0    ; D0 zurck
       rts
* AUSREG: CPU-Benutzer-Register ausgeben A0=Anfangsadresse
ausreg move.l   #' D0=',d1  ; D1=Text fr Register
       move.w   #14,d2      ; D2= Zhler fr 15 Register D0-A6
       bsr      dineuz      ; cr lf neue Zeile
ausre1 move.l   d1,d0       ; Registerbezeichnung
       bsr      dizei4      ; ausgeben
       move.l   (a0)+,d0    ; Registerinhalt als
       bsr      dilangd     ; $Doppelwort ausgeben
       bsr      dileer      ; Leerzeichen dahinter
       addi.l   #$00000100,d1 ; neuer Registertext
       cmpi.l   #' D8=',d1    ; D8 = Ende der Datenregister
       bne.b    ausre2      ; nein: weiter
       move.l   #' A0=',d1  ; ja: A0 beginnen
ausre2 cmpi.w   #11,d2      ; Ende der 1.Zeile ?
       beq.b    ausre3      ; ja: neue Zeile
       cmpi.w   #7,d2       ; Ende der 2.Zeile ?
       beq.b    ausre3      ; ja: neue Zeile
       cmpi.w   #3,d2       ; Ende der 3.Zeile ?
       bne.b    ausre4      ; nein: weiter
ausre3 bsr      dineuz      ; neue Zeile
ausre4 dbra     d2,ausre1   ; Schleife fr D0-D7/A0-A6
       move.l   #'SSP=',d0  ; SP=$
       bsr      dizei4      ; ausgeben
       move.l   (a0)+,d0    ; Registerinhalt
       bsr      dilangd     ; als $Doppelwort ausgeben
       bsr      dileer      ; Leerzeichen
       move.l   #'USP=',d0  ; SP=$
       bsr      dizei4      ; ausgeben
       move.l   (a0)+,d0    ; Registerinhalt
       bsr      dilangd     ; als $Doppelwort ausgeben
       bsr      dineuz      ; neue Zeile
       bsr      dileer      ; Leerzeichen
       move.l   #'SR=%',d0  ; SR=
       bsr      dizei4      ; ausgeben
       move.w   12(a0),d0   ; Wort mit SR laden
       lsr.w    #8,d0       ; High-Byte = TTS..III
       bsr      ausbi       ; binr 9 Zeichen ausgeben
       move.w   12(a0),d1   ; D1.W = Wort mit CCR ...XNZVC
       rol.b    #4,d1       ; D1.B = NZVC...X
       bsr      dileer      ; Leerzeichen
       move.b   #'X',d0     ; X-Bit
       bsr      dizei       ;
       move.b   d1,d0       ; D0.B = NZVC...X
       andi.b   #$01,d0     ; D0.B = 0000000X
       addi.b   #'0',d0     ; nach Ziffer 0 oder 1
       bsr      dizei       ; ausgeben
       move.w   #3,d2       ; Schleife fr 4 Bits: NZVC
       move.l   #'NZVC',d3  ; NZVC
ausre5 bsr      dileer      ; Leerzeichen
       rol.l    #8,d3       ; Buchstabe in D3.B
       move.b   d3,d0       ; nach D0.B und
       bsr      dizei       ; ausgeben
       rol.b    #1,d1       ; Bit nach Position B0
       move.b   d1,d0       ; D0.B
       andi.b   #$01,d0     ; Maske 0000 0001
       addi.b   #'0',d0     ; nach Ziffer 0 oder 1
       bsr      dizei       ; und ausgeben
       dbra     d2,ausre5   ; Schleife fr NZVC
       bsr      dileer      ; Leerzeichen
       move.l   #'VBR=',d0  ; VBR=
       bsr      dizei4      ;
       move.l   (a0)+,d0    ; Wert ausgeben
       bsr      dilangd     ; als $Doppelwort
       bsr      dileer      ; Leerzeichen
       move.l   #'SFC=',d0  ; SFC=
       bsr      dizei4      ;
       move.l   (a0)+,d0    ; Wert ausgeben
       bsr      dilangd     ; als $Doppelwort
       bsr      dileer      ; Leerzeichen
       move.l   #'DFC=',d0  ; DFC=
       bsr      dizei4      ;
       move.l   (a0)+,d0    ; Wert ausgeben
       bsr      dilangd     ; als $Doppelwort
       bsr      dineuz      ; neue Zeile cr lf
       bsr      dileer      ; Leerzeichen
       move.l   #'PC=$',d0  ; PC=$
       bsr      dizei4      ;
       addq     #2,a0       ; SR bergehen
       move.l   (a0),d0     ; Wert = Adresse lesen und
       bsr      dilang      ; ausgeben als Doppelwort
       bsr      dileer      ; Leerzeichen
       move.l   #'Code',d0  ; Code
       bsr      dizei4      ;
       move.l   (a0),a0     ; Adresse laden
       move.w   (a0),d0     ; Codewort laden
       bsr      dileer      ;
       bsr      diwortd     ; als $Wort ausgeben
       bsr      dileer      ; Leerzeichen
       bsr      dileer      ; Leerzeichen
       bsr      disasm      ; Disassembler A0 = Zeiger Codewort A0++ !!!!
       rts

       org      ROMbase+$800

* Startprogrammierung des 68332 und Neustart des Monitors
start    move.w  #$1000,TRAMBAR ; TPURAM $10.0000 - $10.07ff
         move.w  #$0000,TRAMMCR ; TPURAM auch fr Benutzer frei

************************** original initialisation *************************

;         move.w  #$00be,CSPAR0  ; CS2:8 CS1:16 CS0:16 CSBOOT:8 bit
;         move.w  #$0000,CSPAR1  ; ECLK PC6 PC5 PC4 PC3  C-Port Ausg.
;         move.w  #$0006,CSBARBT ; CSBOOT ab $00.0000 512 KB
;         move.w  #$7871,CSORBT  ; Asy H+L R+W AS 1WS U+S jede AVEC
;         move.w  #$0806,CSBAR0  ; CS0 ext 16-bit-RAM ab $8.0000 512 KB
;         move.w  #$5871,CSOR0   ; Asy High R+W AS 1WS U+S jede AVEC
;         move.w  #$0806,CSBAR1  ;  CS1 ext 16-bit-RAM ab $8.0000 512 KB
;         move.w  #$3871,CSOR1   ; Asy Low  R+W AS 1Ws U+S jede AVEC
;         move.w  #$ff80,CSBAR2  ; CS2 Peripherie ab $FF.8000 2 KB
;         move.w  #$f870,CSOR2   ; Syn H+L R+W AS 1WS U+S jede nicht AVEC

************************** modified initialisation *************************

        move.w  #$3FFF,CSPAR0   ; CSBOOT..CS5 als Chip Selects
        move.w  #$0055,CSPAR1   ; A19..A22 als Adressen, A23 als E-Takt
        move.w  #$1007,CSBAR0   ; Adresse und Groesse Bereich fuer CS0
        move.w  #$FFC1,CSBAR2   ; Adresse und Groesse Bereich fuer CS2
        move.w  #$FF82,CSBAR3   ; Adresse und Groesse Bereich fuer CS3
        move.w  #$FFE0,CSBAR4   ; Adresse und Groesse Bereich fuer CS4
        move.w  #$FFE8,CSBAR5   ; Adresse und Groesse Bereich fuer CS5
        move.w  #$4007,CSBAR6   ; Adresse und Groesse Bereich fuer CS6
        move.w  #$5007,CSBAR7   ; Adresse und Groesse Bereich fuer CS7
        move.w  #$6007,CSBAR8   ; Adresse und Groesse Bereich fuer CS8
        move.w  #$7007,CSBAR9   ; Adresse und Groesse Bereich fuer CS9
        move.w  #$2007,CSBAR1   ; Adresse und Groesse Bereich fuer CS1
        move.w  #$3007,CSBAR10  ; Adresse und Groesse Bereich fuer CS10
        move.w  #$78F0,CSORBT   ; Zugriffsparameter fuer CSBOOT mit ? WS
        move.w  #$78F0,CSOR0    ; Zugriffsparameter fuer CS0 mit ? WS
        move.w  #$F830,CSOR2    ; Zugriffsparameter fuer CS2 mit ? WS
        move.w  #$78F0,CSOR3    ; Zugriffsparameter fuer CS3 mit ? WS
        move.w  #$7BF0,CSOR4    ; Zugriffsparameter fuer CS4 mit DTACK
        move.w  #$78F0,CSOR5    ; Zugriffsparameter fuer CS5 mit 3 WS
        move.w  #$78F0,CSOR6    ; Zugriffsparameter fuer CS6 mit 3 WS
        move.w  #$78F0,CSOR7    ; Zugriffsparameter fuer CS7 mit 3 WS
        move.w  #$78F0,CSOR8    ; Zugriffsparameter fuer CS8 mit 3 WS
        move.w  #$78F0,CSOR9    ; Zugriffsparameter fuer CS9 mit 3 WS
        move.w  #$78F0,CSOR1    ; Zugriffsparameter fuer CS1 mit 3 WS
        move.w  #$78F0,CSOR10   ; Zugriffsparameter fuer CS10 mit 3 WS

;       SCCR0   $FFFC08 $001B   Baudrate fuer CPU-Schnittstelle 9600 bd
;       SCCR1   $FFFC0A $100C   CPU-Schnittstelle einschalten

****************************************************************************

         move.b  #$0C,SYPCR     ; SWT aus HALT BERR frei 64 Takte
         move.w  #$7f80,SYNCR   ; W=0 X=1 Y=63 16,777 MHz ECLK:16
         move.w  #$404f,SIMCR   ; ECLK S+U $FF.Fxxx IPL=hoch
;         move.w  #$fff8,CSBAR9  ; CS9: Interrupt-Zyklen
;         move.w  #$6801,CSOR9   ; Asy beide R AS 0WS CPU alle AVEC
         move.w  #55,SCCR0      ; Serielle Schnittstelle 9600 Baud
         move.w  #$000c,SCCR1   ; Interrupts aus Sender+Empfnger ein
         movea.l #stapel,a7     ; Stapelzeiger SSP neu anlegen
* Benutzer-Register nach Reset besetzen neu: SSP USP SR PC
         clr.l   $0(a7)         ;
         clr.l   $4(a7)         ;
         clr.l   $8(a7)         ;
         clr.l   $c(a7)         ; Haltepunkt lschen
         movem.l d0-d7/a0-a6,bereg ; alte D- und A-Register bis A6
         move.l  a7,bereg+$3c   ; neu SSP = A7 fr S=1: System
         move.l  a7,bereg+$40   ; neu USP = A7 fr S=0: User
         movec   VBR,a0         ;
         move.l  a0,bereg+$44   ; alt
         movec   SFC,a0         ;
         move.l  a0,bereg+$48   ; alt
         movec   DFC,a0         ;
         move.l  a0,bereg+$4c   ; alt
         move    #$2700,bereg+$50   ; neu SR: T1=0 T0=0 S=1 I=111 Flags=0
         move.l  #$100000,bereg+$52 ; neu PC = $10.0000
         clr.l   bereg+$68      ; Abbruchtyp gelscht wegen C-Kommando
* Kommandoschleife des Monitors
moni   move.l   #'MON>',d0 ; Prompt auf neuer Zeile
       bsr      dizei4n    ; neue Zeile und 4 Zeichen ausgeben
       bsr      einz       ; Kommandozeichen lesen ohne Echo
       andi.b   #$df,d0    ; Maske 1101 1111  klein -> gro
       bsr      dizei      ; Echo immer gro
moni1  cmpi.b   #'N',d0    ; N = Neustart des Monitors ?
       beq     start       ; ja: dann nach Neustart
       cmpi.b   #'W',d0    ; W = Wort ein/ausgeben ?
       bne      next1      ; nein: weiter suchen
* Kommando w oder W: Wort anzeigen und eingeben
w1     bsr      einad      ; Adresse eingeben
       movea.l  d0,a0      ; Anfangsadresse nach A0
w2     bsr      diadd      ; cr lf $laufende Adresse ausgeben
       move.l   #' = %',d0 ; lz = lz %
       bsr      dizei4     ;
       move.w   (a0),d1    ; Wort aus Speicher lesen
       move.w   d1,d0      ;
       bsr      auswi      ; Wort binr ausgeben
       bsr      dileer     ; lz ausgeben
       move.w   d1,d0      ; Wort
       bsr      diwortd    ; und $hexa ausgeben
       move.l   #' ->$',d0 ; Unterkommando anfordern
       bsr      dizei4     ;
       bsr      einze      ; Unterkommando lesen im Echo
       cmpi.b   #13,d0     ; cr = Ende des Kommandos ?
       beq      moni       ; ja: nach Monitorschleife
       cmpi.b   #'+',d0    ; +  = nchstes Wort ?
       bne.b    w3         ;
       addq     #2,a0      ; Adresse + 2
       bra.b    w2         ; ausgeben und weiter
w3     cmpi.b   #' ',d0    ; lz = nchstes Wort ?
       bne.b    w4         ; wie Unterkommando +
       addq     #2,a0      ; Adresse + 2
       bra.b    w2         ; ausgeben
w4     cmpi.b   #'-',d0    ; -  = vorhergehendes Wort ?
       bne.b    w5         ;
       subq     #2,a0      ; Adresse - 2
       bra.b    w2         ; ausgeben
w5     bsr      deko       ; Hexa ?
       bcs      nexte      ; nein: Fehler Kommando abbrechen
       move.b   d0,d1      ; war 1. Hexaziffer
       move.w   #2,d2      ; noch 2+1 = 3 Ziffern
w6     bsr      einni      ; n. Hexazeichen
       bcs      nexte      ; Fehler: Meldung ausgeben
       lsl.l    #4,d1      ; 4 bit links
       or.b     d0,d1      ; n. Hexaziffer
       dbra     d2,w6      ; Schleife fr 3 Hexazeichen
       move.w   d1,(a0)+   ; Wort speichern
       bra.b    w2         ; nchste Adresse
next1  cmpi.b   #'B',d0    ; B fr Byteausgabe ?
       bne      next2      ; nein: nchste Kommando testen
* Kommando b oder B: Byte anzeigen und eingeben
b1     bsr      einad      ; Adresse eingeben
       movea.l  d0,a0      ; Anfangsadresse nach A0
b2     bsr      diadd      ; laufende Adresse ausgeben
       move.l   #' = %',d0 ; lz = lz %
       bsr      dizei4     ;
       move.b   (a0),d1    ; Byte aus Speicher lesen
       move.b   d1,d0      ;
       bsr      ausbi      ; und binr ausgeben
       bsr      dileer     ; Leerzeichen
       move.b   d1,d0      ; Byte 
       bsr      dibyted    ; und $hexa ausgeben
       move.l   #' ->$',d0 ; Unterkommando anfordern
       bsr      dizei4     ;
       bsr      einze      ; Unterkommando lesen im Echo
       cmpi.b   #13,d0     ; cr = Ende des Kommandos ?
       beq      moni       ; ja: nach Monitorschleife
       cmpi.b   #'+',d0    ; +  = nchstes Byte ?
       bne.b    b3         ;
       addq     #1,a0      ; Adresse + 1
       bra.b    b2         ; ausgeben
b3     cmpi.b   #' ',d0    ; lz = nur Anzeigen ?
       bne.b    b4         ; Adresse bleibt
       bra.b    b2         ; ausgeben
b4     cmpi.b   #'-',d0    ; -  = vorhergehendes Wort ?
       bne.b    b5         ;
       subq     #1,a0      ; Adresse - 1
       bra.b    b2         ; ausgeben
b5     bsr      deko       ; Hexa ?
       bcs      nexte      ; nein: Fehler
       move.b   d0,d1      ; war 1. Hexaziffer 
       bsr      einni      ; 2. Hexazeichen
       bcs      nexte      ; Fehler: Meldung ausgeben
       lsl.w    #4,d1      ; 4 bit links
       or.b     d0,d1      ; 2. Hexaziffer
       move.b   d1,(a0)    ; Wort speichern Adresse bleibt !!!!!
       bra.b    b2         ; gleiche Adresse
next2  cmpi.b   #'A',d0    ; A fr ausfhren ?
       bne      next3      ; nein: nchstes Kommando testen
* Kommando a oder A: Programm ausfhren ohne Testhilfe
au1    bsr      einad      ; Adresse eingeben
       movea.l  d0,a0      ; Anfangsadresse nach A0
       jsr      (a0)       ; Ausfhren als Unterprogramm
       bra      start      ; bei Rckkehr mit RTS weiter Neustart
next3  cmpi.b   #'D',d0    ; D fr Dump
       bne      next4      ; nein: nchstes Kommando
* Kommando d oder D: 256 Bytes Speicher ausgeben
du1    bsr      einad      ; Adresse eingeben
       andi.l   #$fffff0,d0 ; Maske xxxxxxxx0000 
       movea.l  d0,a0      ; Anfangsadresse nach A0
du2    bsr      dineuz     ; neue Zeile
       moveq    #9,d1      ; 10 Leerzeichen
du3    bsr      dileer     ; Leerzeichen
       dbra     d1,du3     ;
       moveq    #15,d1     ; 16 berschriften
       clr.b    d2         ; Ziffern
du4    move.b   #'_',d0    ; Unterstrich
       bsr      dizei      ; ausgeben
       move.b   d2,d0      ; Ziffer
       bsr      dinibb     ;
       addq     #1,d2      ; nchste Ziffer
       bsr      dileer     ; Leerzeichen
       dbra     d1,du4     ;
       moveq    #15,d1     ; 16 Ziffern
       clr.b    d0         ; 
du5    bsr      dinibb     ; Ziffer ausgeben
       addq     #1,d0      ; nchste Ziffer
       dbra     d1,du5     ;
       moveq    #15,d1     ; 16 Zeilen
du6    bsr      diadd      ; neue Zeile und Adresse
       moveq    #15,d2     ; 16 Bytes
       move.l   a0,-(a7)   ; Anfangsadresse retten
du7    bsr      dileer     ; Leerzeichen
       move.b   (a0)+,d0   ; Byte laden
       bsr      dibyte     ; und ausgeben
       dbra     d2,du7     ;
       movea.l  (a7)+,a0   ; Anfangsadresse zurck
       moveq    #15,d2     ; 16 Zeichen
       bsr      dileer     ; Leerzeichen
du8    move.b   (a0)+,d0   ; Byte laden
       cmpi.b   #' ',d0    ; Steuerzeichen ?
       bhs.b    du9        ; nein
       move.b   #'.',d0    ; ja: durch Punkt ersetzt
du9    bsr      dizei      ; Zeichen ausgeben
       dbra     d2,du8     ;
       dbra     d1,du6     ; Zeilenzhler
       move.l   #' -->',d0 ; Prompt
       bsr      dizei4n    ; neue Zeile 
       bsr      einze      ; Unterkommando
       cmpi.b   #' ',d0    ; Leerzeichen ? als Fortsetzung
       beq      du2        ; ja: nchsten Block
       bra      moni       ; nein: Abbruch
next4  cmpi.b   #'E',d0    ; E fr empfangen .BIN-File
       bne      next5      ; nein: nchstes Kommando
* Kommando e oder E: Datei empfangen und speichern Ende: 16*$FF
em1    bsr      einad      ; Ladeadresse anfordern
       movea.l  d0,a0      ; nach A0
       clr.b    d1         ; D1: Zhler $FF
       clr.b    d2         ; D2: Zhler fr Echo
em2    bsr      einz       ; Byte lesen ohne Echo
       move.b   d0,(a0)+   ; und speichern
       addq.b   #8,d2      ; Echozhler +8
       cmpi.b   #$ff,d0    ; Endemarke ?
       bne.b    em3        ; nein
       addq.b   #1,d1      ; ja: zhlen
       bra.b    em4        ; weiter
em3    clr.b    d1         ; nein: Zhler lschen
em4    tst.b    d2         ; Echozhler durchgelaufen?
       bne.b    em5        ; nein
       move.b   #'*',d0    ; Zeichen *
       bsr      dizei      ; als Echo ausgeben
em5    cmpi.b   #16,d1     ; schon 16 * $FF ?
       bne.b    em2        ; nein: weiter
       move.l   #'ENDE',d0 ; ja: ENDE ausgeben
       bsr      dizei4n    ; auf neuer Zeile
       bra      moni       ; 
next5  cmpi.b   #'F',d0    ; F fllen Bereich
       bne      next6      ; nein: weiter
* Kommando F oder f: Bereich mit Langwort fllen mit Kontrolle
fi1    move.l   #' Anf',d0 ; Anfangsadresse
       bsr      dizei4     ;
       bsr      einad      ; lesen nach D0.L
       movea.l  d0,a0      ; A0 = Anfangsadresse
       move.l   #' End',d0 ; Endadresse
       bsr      dizei4     ;
       bsr      einad      ; lesen nach D0.L
       movea.l  d0,a1      ; A1 = Endadresse
       bsr      einzm      ; Meldung Prompt Wert lesen
       move.l   d0,d1      ; D1.L = Langwort
fi2    cmpa.l   a1,a0      ; laufende - letzte Adresse
       bhi      moni       ; A0 > A1: fertig
       move.l   d1,(a0)    ; Wert speichern
       cmp.l    (a0),d1    ; und vergleichen
       bne.b    fi4        ; ungleich: Fehlermeldung
fi3    addq.l   #4,a0      ; laufende Adresse + 4
       bra.b    fi2        ; neuer Durchlauf
fi4    bsr      diadd      ; neue Zeile laufende Adresse
       move.l   #' ERR',d0 ; Fehlermeldung
       bsr      dizei4     ;
       move.l   #'OR $',d0 ;
       bsr      dizei4     ;
       move.l   (a0),d0    ; altes Langwort im Speicher 
       bsr      dilang     ; ausgeben
       bra.b    fi3        ; neue Adresse
next6  cmpi.b   #'S',d0    ; S: Satz S-File .HEX laden
       bne      next7      ; nein: weiter
* Kommando s oder S: Satz aus Datei .HEX laden nur S als Echo
* ohne Echo: einz fr einze  einno fr einni
sp1    bsr      einz       ; Folgezeichen mit Typ
       move.b   #0,d4      ; D4.B = 0: Marke kein Ende
       cmpi.b   #'1',d0    ; S1 ?
       bne.b    sp2        ; nein:
       moveq    #2,d1      ; ja: 2-byte-Adresse D1 = 2
       bra.b    sp4        ;
sp2    cmpi.b   #'2',d0    ; S2 ?
       bne.b    sp3        ; nein:
       moveq    #3,d1      ; ja: 3-byte-Adresse D1 = 3
       bra.b    sp4        ;
sp3    cmpi.b   #'3',d0    ; S3 ?
       bne.b    sp3a       ; nein: Endesatz?
       moveq    #4,d1      ; ja: 4-byte-Adresse D1 = 4
       bra.b     sp4        ;
sp3a   move.b   #$ff,d4    ; D4.B = -1: Marke Endesatz
       cmpi.b   #'7',d0    ; S7 - Endesatz ?
       bne.b    sp3b       ; nein
       moveq    #4,d1      ; ja: 4-byte-Startadresse D1 = 4
       bra.b    sp4        ;
sp3b   cmpi.b   #'8',d0    ; S8 - Endesatz ?
       bne.b    sp3c       ; nein:
       moveq    #3,d1      ; ja: 3-byte-Startadresse D1 = 3
       bra.b    sp4        ;
sp3c   cmpi.b   #'9',d0    ; S9 - Endesatz ?
       bne.b    sp8        ; kein Endesatz: berlesen
       moveq    #2,d1      ; ja: 2-byte-Startadresse D1 = 2
* Satzlnge lesen nach D2
sp4    clr.l    d2         ; Lnge lschen
       bsr      einno      ; High-Nibble lesen
       bcs      sp8        ; Lesefehler
       move.b   d0,d2      ; nach Lnge
       bsr      einno      ; Low-Nibble lesen
       bcs      sp8        ; Lesefehler
       lsl.b    #4,d2      ; High verschieben
       or.b     d0,d2      ; D2 = Gesamtlnge in Bytes
       sub.l    d1,d2      ; D2 = D2 - D1: Datenbytes + CRC
* Adresse lesen D1 = Zahl der Adrebytes
       lsl.l    #1,d1      ; * 2 = Nibbles
       subq     #1,d1      ; -1 = Nibblezhler fr DBRA-Befehl
       clr.l    d3         ; Adresswert lschen
sp5    bsr      einz       ; Nibble lesen
       bsr      deko       ; und dekodieren
       bcs.b    sp8        ; Lesefehler
       lsl.l    #4,d3      ; alten Wert nach links
       or.b     d0,d3      ; neues Nibble dazu
       dbra     d1,sp5     ; 
       cmpi.b   #$ff,d4    ; Endesatz ?
       beq.b    sp10       ; ja: D3.L = Adresse
       movea.l  d3,a0      ; A0 = Ladeadresse
* Daten lesen und speichern
       subq     #2,d2      ; D2 = Ladezhler ( - CRC)
sp6    clr.l    d3         ; D3 = Byte
       bsr      einno      ; High-Nibble lesen und dekodieren
       bcs      sp8        ; Lesefehler
       move.b   d0,d3      ; Nibble nach Byte
       bsr      einno      ; Low-Nibble lesen und dekodieren
       bcs.b    sp8        ; Lesefehler
       lsl.b    #4,d3      ; altes Nibble nach links
       or.b     d0,d3      ; neues dazu
       move.b   d3,(a0)    ; Byte speichern
       cmp.b    (a0),d3    ; und vergleichen
       bne.b    sp9        ; ungleich: Ladefehler
sp7    addq.l   #1,a0      ; nchste Byteadresse
       dbra     d2,sp6     ; Schleife
* Rest berlesen bis $0D
sp8    bsr      einz       ; Zeichen lesen
       cmpi.b   #$0D,d0    ; CR ?
       bne.b    sp8        ; nein
       bsr      einz       ; LF berlesen
       bsr      einze      ; neues S oder s ? mit  ECHO
       cmpi.b   #'S',d0    ;
       beq      sp1        ; ja:
       cmpi.b   #'s',d0    ;
       beq      sp1        ; ja: 
       bsr      ausz       ; nein: Echo ausgeben
       bra      moni       ; neue Eingabe 
* Ladefehler
sp9    bsr      diadd      ; Adresse ausgeben
       move.l   #' ERR',d0 ;
       bsr      dizei4     ;
       move.l   #'OR $',d0 ;
       bsr      dizei4     ;
       move.b   (a0),d0    ; Inhalt laden
       bsr      dibyte     ; und hexa ausgeben
       bra      sp7        ; weiter laden
* Endesatz  S7:4-byte  S8:3-byte  S9:2-byte-Adressen
sp10   tst.l    d3         ; Startadresse bergeben ?
       beq.b    sp11         ; Null: keine
       move.l   d3,bereg+$52 ;   ja: nach PC speichern
sp11   bsr      einz       ; Rest mit CRC berlesen
       cmpi.b   #$0D,d0    ; CR ?
       bne.b    sp11       ; nein
       bsr      einz       ; LF berlesen
       move.l   #'ENDE',d0 ; Endemeldung
       bsr      dizei4n    ; cr lf ENDE
       tst.l    d3         ; Startadresse ?
       beq      sp12       ; Null: keine
       move.l   #' STA',d0 ;
       bsr      dizei4     ;
       move.l   #'RT:$',d0 ;
       bsr      dizei4     ;
       move.l   d3,d0      ;
       bsr      dilang     ;
sp12   bra      moni       ;  
next7  cmpi.b   #'L',d0    ; L = Langwort ein/ausgeben ?
       bne      next8      ; nein: weiter suchen 
* Kommando l oder L: Langwort anzeigen und eingeben
l1     bsr      einad      ; Adresse eingeben
       movea.l  d0,a0      ; Anfangsadresse nach A0
l2     bsr      diadd      ; laufende Adresse ausgeben
       move.b   #-1,d3     ; D3.B !0: Marke Langwortkommando
l2a    move.l   #' = $',d0 ; Einsprung Register-Ein-/Ausgabe
       bsr      dizei4     ;
       move.l   (a0),d0    ; Langwort aus Speicher lesen
       bsr      dilang     ; mit Trennpunkt hexa ausgeben
       move.l   #' ->$',d0 ; Unterkommando anfordern
       bsr      dizei4     ;
       bsr      einze      ; Unterkommando lesen im Echo
       cmpi.b   #13,d0     ; cr = Ende des Kommandos ?
       beq      moni       ; ja: nach Monitorschleife
       tst.b    d3         ; L oder Register ?
       beq.b    l5         ; D3.B = 0: Register eingeben
       cmpi.b   #'+',d0    ; +  = nchstes Langwort ?
       bne.b    l3         ;
       addq     #4,a0      ; Adresse + 4
       bra.b    l2         ; ausgeben
l3     cmpi.b   #' ',d0    ; lz = nchstes Langwort ?
       bne.b    l4         ; wie Unterkommando +
       addq     #4,a0      ; Adresse + 4
       bra.b    l2         ; ausgeben
l4     cmpi.b   #'-',d0    ; -  = vorhergehendes Langwort ?
       bne.b    l5         ;
       subq     #4,a0      ; Adresse - 4
       bra.b    l2         ; ausgeben
l5     bsr      deko       ; Hexa ?
       bcs      nexte      ; nein: Fehler Kommando abbrechen
       move.b   d0,d1      ; war 1. Hexaziffer
       move.w   #6,d2      ; noch 6+1 = 7 Ziffern
l6     bsr      einni      ; n. Hexazeichen
       bcs      nexte      ; Fehler: Meldung ausgeben
       lsl.l    #4,d1      ; 4 bit links
       or.b     d0,d1      ; n. Hexaziffer
       dbra     d2,l6      ; Schleife fr 7 Hexazeichen
       move.l   d1,(a0)+   ; Langwort speichern
       tst.b    d3         ; D3.B = 0: Registereingabe ?
       beq      moni       ; ja: fertig 
       bra.b    l2         ; nein: nchste Adresse
next8  cmpi.b   #'R',d0    ; R = Register ein/ausgeben ?
       bne      next9      ; nein: weiter suchen
* r oder R: Register der CPU nur anzeigen und ndern 
r1     movea.l  #bereg,a0  ; A0 = Adresse der Register D0...A7 
       bsr      einz       ; D0.B = Zeichen ohne Echo fr Unterkommando  
       andi.b   #$df,d0    ; %1101 1111 Maske klein -> gro
       cmpi.b   #'A',d0    ; A-Register ?
       bne.b    r2         ; nein: 
       adda.l   #32,a0     ; A0 adressiert
       bra.b    r3         ; weiter wie D-Register
r2     cmpi.b   #'D',d0    ; D-Register ?
       bne.b    r4         ; nein: alle Register ausgeben
r3     bsr      dizei      ; A oder D als Echo ausgeben
       bsr      einz       ; D0.B = Register-Nr. 0..7 ohne Echo
       cmpi.b   #'0',d0    ; kleiner 0 ?
       blo.b    r4         ; ja: alle Register
       cmpi.b   #'7',d0    ; grer 7 ?
       bhi.b    r4         ; ja: alle Register
       bsr      dizei      ; nein: 0..7 als Echo
       subi.b   #'0',d0    ; decodieren
       extb.l   d0         ; nach Langwort ausdehnen
       lsl.l    #2,d0      ; *4 wegen Langwort
       adda.l   d0,a0      ; A0 = Registeradresse
       clr.b    d3         ; D3.B = $00: Marke fr Registerausgabe
       bra      l2a        ; Langwort Ein-/Ausgabe
r4     bsr      ausreg     ;
       bra      moni       ; keine nderung 
next9  cmpi.b   #'G',d0    ; G = Gehe mit Testhilfen
       bne      next10     ; nein: weiter suchen                
* g oder G: Gehe (starte) mit Testhilfen und RTE
g1     bsr      einad      ; Startadresse nach D0.L
       tst.l    d0         ; nur cr oder Wert 0 ?
       beq.b    g2         ; ja: alten PC nehmen
       move.l   d0,bereg+$52     ; PC = neue Startadresse
g2     andi.w   #$3fff,bereg+$50 ; SR = T1=0 T0=0 kein Trace
       move.l   bereg-4,d0       ; Haltepunkt gesetzt?
       beq.b    g3               ; nein:
       cmp.l    bereg+$52,d0     ; ja: Haltepunkt = PC ?
       beq.b    g3               ; ja: nicht starten
       move.l   d0,a0            ; nein: Code ersetzen
       move.w   (a0),d0          ; alten Code
       move.w   d0,bereg-6       ; retten
       move.w   #$4afc,(a0)      ; ILLEGAL einsetzen
g3     clr.w    bereg+$56        ; Stapeltyp $0
       move.l   bereg+$40,a0     ; USP = A7 fr S=0: User
       move     a0,USP           ; Benutzer-Stapelzeiger
       move.l   bereg+$44,a0     ;
       movec    a0,VBR           ; Vektorbasisregister
       move.l   bereg+$48,a0     ;
       movec    a0,SFC           ; Source Function Code
       move.l   bereg+$4c,a0     ;
       movec    a0,DFC           ; Destination Function Code
       movem.l  bereg,d0-d7/a0-a7 ; alle D- und A-Register
       move.w   bereg+$56,-(a7)  ; Stapeltyp auf Stapel
       move.l   bereg+$52,-(a7)  ; PC auf Stapel
       move.w   bereg+$50,-(a7)  ; SR auf Stapel
       rte                 ; SR, PC und Stapeltyp vom Stapel
next10 cmpi.b   #'C',d0    ; C = Continue mit Testhilfen
       bne      next11     ; nein: weiter suchen                
* c oder C: Continue bei PC mit Testhilfen und RTE
c1     cmpi.l   #'CERR',bereg+$68 ; Abbruch mit CERR ?
       bne.b    c2               ; nein: weiter
       move.l   #'on?>',d0       ; ja: Frage
       bsr      dizei4           ;
       bsr      einz             ; Antwort lesen
       cmpi.b   #13,d0           ; cr = ja
       bne.b    c2               ; nein: weiter
       addq.l   #2,bereg+$52     ; ja: PC + 2
c2     bra.b    g3         ; wie G SR bleibt (T-Bits)
next11 cmpi.b   #'T',d0    ; T = Trace jeden Befehl
       bne      next12     ; nein: weiter suchen                
* t oder T: Trace jeden Befehl mit Testhilfen und RTE
t1     bsr      einad      ; Startadresse nach D0.L
       tst.l    d0         ; nur cr oder Wert 0 ?
       beq.b    t2         ; ja: alten PC nehmen
       move.l   d0,bereg+$52     ; PC = neue Startadresse
t2     andi.w   #$3fff,bereg+$50 ; SR = %0011 fff T1=0 T0=0
       ori.w    #$8000,bereg+$50 ; SR = $1000 T1 = 1
       bra      g3         ; nein: weiter mit G0
next12 cmpi.b   #'V',d0    ; V = Verfolge Sprnge
       bne      next13     ; nein: weiter suchen                
* v oder V: Verfolge (Trace) Sprnge Testhilfen und RTE
v1     bsr      einad      ; Startadresse nach D0.L
       tst.l    d0         ; nur cr oder Wert 0 ?
       beq.b    v2         ; ja: alten PC nehmen
       move.l   d0,bereg+$52     ; PC = neue Startadresse
v2     andi.w   #$3fff,bereg+$50 ; SR = %0011 fff T1=0 T0=0
       ori.w    #$4000,bereg+$50 ; SR = $0100 T0 = 1
       bra      g3
next13 cmpi.b   #'H',d0    ; H = Haltepunkt verwalten
       bne      next14     ; nein: weiter suchen                
* h oder H: Haltepunkt verwalten
h1     bsr      dileer     ; Leerzeichen
       move.l   bereg-4,d1 ; Haltepunktadresse
       beq      h2         ; Null: nicht gesetzt
       move.l   #'Adr.',d0 ;
       bsr      dizei4     ;
       move.l   d1,d0      ; Adr$1234.5678
       bsr      diaddd     ; $adresse
       bsr      dileer     ; Leerzeichen
       move.l   #'Cod.',d0 ; Cod$1234
       bsr      dizei4     ;
       move.l   d1,a0      ; Adresse
       move.w   (a0),d0    ; Codewort
       bsr      diwortd    ; $wort
       bsr      dileer     ; lz
       bsr      disasm     ; Befehl
       bra.b    h3         ; Nach Eingabe
h2     move.l   #'kein',d0 ;
       bsr      dizei4     ;
h3     bsr      dileer     ; Leerzeichen
       move.l   #'Neu>',d0 ;
       bsr      dizei4n    ;
       bsr      einad      ; D0.L = neue Haltepunktadresse
       bclr     #0,d0      ; mache ganzzahlig (Adrefehler!)
       move.l   d0,bereg-4 ; speichern
       beq.b    h4         ; bei Null: kein Haltepunkt
       bsr      dileer     ; lz
       move.l   #'Cod.',d0 ;
       bsr      dizei4     ;
       move.l   bereg-4,a0 ; Adresse lesen
       move.w   (a0),d0    ; Code lesen
       move.w   d0,bereg-6 ; speichern
       bsr      diwortd    ; und $Wort ausgeben
       bsr      dileer     ; lz
       bsr      disasm     ; Befehl
h4     bra      moni       ;
next14 cmpi.b   #'K',d0    ; k = Kopiere Speicher
       bne      next15     ; nein: weiter
* Kommando K oder k: Speicher kopieren
k1     move.l   #' von',d0 ;
       bsr      dizei4     ;
       bsr      einad      ; Anfangsadresse
       movea.l  d0,a0      ; A0 = Anfangsadresse
       move.l   #' bis',d0 ;    = laufende Adresse
       bsr      dizei4     ;
       bsr      einad      ; Endadresse
       movea.l  d0,a1      ; A1 = Endadressse
       move.l   #'nach',d0 ;
       bsr      dizei4     ;
       bsr      einad      ; Zieladresse
       movea.l  d0,a2      ; A2 = Zieladresse
k2     cmpa.l   a0,a1      ; A1:Ende - A0:Lauf
       blo.b    k3         ;  Ende <  Lauf: fertig
       move.b   (a0)+,(a2)+ ; Ende >= Lauf: kopieren
       bra.b    k2         ; weiter
k3     bra      moni       ; fertig
next15 cmpi.b   #'U',d0    ;  u = Unassemble = disassemblieren
       bne      next16     ; nein: weiter
* u oder U: Disassemblieren 
u1      bsr     einad      ; ADR$ D0.L = Adresse lesen
        movea.l d0,a0      ; A0= Anfang Programmcode
u2      bsr     diadd      ; neue Zeile Adresse aus A0 ausgeben
        move.w  #'  ',d0   ; Abstand
        bsr     dizei2     ; ausgeben
        bsr     disasm     ; gibt Befehl aus (A0)++
        bsr     einz       ; D0.B: Taste ohne Echo
        cmpi.b  #13,d0     ; cr = Abbruch ?
        bne.b   u2         ; nein: weiter
        bra     moni       ; ja: Monitor
next16  nop                ; weitere Kommando hier anbauen
* Fehlermeldung ausgeben und Monitor-Hauptschleife
nexte  move.l   #' Kom',d0 ; Fehlermeldung       
       bsr      dizei4     ; ausgeben
       move.l   #'mand',d0 ;
       bsr      dizei4     ; Kommando ?
       move.l   #'o ??',d0 ;
       bsr      dizei4     ;
       bra      moni       ; neuer Prompt
*
* Ausnahme - Programme
berr   move.l   #'BERR',bereg+$68  ; Meldung
       bra      excep    ; #2  $08 Typ $c Busfehler
aerr   move.l   #'AERR',bereg+$68  ; Meldung
       bra      excep    ; #3  $0c Typ $c Adrefehler
cerr   move.l   #'CERR',bereg+$68  ; Meldung
       bra      excep    ; #4  $10 Typ $0 Codefehler ILLEGAL
derr   move.l   #'DERR',bereg+$68  ; Meldung
       bra      excep    ; #5  $14 Typ $2 Divisionsfehler /0
chkx   move.l   #'CHK ',bereg+$68  ; Meldung
       bra      excep    ; #6  $18 Typ $2 Befehle CHK und CHK2
trpx   move.l   #'TRPx',bereg+$68  ; Meldung
       bra      excep    ; #7  $1c Typ $2 Befehle TRAPcc und TRAPV
perr   move.l   #'PERR',bereg+$68  ; Meldung
       bra      excep    ; #8  $20 Typ $0 Privilegfehler
trac   move.l   #'TRAC',bereg+$68  ; Meldung
       bra      excep    ; #9  $24 Typ $2 TRACE T-Bits
eaxx   move.l   #'Axxx',bereg+$68  ; Meldung
       bra      excep    ; #10 $28 Typ $0 Emulator $Axxx-Code
efxx   move.l   #'Fxxx',bereg+$68  ; Meldung
       bra      excep    ; #11 $2c Typ $0 Emulator $Fxxx-Code
bkpt   move.l   #'BKPT',bereg+$68  ; Meldung
       bra      excep    ; #12 $30 Typ $2 Hardware-Breakpoint
ferr   move.l   #'FERR',bereg+$68  ; Meldung
       bra      excep    ; #14 $38 Typ $0 Formatfehler bei RTE
inot   move.l   #'NINT',bereg+$68  ; Meldung
       bra      excep    ; #15 $3c Typ $0 Interrupt nicht init
ierr   move.l   #'IERR',bereg+$68  ; Meldung
       bra      excep    ; #24 $60 Typ $0 Interruptfehler (falscher)
int1   move.l   #'INT1',bereg+$68  ; Meldung
       bra      excep    ; #25 $64 Typ $0 Eigenvektor Ebene 1
int2   move.l   #'INT2',bereg+$68  ; Meldung
       bra      excep    ; #26 $68 Typ $0 Eigenvektor Ebene 2
int3   move.l   #'INT3',bereg+$68  ; Meldung
       bra      excep    ; #27 $6c Typ $0 Eigenvektor Ebene 3
int4   move.l   #'INT4',bereg+$68  ; Meldung
       bra      excep    ; #28 $70 Typ $0 Eigenvektor Ebene 4
int5   move.l   #'INT5',bereg+$68  ; Meldung
       bra      excep    ; #29 $74 Typ $0 Eigenvektor Ebene 5
int6   move.l   #'INT6',bereg+$68  ; Meldung
       bra      excep    ; #30 $78 Typ $0 Eigenvektor Ebene 6
int7   move.l   #'INT7',bereg+$68 ; Meldung
       bra      excep    ; #31 $7c Typ $0 Eigenvektor Ebene 7 NMI
* alle besetzen Ausnahme werden hier behandelt:
excep    movem.l d0-d7/a0-a6,bereg ; D- und A- bis A6 nicht SSP
         move    USP,a0         ; Benutzer-Stapelzeiger
         move.l  a0,bereg+$40   ; USP = A7 fr S=0: User
         movec   VBR,a0         ; Vektorbasisregister
         move.l  a0,bereg+$44   ;
         movec   SFC,a0         ; Source Function Code
         move.l  a0,bereg+$48   ;
         movec   DFC,a0         ; Destination Function Code
         move.l  a0,bereg+$4c   ; 
         move.w  (a7)+,bereg+$50 ; Statusregister
         move.l  (a7)+,bereg+$52 ; Befehlszhler PC 
         move.w  (a7)+,d0       ; Stapelcodewort
         move.w  d0,bereg+$56   ; retten
         andi.w  #$f000,d0      ; Maske 1111 0 0 0 Ausnahmecode 
         cmpi.w  #$0000,d0      ; Typ $0 ?
         beq     excep1          ; ja: keine weiteren Langwrter
         move.l  (a7)+,bereg+$58 ; Langwort Fehleradresse
         cmpi.w  #$2000,d0       ; Typ $2 ?
         beq     excep1          ; ja: keine weiteren Wrter
         move.l  (a7)+,bereg+$5c ; nein: noch 3 Langwrter
         move.l  (a7)+,bereg+$60 ;
         move.l  (a7)+,bereg+$64 ;
excep1   move.l  a7,bereg+$3c ; korrigiertes A7 = SSP
         move.l  bereg+$68,d0 ; Meldung Ausnahmetyp
         cmpi.l  #'CERR',d0   ; war es der Haltepunkt?
         bne     excep2       ; nein
         move.l  bereg-4,d1   ; Haltepunktadresse
         cmp.l   bereg+$52,d1 ; = Befehlszhler PC ?
         bne     excep2       ; nein: ungleich
         move.l  d1,a0        ; ja: Code testen
         cmpi.w  #$4afc,(a0)  ; ILLEGAL ?
         bne     excep2       ; nein: ungleich
         move.w  bereg-6,d1   ; ja: alten Code
         move.w  d1,(a0)      ; wiederherstellen
         move.l  #'HALT',bereg+$68 ; als Marke fr C-Kommando
         move.l  #'HALT',d0        ; fr Ausgabe
excep2   bsr     dineuz     ; neue Zeile
         bsr     dizei4     ; neue Zeile und Zeichen D0.L
         bsr     dileer     ; Leerzeichen
         move.l  #'Ausn',d0 ; 
         bsr     dizei4     ;
         move.l  #'ahme',d0 ;
         bsr     dizei4     ;
         move.l  #' Typ',d0 ;  Typ
         bsr     dizei4     ;
         bsr     dileer     ;
         move.w  bereg+$56,d0 ; Code und Abstand
         bsr     diwortd      ; ausgeben
         move.w  bereg+$56,d1 ;
         andi.w  #$f000,d1 ; Maske %1111 $000
         cmpi.w  #$0000,d1 ; Ausnahme-Stapeltyp Typ $0?
         beq     excep3    ; ja: keine weiteren Wrter
         bsr     dileer    ; nein: Leerzeichen
         move.l  #'Adr.',d0 ;
         bsr     dizei4     ;
         move.l  bereg+$58,d0 ; Fehleradresse
         bsr     dilangd   ;  $Langwort ausgeben
         cmpi.w  #$2000,d1 ; Typ $2?
         beq     excep3    ; ja: keine weiteren Langwrter
         bsr     dileer    ; Leerzeichen
         move.l  bereg+$5c,d0 ; Langwort
         bsr     dilangd   ; $lang ausgeben
         bsr     dileer    ; Leerzeichen
         move.l  bereg+$60,d0 ; Langwort
         bsr     dilangd   ; $lang ausgeben
         bsr     dileer    ; Leerzeichen
         move.l  bereg+$64,d0 ; Langwort
         bsr     dilangd   ; $lang ausgeben
excep3   movea.l #bereg,a0 ; Benutzer-Register
         bsr     ausreg    ; ausgeben 
         bra     moni      ; Monitorhauptschleife
* alle reservierten Ausnahmen #13  #16-#23  #48-#63
resx   move.w   (a7)+,d1   ; Statusregister vom Stapel
       move.l   (a7)+,d2   ; Befehlszhler vom Stapel
       move.w   (a7)+,d3   ; Typ und Vektor-Offset
       movea.l  #stapel,a7 ; A7 = Stapelzeiger neu anlegen
       move.l   #'SR=$',d0 ; Meldung SR=$
       bsr      dizei4n    ; auf neuer Zeile ausgeben
       move.w   d1,d0      ; Statusregister
       bsr      diwort     ; als Wort
       bsr      dileer     ; Leerzeichen
       move.l   #'PC=$',d0 ; Meldung PC=$
       bsr      dizei4     ; dahinter
       move.l   d2,d0      ; Befehlszhler             
       bsr      dilang     ; als Langwort
       bsr      dileer     ; Leerzeichen
       move.l   #'TYP:',d0 ; Meldung TYP:
       bsr      dizei4     ; dahinter
       move.w   d3,d0      ; Typ und Vektoroffset
       bsr      diwortd    ; als Wort
       bra      start      ; Neustart des Monitors
* Trap-Befehle fr Ein-/Ausgabe mit Monitorunterprogrammen
trap0  bsr      dizei      ; Zeichen aus D0.B ausgeben
       rte                 ;
trap1  bsr      dizei4n    ; cr lf 4 Zeichen aus D0.L ausgeben
       rte                 ; D0.L = 0: A0 = Textadresse bis $00
trap2  bsr      dizei4     ; 4 Zeichen aus D0.L ausgeben
       rte                 ; D0.L = 0: A0 = Testadresse bis $00
trap3  bsr      dibyted    ; Byte $hexa aus D0.B ausgeben
       rte                 ;
trap4  bsr      diwortd    ; Wort $hexa aus D0.W ausgeben
       rte                 ;
trap5  bsr      dilangd    ; Langwort $hexa aus D0.L ausgeben
       rte                 ;
trap6  bsr      diadd      ; cr lf $ Adresse xx.xxxx aus A0 ausgeben
       rte                 ;
trap7  bsr      didezi     ; D0.L dezimal ausgeben (ohne fhrende 0)
       rte                 ;
trap8  bsr      einz       ; Zeichen nach D0.B ohne Echo 
       rte                 ;
trap9  bsr      einze      ; Zeichen nach D0.B mit Echo
       rte                 ;
trap10 bsr      einad      ; ADR$ Adresse nach D0.L
       rte                 ;
trap11 bsr      einza      ; Eingabe + - $ Zahl nach D0.L
       rte                 ;
trap12 bsr      tra12      ; Funktionen System-Timer
       rte                 ;
trap13 bsr      tra13      ; Funktionen serieller Bus QSM
       rte                 ;
trap14 bsr      tra14      ; Funktionen TPU 
       rte                 ;
trap15 move.l   #'EXIT',bereg+$68 ; Ausnahmetyp
       bra      excep      ; Rcksprung nach Monitor
* Unterprogramm Disassembler
* A0 = Zeiger auf Code; A0++ Zeiger auf nchsten Code
disasm  lea     tab(PC),a1 ; A1 = Zeiger auf Tabelle 
dia1    move.w  (a1)+,d0   ; Maske oder Endemarke
        beq.b   diaerr     ; Endemarke: Code nicht gefunden
        and.w   (a0),d0    ; Maske UND Code
        cmp.w   (a1)+,d0   ; in Tabelle ?
        beq.b   dia2       ; ja: gefunden
dia1a   adda.l  #16,a1     ; nein: neuen Code versuchen    
        bra.b   dia1       ; bis Endemarke
* Code prfen   Befehl ausgeben  Sprung Operandenausgabe
dia2    move.w  (a0),d1    ; D1.W = Codewort laden                   
        move.l  (a1),d0    ; D0.L = zul. Adressierungsarten
        bmi.b   dia3a      ; Bit #31=1: Sonderfall: kein Text ausgeben
dia2a   beq.b   dia3       ; Bit #31=0: zul. Typ = 0: nur Befehlstext ausgeben
        bsr     errte      ; Bit #31=0: zul. Typ !=0: Adressierung prfen
        bcs.b   dia1a      ; C=1 Fehler: weiter suchen   
dia3    move.l  4(a1),d0   ; kein Fehler: 1. Befehlstext 
        bsr     dizei4     ; ausgeben
        move.l  8(a1),d0   ; 2. Befehlstext 
        bsr     dizei4     ; ausgeben
dia3a   movea.l 12(a1),a2  ; Sprungadresse laden       
        move.w  (a0)+,d1   ; D1.W = Code  A0 => Wort hinter Code
        jmp     (a2)       ; Sprungverteiler fr Typ 
* Code nicht gefunden: Wort hexa ausgeben  und Ende des Upros dia
diaerr  move.w  (a0)+,d0   ; Wort laden A0 -> nchstes Wort
        bsr     diwortd    ; $wort ausgeben
diaex   rts                ; einziges Ende von dia
* keffa/effa: D1.W = code:mod:reg bleibt!!!  A0 = Zeiger auf Wort
keffa   bsr     dikomm     ; Trennkomma 
effa    movem.l d0-d3,-(a7) ; Register retten: bei effaex zurckladen
        move.b  d1,d2      ; D2.B = xx mod reg
        andi.b  #$38,d2    ; D2.B = 00 111 000 mod maskieren
        bne.b   effa2      ; mod=000: Dn
        bsr     xn         ; Dn ausgeben
        bra     effaex     ; Rcksprung
effa2   cmpi.b  #$08,d2    ; 00 001 000 mod=001:  An
        bne.b   effa3      ;
        bsr     xn         ; An ausgeben
        bra     effaex     ; Rcksprung
effa3   cmpi.b  #%00111100,d1 ; 00 mod=111 reg=100: Bytekonstante
        bne.b   effa4      ;
        move.w  (a0)+,d0   ; Wort laden
        bsr     dibyter    ; #$byte ausgeben
        bra     effaex     ; Rcksprung
effa4   cmpi.b  #%01111100,d1 ; 01 mod=111 reg=100: Wortkonstante
        bne.b   effa5      ;
        move.w  (a0)+,d0   ; Wort laden
        bsr     diwortr    ; #$wort ausgeben
        bra     effaex     ; Rcksprung
effa5   cmpi.b  #%10111100,d1 ; 10 mod=111 reg=100: Langkonstante
        bne.b   effa6      ;
        move.l  (a0)+,d0   ; Langwort laden
        bsr     dilangr    ; #$lang ausgeben
        bra     effaex     ; Rcksprung
effa6   cmpi.b  #$10,d2    ; 00 010 000 mod=010: (An) ?
        bne.b   effa7      ; nein
        bsr     kank       ; (An) ausgeben
        bra     effaex     ; Rcksprung
effa7   cmpi.b  #$18,d2    ; 00 011 000 mod=011: (An)+ ?
        bne.b   effa8      ; nein
        bsr     kank       ; (An) ausgeben
        move.b  #'+',d0    ; +
        bsr     dizei      ; ausgeben
        bra     effaex     ; Rcksprung
effa8   cmpi.b  #$20,d2    ; 00 100 000 mod=100: -(An) ?
        bne.b   effa9      ; nein
        move.b  #'-',d0    ; -
        bsr     dizei      ;
        bsr     kank       ; (An) ausgeben
        bra     effaex     ; Rcksprung
effa9   cmpi.b  #$28,d2    ; 00 101 000 mod=101: wort(An) 
        bne.b   effa9a     ; nein
        move.w  (a0)+,d0   ; nchstes Wort
        ext.l   d0         ; zum Langwort vorzeichenausgedehnt
        bsr     diaddd     ; $add xx.xxxx ausgeben
        bsr     kank       ; (An) ausgeben 
        bra     effaex     ; Rcksprung
effa9a  move.b  d1,d0      ; vollen Code testen
        andi.b  #$3f,d0    ; 00 111 111 maskieren
        cmpi.b  #$3a,d0    ; 00 111 010 mod = 111 reg = 010
        bne.b   effa10     ; nein
        move.w  (a0)+,d0   ; nchstes Wort
        ext.l   d0         ; vorzeichenausgedehnt
        add.l   a0,d0      ; 
        subq.l  #2,d0      ; Wort + PC - 2 -> Adresse
        bsr     diaddd     ; $add xx.xxxx 
        move.l  #'(PC)',d0 ; (PC) 
        bsr     dizei4     ; ausgeben
        bra     effaex     ; Rcksprung
effa10  cmpi.b  #$30,d2    ; 00 110 000 mod=110: d(An,Xi) (b,An,Xi)
        bne     effa11     ; nein: weiter suchen
        move.w  (a0)+,d2   ; D2 = Erweiterungswort
        btst    #8,d2      ; kurze oder volle Erweiterung ?
        bne.b   effa10x    ; B8=1: -> volle Erweiterung
* kurze Erweiterung wie 68000 b(An,Xi)
        move.b  d2,d0      ; Byteabstand
        extb.l  d0         ; vorzeichenausgedehnt zum Langwort
        bsr     diaddd     ; $add $xx.xxxx ausgeben
        bsr     dikauf     ; ( Klammer auf
        bset    #3,d1      ; Marke fr A:  1 nnn
        bsr     xn         ; Basisregister An
        bsr     kxi        ; ,Xi.w*s) ausgeben
        bra     effaex     ; Rcksprung
* (displacement,An,Xi.w*s) volles Format D2.W = Erweiterungswort
effa10x bsr     dikauf     ; ( Klammer auf 
        move.b  d2,d0      ; D0.B = BS IS BdBd I/IS-Feld 
        andi.b  #$0f,d0    ; Maske 0000 1111
        bne     effaerr    ; Code-Fehler I/IS mu 0000 sein
        move.b  d2,d0      ; Erweiterungswort untersuchen
        andi.b  #$30,d0    ; Maske 00 11 0000 
        beq     effaerr    ; Bd Bd = 0 0: reserviert = Fehler
        cmpi.b  #$10,d0    ; 00 01 0000: Displacement Null ?
        beq.b   effa10y    ; ja: kein Displacement
        cmpi.b  #$20,d0    ; 00 10 0000: Wortdisplacement ?
        beq.b   effa10z    ; ja: Wortdisplacement
        move.l  (a0)+,d0   ; Langwort laden
        bsr     diaddd     ; $adr $xx.xxxx ausgeben
        bra.b   effa10a    ;
effa10y move.l  #'----',d0 ; kein Displacement
        bsr     dizei4     ; ausgeben
        bra     effa10a    ;
effa10z move.w  (a0)+,d0   ; Wort laden
        ext.l   d0         ; zum Langwort vorzeichenausgedehnt
        bsr     diaddd     ; $adr $xx.xxxx ausgeben
effa10a btst    #7,d2      ; BS = Basisregister ? 
        beq.b   effa10b    ; BS = 0: ja
        move.l  #',---',d0 ; BS = 1: nein ,--- 
        bsr     dizei4     ; ausgeben
        bra     effa10c    ;
effa10b bset    #3,d1      ; mode xx1 nnn fr An
        bsr     kxn        ; ,An ausgeben
effa10c btst    #6,d2      ; IS = Indexausdruck ?
        beq.b   effa10d       ; IS = 0: ja
        move.l  #$2c2d2d29,d0 ; IS = 1: nein ,--)
        bsr     dizei4      ; ausgeben
        bra     effaex      ; Rcksprung
effa10d bsr     kxi        ; IS = 1: ,Xi.w*s) ausgeben
        bra     effaex     ; Ende (d,An,Xi) volles Format
* Absolute Wort- oder Langwortadresse mit Symbolausgabe
effa11  move.b  d1,d0      ; D0.B effektive Addresse 
        andi.b  #$3f,d0    ; Maske 00 111 111 
        cmpi.b  #$38,d0    ; %00 111 000 mod=111 reg=000: (abs).W 
        bne.b   effa12     ;
        move.w  (a0)+,d0   ; nchstes Wort
        ext.l   d0         ; zu Langwort vorzeichenausgedehnt
        bsr     symbol     ; Symbolausgabe versuchen    
        bcc     effaex     ; C=0: Symbol ausgegeben
        bsr     diaddd     ; $adr $xx.xxxx ausgeben
        bra     effaex     ; Rcksprung
effa12  cmpi.b  #$39,d0    ; %00 111 001 mod=111 reg=001: (abs).L
        bne.b   effa13     ;
        move.l  (a0)+,d0   ; nchstes Langwort
        bsr     symbol     ; Symbolausgabe versuchen        
        bcc     effaex     ; C=0: Symbol augegeben
        bsr     diaddd     ; $adr xx.xxxx ausgeben
        bra     effaex     ; Rcksprung     
effa13  cmpi.b  #$3b,d0    ; %00 111 011 mod = 111 reg=011 b(PC,Xi) 
        bne     effaerr    ; nein: Code-Fehler
        move.w  (a0)+,d2   ; D2 = Erweiterungswort
        btst    #8,d2      ; kurze oder volle Erweiterung ?
        bne.b   effa13x    ; B8=1: -> volle Erweiterung
* kurze Erweiterung wie 68000 b(PC,Xi)
        move.b  d2,d0      ; Byteabstand
        extb.l  d0         ; nach Langwort vorzeichenausgedehnt 
        add.l   a0,d0      ; Abstand + PC - 2 => Adresse
        subq.l  #2,d0      ;
        bsr     diaddd     ; $adr ausgeben
        move.l  #$2850432c,d0 ; (PC,
        bsr     dizei4     ;
        bsr     xi         ; Xi.w*s) ausgeben
        bra     effaex     ; Rcksprung
* (displacement,PC,Xi.w*s) volle Erweiterung D2.W = Erweiterungswort
effa13x bsr     dikauf     ; ( Klammer auf dann Erweiterungwort testen
        move.b  d2,d0      ; D0.B = BS IS BdBd I/IS-Feld 
        andi.b  #$0f,d0    ; Maske 0000 1111
        bne     effaerr    ; Code-Fehler I/IS mu 0000 sein
        move.b  d2,d0      ; Erweiterungswort untersuchen
        andi.b  #$30,d0    ; Maske 00 11 0000 
        beq     effaerr    ; Bd Bd = 0 0: reserviert = Fehler
        cmpi.b  #$10,d0    ; 00 01 0000: Displacement Null ?
        beq.b   effa13y    ; ja: kein Displacement
        cmpi.b  #$20,d0    ; 00 10 0000: Wortdisplacement ?
        beq.b   effa13z    ; ja: Wortdisplacement
        move.l  (a0)+,d0   ; Langwort laden
        add.l   a0,d0      ; Abstand + PC - 6 -> Adresse
        subq.l  #6,d0      ; Korrektur
        bsr     diaddd     ; $adr $xx.xxxx ausgeben
        bra     effa13a    ;
effa13y move.l  #'----',d0 ; kein Displacement
        bsr     dizei4     ; ausgeben
        bra.b   effa13a    ;
effa13z move.w  (a0)+,d0   ; Wort laden
        ext.l    d0        ; vorzeichenausgedehnt
        add.l   a0,d0      ; Abstand + PC - 4 -> Adresse
        subq    #4,d0      ;
        bsr     diaddd     ; $adr $xx.xxxx ausgeben
effa13a bsr     dikomm     ; Komma ausgeben
        btst    #7,d2      ; BS = PC als Basisregister ? 
        beq.b   effa13b    ; BS = 0: ja
        move.w  #'--',d0   ; BS = 1: nein ZPC 
        bsr     dizei2     ; ausgeben
effa13b move.w  #'PC',d0   ; PC
        bsr     dizei2     ; ausgeben
effa13c btst    #6,d2      ; IS = Indexausdruck ?
        beq.b   effa13d       ; IS = 0: ja
        move.l  #$2c2d2d29,d0 ; IS = 1: nein ,--)
        bsr     dizei4        ; ausgeben
        bra     effaex     ; Rcksprung
effa13d bsr     kxi        ; IS = 1: ,Xi.w*s) ausgeben
        bra     effaex     ; Ende (d,An,Xi) volles Format
* Fehlermeldung fr Codefehler volles Erweiterungsformat
effaerr move.w  d2,d0      ; D0.W = Erweiterungswort
        bsr     diwortd    ; $wort
        move.l  #' ERR',d0 ; Fehlermeldung
        bsr     dizei4     ; dann Rcksprung
* Aussprung aus Unterprogramm effa und keffa:
effaex  movem.l (a7)+,d0-d3 ; Register zurck
        rts                ; aus effa und keffa
* Hilfs-Unterprogramme aufgerufen in effa und keffa
* kxn: ,Dn ,An  xn: Dn An  D1.B: .... xnnnn   D0.B zerstrt
kxn    bsr     dikomm      ; Komma
xn     move.b  #'A',d0     ; An vorgegeben
       btst    #3,d1       ; An oder Dn
       bne.b   xn1         ; 
       move.b  #'D',d0     ; Dn
xn1    bsr     dizei       ; ausgeben
       move.b  d1,d0       ; 
       andi.b  #$07,d0     ; n maskieren
       bsr     dinibb      ; und ausgeben
       rts                 ; Rcksprung -> effa
* kank: D1.B = xx mod aaa   Ausgabe: (An)
kank   bsr     dikauf      ; ( Klammer auf
       bset    #3,d1       ; xx xx1 xxx
       bsr     xn          ; An ausgeben
       bsr     dikzu       ; ) Klammer zu
       rts                 ; Rcksprung -> effa
* kxi: ,Xi.w*s) D2 = Erweiterungswort D/A nnn W/L ss 
kxi     bsr     dikomm     ; Komma
xi      move.b  #'D',d0    ; X = D
        btst    #15,d2     ; D/A-Feld
        beq.b   kxi1       ;
        move.b  #'A',d0    ; X = A
kxi1    bsr     dizei      ;
        move.w  d2,d0      ; i  
        rol.w   #4,d0      ; nach D0.B
        andi.b  #$07,d0    ; %0000 0111 A/D raus
        bsr     dinibb     ; x ausgeben
        bsr     dipunk     ; . Punkt ausgeben
        move.b  #'W',d0    ; W = 0
        btst    #11,d2     ; W/L-Feld: 0:.W 1:.L
        beq.b   kxi2       ;
        move.b  #'L',d0    ; L = 1
kxi2    bsr     dizei      ; Lnge ausgeben
        move.b  #'*',d0    ; Stern
        bsr     dizei      ;
        rol.w   #7,d2      ; Skalenfaktor D0.B
        andi.b  #3,d2      ; 0000 0011 
        move.b  #1,d0      ; 0000 0001
        lsl.b   d2,d0      ; 
        addi.b  #'0',d0    ; codieren
        bsr     dizei      ;
        bsr     dikzu      ; ) Klammer zu
        rts                ; Rcksprung -> effa
* errte: Test Adressierungsart: D0.W = zul. typ  D1.W = 00 mod reg  
errte:  movem.l d0-d3,-(a7)  ; Register retten
        clr.l   d2           ; D2 = 0
        clr.l   d3           ; D3 = 0
        move.b  d1,d2        ; D2 = xx mod reg
        lsr.b   #3,d2        ; D2 = 000 xx mod
        andi.b  #7,d2        ; D2 = 000 00 mod
        cmpi.b  #7,d2        ; < mod = 111 ?
        blo.b   errte1       ; war mod = 000 ... 110
        move.b  d1,d3        ; D3 = xx mod reg
        andi.b  #7,d3        ; D3 = 00 000 reg
        add.b   d3,d2        ; D2.B = mod + reg = Position 
errte1  btst    d2,d0        ; teste Adressierungsart         
        bne.b   errte3       ; war 1: zulssig
errte2  ori     #$01,CCR     ; C = 1: Fehler
        bra.b   errte5       ;
errte3  move.b  d1,d2        ; D2.B = Code xx mod reg
        andi.b  #$3f,d2      ; %00 111 111 mod = xxx  reg = xxx
        cmpi.b  #$3b,d2      ; %00 111 011 (d,PC,Xi) ?
        beq.b   errte3a      ; ja: Erweiterungswort testen
        andi.b  #$38,d2      ; %00 111 000 mod = xxx reg = 000
        cmpi.b  #$30,d2      ; %00 110 xxx (d,PC,Xi) ?
        bne.b   errte4       ; nein: kein Erweiterungswort 
errte3a move.w  2(a0),d2     ; Erweiterungswort laden
        btst    #8,d2        ; volles Format ?
        beq.b   errte4       ; nein: immer gut
        andi.b  #$0f,d2      ; ja: %0000 1111 I/IS = 0000 ? 
        bne.b   errte2       ; nein: Formatfehler
        move.w  2(a0),d2     ; Erweiterungwort laden
        andi.b  #$30,d2      ; %0 0 11 0000 BD SIZE = 00 ?
        beq.b   errte2       ; SIZE = 00 : Formatfehler (reserved)
errte4  andi    #$fe,CCR     ; C = 0: gut 
errte5  movem.l (a7)+,d0-d3  ; Register zurck
        rts                  ; Rcksprung
* Unterprogramm gibt hinter Langwortadresse vordef. Symbol aus
symbol  movem.l d0-d1/a0,-(a7) ; Register retten
        lea     sytab(PC),a0   ; A0 = Anfang Symboltabelle
symbol1 move.l  (a0)+,d1       ; D1.L = Tabellenwert
        beq.b   symbolx        ; Endemarke der Tabelle
        cmp.l   d1,d0          ; Adresse - Tabellenwert
        beq.b   symbol3        ; gefunden: ausgeben
symbol2 tst.b   (a0)+          ; Textendemarke 0 suchen
        bne.b   symbol2        ; Nicht Null: noch kein Ende
        move.l  a0,d1          ; Ende: Adresse geradzahlig machen
        addq.l  #1,d1          ; Addiere 1
        andi.b  #$fe,d1        ; Maske %1111 1110 fr letztes Bit
        move.l  d1,a0          ;
        bra.b   symbol1        ; Ist Null: nchsten Tabellenwert
symbol3 move.b  #'<',d0        ; < 
        bsr     dizei          ; ausgeben
symbol4 move.b  (a0)+,d0       ; Zeichen laden
        beq.b   symboly        ; Symbolendemarke nicht ausgeben
        bsr     dizei          ; Zeichen ausgeben
        bra.b   symbol4        ; nchstes Zeichen
symbolx movem.l (a7)+,d0-d1/a0 ; Register zurck
        ori     #$01,CCR       ; C=1: nicht gefunden
        rts                    ;
symboly move.b  #'>',d0        ; >
        bsr     dizei          ; ausgeben
        movem.l (a7)+,d0-d1/a0 ; Register zurck       
        andi    #$fe,CCR       ; C=0: gefunden
        rts                    ;

* Typ 20: 1-Wort-Befehl ohne Operanden  NOP
typ20   bra     diaex      ; fertig
* Typ 21: 1-Wort-Befehl mit 16-bit-Konstante RTD #wort
typ21   move.w  (a0)+,d0   ; Folgewort laden
        bsr     diwortr    ; #$wort ausgeben
        bra     diaex      ; fertig
* Typ 22: 1-Wort-Befehl mit 32-bit-Konstante TRAPcc.x #lang
typ22   bsr      dileer    ; Leerzeichen ausgeben
        move.l  (a0)+,d0   ; Folgelangwort laden 
        bsr     dilangr    ; #$lang ausgeben
        bra     diaex      ; fertig
* Typ 23: LPSTOP # verlagert als Sonderfall nach Typ 59 TBLxx
* Typ 24: BKPT #3-bit-Code und TRAP #4-bit-Code 
typ24a  bclr    #3,d1      ; BKPT Bit #3 lschen 
typ24b  move.b  d1,d0      ; D0.B = Codewort
        andi.l  #$0f,d0    ; %000 1111 Zahl maskieren
        bsr     didezir    ; #dezimal aus D0.B
        bra     diaex      ; fertig
* Typ 25: Wort mit Dn  EXT SWAP  Typ 26: UNLK An
typ25   andi.b  #$0f,d1    ; Maske 00 001 111 
        bsr     effa       ; Dn oder An ausgeben
        bra     diaex      ; fertig
* Typ 27: LINK.W An,#wort
typ27   andi.b  #$07,d1    ; 00 001 111  An
        ori.b   #$08,d1    ; 00 001 000  1 fehlt in Code
        bsr     effa       ; An ausgeben
        move.b  #$7c,d1    ; 01 111 100 
        bsr     keffa      ; Komma und #Wortkonstante
        bra     diaex      ; fertig
* Typ 28: LINK.L An,#langwort
typ28   andi.b  #$0f,d1    ; 00 001 111  An
        bsr     effa       ; An ausgeben
        move.b  #$bc,d1    ; 10 111 100 
        bsr     keffa      ; Komma und #Langwortkonstante
        bra     diaex
* Typ 29: MOVEQ  #byte,Dn  ;
typ29   move.b  d1,d0      ; Bytekonstante 
        bsr     dibyter    ; #$byte
        rol.w   #7,d1      ; D1.B = xxxxxxxxxxxx reg
        andi.b  #$07,d1    ; 00 000 reg 
        bsr     keffa      ;
        bra     diaex      ;
* Typ 30a: EXG  Dx,Dy  Typ 30c EXG Dx,Ay
typ30a  rol.w   #7,d1      ; .....yy y....rrr
        andi.b  #$8f,d1    ;         10001111
        bsr     effa       ; Dx Ax ausgeben
        ror.w   #7,d1      ; ........ .....yyy
        andi.b  #$0f,d1    ;          00001111
        bsr     keffa      ;
        bra     diaex      ;
* Typ 30b: EXG  Ax,Ay
typ30b  bset    #12,d1     ; xxx1xxxx xxxxxxxx fr Ax
        bra     typ30a     ; wie Dx,Dy
* Typ 31a: MOVEC Rc,Rn  2.Wort enthlt Register
typ31a  move.w   (a0)+,d1   ; D1 = Registercode
        move.w   d1,d2      ; D2 = Arbeitsregister 
        bsr      typ31rc    ; Rc=SFC,DFC,USP,VBR,ERR 
        rol.w    #4,d1      ;
        andi.b   #$0f,d1    ; A/Drrr
        bsr      keffa      ; mit Komma ausgeben
        bra      diaex      ;
* Typ 31b: MOVEC Rn,Rc  2.Wort enthlt Register        
typ31b  move.w   (a0)+,d1   ; D1 = Registercode
        rol.w    #4,d1      ; cccccccc cccc A/Drrr
        andi.b   #$0f,d1    ; 00 001 111 
        bsr      effa       ; Rn als An oder Dn ausgeben
        move.w   -2(a0),d2  ; 2. Codewort nochmal holen
        bsr      dikomm     ; Trennkomma
        bsr      typ31rc    ; rc=SFC,DFC,USP,VBR,ERR ausgeben
        bra      diaex      ;
* typ31rc: Unterprogramm gibt Rc=SFC,DFC,USP,VBR,ERR aus
typ31rc andi.w   #$0fff,d2  ; Rn maskieren
        cmpi.w   #$0000,d2  ; Rc = SFC ?
        bne.b    typ31r2    ; nein:
        move.l   #'SFC',d0  ; ja:
        bsr      dizei4     ; ausgeben 
        bra.b    typ31r6
typ31r2 cmpi.w   #$0001,d2  ; Rc = DFC ?
        bne.b    typ31r3    ; nein
        move.l   #'DFC',d0  ; ja:
        bsr      dizei4     ; ausgeben 
        bra.b    typ31r6
typ31r3 cmpi.w   #$0800,d2  ; Rc = USP ?
        bne.b    typ31r4    ; nein
        move.l   #'USP',d0  ; ja
        bsr      dizei4     ; ausgeben 
        bra.b    typ31r6
typ31r4 cmpi.w   #$0801,d2  ; Rx = VBR ?
        bne.b    typ31r5    ; Code-Fehler
        move.l   #'VBR',d0  ; 
        bsr      dizei4     ; ausgeben 
        bra.b    typ31r6    ;
typ31r5 move.w   d2,d0      ; Code-Fehler:
        bsr      diwortd    ; $wort ausgeben
        move.l   #'=err',d0 ; Fehlermeldung
        bsr      dizei4     ; ausgeben
typ31r6 rts                 ;
* Typ32: CMPM.x  (Ay)+,(Ax)+
typ32   bset     #4,d1      ; mod = 011 gesetzt
        bsr      effa       ; (Ay)+ ausgeben
        rol.w    #7,d1      ; 
        bsr      keffa      ; ,(Ax) ausgeben
        bra      diaex
* Typ33a: ABCD Dy,Dx
typ33a  andi.b   #7,d1      ; D1.B = mod = 000
        bsr      effa       ; Dy ausgeben
        rol.w    #7,d1      ; 
        andi.b   #7,d1      ; mod = 000
        bsr      keffa      ; , Dx ausgeben
        bra      diaex
* Typ33b: ABCD -(Ay),-(Ax)
typ33b  andi.b   #7,d1      ; maskieren
        ori.b    #$20,d1    ; 00 100 000 mod = 100
        bsr      effa       ; -(Ay) ausgeben
        rol.w    #7,d1      ;
        andi.b   #7,d1      ;
        ori.b    #$20,d1    ;
        bsr      keffa      ;
        bra      diaex
* Typ35: Bxx.W Wortabstand
typ35   move.l   a0,d0      ; Adresszhler
        move.w   (a0)+,d1   ; Wort-Abstand
        ext.l    d1         ; Vorzeichenausdehnung
typ351  add.l    d1,d0      ; Sprungziel 
        bsr      dipfei     ; => ausgeben (D0.L gerettet in Upro)
        bsr      diaddd     ; $xx.xxxx ausgeben
        bra      diaex
* Typ36: Bxx.L Langwortabstand
typ36   move.l   a0,d0      ; Adrezhler
        move.l   (a0)+,d1   ; Langwortabstand
        bra      typ351     ; => und $xx.xxxx ausgeben
* Typ37: Bxx.S oder Bxx.B Byteabstand
typ37   move.l   a0,d0      ; Adrezhler
        move.w   -2(a0),d1  ; Byte-Abstand aus Codewort
        extb.l   d1         ; Byte -> Langwort mit Vorzeichen
        bra      typ351     ; => und $xx.xxxx ausgeben
* Typ38: DBcc  Dn,ziel
typ38   andi.b   #$07,d1    ;
        bsr      effa       ; Dn
        bsr      dikomm     ; Komma ausgeben
        bra      typ35      ; Wortabstand   
* Alle Befehle mit Effektiver Adresse <ea> 
* Typ40: Befehl <effa> 
typ40   bsr      effa       ; TST CLR JMP <effa>
        bra      diaex      ;
* Typ41: Dn,<effa>    EOR  Dn,<effa>
typ41   bclr     #12,d1     ; fr mod = xx0 Dn
        rol.w    #7,d1      ;
        andi.b   #$8f,d1    ; %1000 1111 s0  mod = 000
        bsr      effa       ; typ4 /#
        ror.w    #7,d1      ; 
        andi.b   #$3f,d1    ; %00 111 111
        bsr      keffa      ; Komma und effa
        bra      diaex      ;
* Typ42: <effa>,An   ADDA.W  <effa>,An    LEA <effa>,An
typ42   bset     #12,d1     ; fr mod = xx1 An  fr LEA!
typ421  andi.b   #$3f,d1    ; %00 111 111  
        ori.b    #$40,d1    ; %01 000 000 Wortkonstante
typ422  bsr      effa       ; 
        rol.w    #7,d1      ;
        andi.w   #$0f,d1    ; %00 001 111 
        bsr      keffa      ; Komma An   
        bra      diaex      ;
* Typ43  effa,An  alle ADDA.L Langwortkonstante
typ43   bset     #12,d1     ; fr mod = xx1 An 
typ431  andi.b   #$3f,d1    ; %00 111 111  
        ori.b    #$80,d1    ; %10 000 000 Langkonstante
        bra      typ422     ; weiter wie Typ 42
* Typ44:  ADDQ.x #kon,<effa>  typ4 und typ9
typ44   bsr      diraut     ; # ausgeben
        move.w   d1,d0      ; Konstante
        rol.w    #7,d0      ; schieben
        andi.b   #7,d0      ; maskieren
        bne.b    typ441     ;
        addi.b   #8,d0      ; 000 = 8
typ441  bsr      dinibb     ; x
        andi.w   #$003f,d1  ; %00 111 111
        bsr      keffa      ; Komma und effa
        bra      diaex      ;
* Typ45a: ANDI #byte,CCR
typ45a  move.w   (a0)+,d0   ; Konstante
        bsr      dibyter    ; #$byte ausgeben
        move.l   #',CCR',d0 ; ,CCR
        bsr      dizei4     ; ausgeben
        bra      diaex      ;
* Typ45b: ANDI #wort,SR
typ45b  move.w   (a0)+,d0   ; Konstante
        bsr      diwortr    ; #$wort ausgeben
        move.l   #',SR ',d0 ; ,SR 
        bsr      dizei4     ; ausgeben
        bra      diaex      ;
* Typ45c: EORI #byte,CCR
typ45c  move.w   (a0)+,d0   ; Konstante
        bsr      dibyter    ; #$byte ausgeben
        move.l   #',CCR',d0 ; ,CCR
        bsr      dizei4     ;  ausgeben
        bra      diaex      ;
* Typ45d: EORI #wort,SR
typ45d  move.w   (a0)+,d0   ; Konstante
        bsr      diwortr    ; #$wort ausgeben
        move.l   #',SR ',d0 ; ,SR
        bsr      dizei4     ; ausgeben
        bra      diaex      ;
* Typ45e: ORI #byte,CCR
typ45e  move.w   (a0)+,d0   ; Konstante
        bsr      dibyter    ; #$byte ausgeben
        move.l   #',CCR',d0 ; ,CCR
        bsr      dizei4     ; ausgeben
        bra      diaex      ;
* Typ45f: ORI #wort,SR
typ45f  move.w   (a0)+,d0   ; Konstante
        bsr      diwortr    ; #$wort ausgeben
        move.l   #',SR ',d0 ; ,SR
        bsr      dizei4     ; ausgeben
        bra      diaex      ;
* Typ46a: ADDI.B #byte,effa typ4  CMPI.B #byte,effa typ5       
typ46a  move.w   (a0)+,d0   ; Konstante
        bsr      dibyter    ; #$byte 
        bsr      keffa      ;
        bra      diaex      ;
* Typ46b: ADDI.w #,effa typ4        
typ46b  move.w   (a0)+,d0   ; Konstante
        bsr      diwortr    ; #$wort
        bsr      keffa      ;
        bra      diaex      ;
* Typ46c: ADDI.L #,effa typ4        
typ46c  move.l   (a0)+,d0   ; Konstante
        bsr      dilangr    ; #$lang
        bsr      keffa      ;
        bra      diaex      ;
* Typ47: CMP.x <effa>,Dn    .W .L: typ1 .B typ2 /An
typ47   bsr      effa       ; effektive Adresse
        rol.w    #7,d1      ;
        andi.b   #$07,d1    ; %00 000 111  mod = 000 Dn
        bsr      keffa      ; Dn
        bra      diaex      ;
* Typ47a CHK.W  <effa>,Dn   s = 01 Wort
typ47a  bclr     #12,d1     ; Dn 
        bra      typ421     ; weiter wie ADDA.W <ea>,An
* Typ47b CHK.W  <effa>,Dn   s = 10 Lang
typ47b  bclr     #12,d1     ; Dn
        bra      typ431      ; weiter wie ADDA.L <ea>,An
* Typ48a ADD.x  <effa>,Dn   ;
typ48a  bclr     #12,d1     ; Dn
        bra      typ47      ;    TEST   gehe direkt ?
* Typ48b ADD.x  Dn,<effa>   ;
typ48b  bclr     #12,d1     ; Dn
        bra      typ41      ;    TEST  gehe direkt ?
* typ49a: ASR.x  #kon,Dn
typ49a  andi.b   #$07,d1   ; %00 000 111  mod = 0 0 0 Dn 
        bra      typ44     ; wie ADDQ #3,<ea>
* typ49b: ASR.x  Dx,Dn     
typ49b  andi.b   #$07,d1   ; %00 000 111  mod = 0 0 0 Dn
        bra      typ30a    ; wie EXG Dx,Dy
* typ50a: BTST Dn,<effa>
typ50a  bra      typ41     ; wie typ41 
* typ50b: BTST  #kon,<effa> #kon im Folgewort
typ50b  move.w  (a0)+,d0   ; Folgewort laden
        andi.l  #$0ff,d0   ; %0000 .... 0000 1111 1111 Byte 
        bsr     didezir    ; #dezimal aus D0.B
        bsr     keffa      ; Komma und effektive Adresse
        bra     diaex      ;
* Sonderflle des MOVE CCR SR USP
typ52a  move.l  #'CCR,',d0 ; MOVE CCR,<>
        bsr     dizei4     ;
        bsr     effa       ; <>
        bra     diaex      ;
typ52b  andi.b  #$3f,d1    ; %00 111 111  #byte
        bsr     effa       ; <>
        move.l  #',CCR',d0 ; ,CCR
        bsr     dizei4     ;
        bra     diaex      ;
typ52c  move.w  #'SR',d0   ; MOVE SR,<>
        bsr     dizei2     ;
        bsr     keffa      ; <>
        bra     diaex      ;
typ52d  andi.b  #$3f,d1    ; %00 111 111  
        ori.b   #$40,d1    ; %01 000 000  #wort
        bsr     effa       ; <>
        move.l  #',SR ',d0 ; ,SR
        bsr     dizei4     ;
        bra     diaex      ;
typ52e  move.l  #'USP,',d0 ; MOVE USP,An
        bsr     dizei4     ;
        andi.b  #$07,d1    ; %00 000 111
        ori.b   #$08,d1    ; %00 001 000 An
        bsr     effa       ; 
        bra     diaex      ;
typ52f  andi.b  #$07,d1    ; %00 000 111 
        ori.b   #$08,d1    ; %00 001 000 An
        bsr     effa       ; <>
        move.l  #',USP',d0 ; ,CCR
        bsr     dizei4     ;
        bra     diaex      ;
* Typ55a MOVEP.x  w(An),Dn
typ55a  bset    #5,d1      ; mod = 101 gesetzt
        bsr     effa       ; w(An)
        rol.w   #7,d1      ; Dn frei machen
        bsr     keffa      ;
        bra     diaex      ;
* Typ55b MOVEP.x  Dn,w(An) ;
typ55b  rol.w   #7,d1      ; 
        bsr     effa       ; Dn
        ror.w   #7,d1      ;
        bset    #5,d1      ; mod = 101 gesetzt
        bsr     keffa      ; w(An)
        bra     diaex
* Typ56 MOVES.x   Erweiterungswort: Rn,<> oder <>,Rn
typ56   move.w  (a0)+,d0   ; D0.W = Erweiterungswort
        btst    #11,d0     ; Richtungsbit
        bne     typ561     ; B11 = 1: -> Rn,<ea>
        bsr     effa       ; <effa> ausgeben
        rol.w   #4,d1      ; Rn nach rechts 
        andi.b  #$0f,d1    ; %00 001 111 An oder Dn
        bsr     keffa      ; , Rn
        bra     diaex      ;
typ561  movem.l d1,-(a7)   ; B11 = 1: Rn,<ea>  Codewort retten
        move.w  d0,d1      ; Erweiterungswort mit Rn
        rol.w   #4,d1      ;  
        andi.b  #$0f,d1    ; %00 001 111 An oder Dn
        bsr     effa       ; Rn ausgeben
        movem.l (a7)+,d1   ; Codewort holen
        bsr     keffa      ; , <effa>
        bra     diaex      ;
* Typ57a: MOVEM.x liste,<effa>  fr -(an) Liste richtig!!
typ57a  move.w  (a0)+,d0   ; D0.W = Registerliste
        movem.l d1,-(a7)   ; D1.W mit Code retten
        andi.b  #$38,d1    ; %00 111 000 
        cmpi.b  #$20,d1    ; %00 100 000 -(An)?
        bne     typ57a1    ; nein: Liste vertauschen
        bsr     typ57nc    ; ja: bei -(An) nicht tauschen ausgeben
        bra.b   typ57a2    ; Weiter
typ57a1 bsr     typ57c     ; nein: Liste tauschen und ausgeben
typ57a2 movem.l (a7)+,d1   ; Code wieder zurck
        bsr     keffa      ; komma und <effa>
        bra     diaex      ;
* Typ57b: MOVEM.x <effa>,liste  Liste immer vertauschen -> D0 - A7
typ57b  move.w  (a0)+,d0   ; D0.W = Registerliste
        movem.l d0,-(a7)   ; retten
        bsr     effa       ; <effa> ausgeben
        bsr     dikomm     ; komma
        movem.l (a7)+,d0   ; D0.W = Registerliste
        bsr     typ57c     ; tauschen und ausgeben
        bra     diaex      ;       
* typ57c: D0.W: Liste vertauschen und ausgeben 
typ57c  movem.l d0-d4,-(a7) ; Register retten  
        moveq   #15,d2      ; D2.W = Zhler 16 Bits
typ57c1 roxl.w  #1,d0       ; D0-Hi -> X-Bit
        roxr.w  #1,d1       ; X-Bit -> D1-Hi
        dbra    d2,typ57c1  ; Schleife
        move.w  d1,d0       ; D0.W = Liste
        bra     typ57n1     ; 
typ57nc movem.l d0-d4,-(a7) ; nicht vertauschen bei -(a7)
typ57n1 clr.w   d1          ; D1.W: 00 000 000 = Register-Nummer D0-A7
        moveq   #15,d4      ; D4.W = Zhler und Position 16 Register
        move.w  d0,d3       ; D3.W = Liste
typ57n2 btst    d4,d3       ; Bit testen
        beq     typ57n3     ; 0: kein Register
        bsr     effa        ; 1: Register ausgeben
        bsr     distri      ; / als Trennung
typ57n3 addq.w  #1,d1       ; nchstes Register
        dbra    d4,typ57n2  ; Schleife
        movem.l (a7)+,d0-d4 ; Register zurck
        rts                 ;
* Sonderflle: noch keine Prfung und kein Befehl ausgegeben D1.W = Code
* Typ51: CHK2 oder CMP2  D1.W = Code  (A0) = 2.Codewort  (A1) = Sprungadresse
typ51   move.w  (a0)+,d2   ; 2.Codewort laden
        andi.b  #$3f,d1    ; %00 111 111  keine #-Adressierung
        bsr     errte      ; Adressierung prfen
        bcc.b   typ551     ; C=0: kein Adressierungsfehler
        subq    #2,a0      ; C=1: Fehler: Zeiger auf nchstes Code-Wort zurck
        bra     dia1a      ; nicht zulssig: neuen Code versuchen 
typ551  move.l  4(a1),d0   ; D0.L = 1.Befehlstext  CHK2
        btst    #11,d2     ; 0: CMP2  1:CHK2
        bne.b   typ51a     ; 1: bleibt
        move.l  #'CMP2',d0 ; 0: nach CMP2 ndern
typ51a  bsr     dizei4     ; 1.Befehlstext ausgeben        
        move.l  8(a1),d0  ; 2.Befehlstext laden
        bsr     dizei4     ; und ausgeben
        movem.l d2,-(a7)   ; 2. Codewort retten
        bsr     effa       ; <eff> ausgeben
        movem.l (a7)+,d1   ; D1.W = 2. Codewort
        rol.w   #4,d1      ;
        andi.b  #$0f,d1    ; A/D rrr
        bsr     keffa      ; Rn ausgeben
        bra     diaex      ; 
* Typ58a: DIVx.L oder DIVxL.L  <ea>,dq oder <ea>,dr:dq
typ58a  move.w  (a0)+,d2   ; 2.Codewort laden
        bsr     errte      ; Adressierung prfen
        bcc.b   typ58a0    ; C=0: kein Fehler
        subq    #2,a0      ; C=1: Fehler A0 auf nchstes Code-Wort zurck
        bra     dia1a      ; nicht zulssig: neuen Code versuchen 
typ58a0 move.l  #'DIVU',d0 ; 0: DIVU angenommmen  
        btst    #11,d2     ; 2.Codewort: 0: DIVU  1: DIVS
        beq.b   typ58a1    ; 0: DIVU ausgeben
        move.l  #'DIVS',d0 ; 1: DIVS laden
typ58a1 bsr     dizei4     ; 1.Befehlstext ausgeben
        move.l  #'.L  ',d0 ; 2.Befehlstext laden
        btst    #10,d2     ; SIZE ?
        bne.b   typ58a2    ; = 1: immer .L
        move.w  d2,d3      ; D3.W = Erweiterung
        rol.w   #4,d3      ; Dq mit Dl vergleichen
        andi.b  #$07,d3    ; %00 000 111 Dl-Feld
        cmp.b   d3,d2      ; Dq - Dl
        beq.b   typ58a2    ; gleich:   DIVx.L
        move.l  #'L.L ',d0 ; ungleich: DIVxL.L
typ58a2 bsr     dizei4     ; und ausgeben
        movem.l d2,-(a7)   ; 2. Codewort retten
        andi.b  #$3f,d1    ; %00 111 111  SIZE frei
        ori.b   #$80,d1    ; %10 000 000  Langwort fr #
        bsr     effa       ; <eff> ausgeben
        movem.l (a7)+,d1   ; D1.W = 2. Codewort
        bsr     dikomm     ; , Komma ausgeben
        btst    #10,d1     ; SIZE = 0: dr==dq?  SIZE = 1: immer dr:dq
        bne.b   typ58a3    ; -> immer dr:dq
        move.w  d1,d3      ; D3.W = Erweiterung
        rol.w   #4,d3      ; Dq mit Dl vergleichen
        andi.b  #$07,d3    ; %00 000 111 Dl-Feld
        cmp.b   d3,d1      ; Dq - Dl
        beq.b   typ58a4    ; gleich:   nur Dq
typ58a3 andi.b  #$07,d1    ; dh maskieren
        bsr     effa       ; Dl rrr ausgeben
        bsr     didopp     ; : Doppelpunkt
typ58a4 rol.w   #4,d1      ;
        andi.b  #$07,d1    ; Dl rrr
        bsr     effa       ; dl ausgeben
        bra     diaex      ; 
* Typ58b: MULU.L oder MULS.L  <ea>,dl oder <ea>,dh:Dl
typ58b  move.w  (a0)+,d2   ; 2.Codewort laden
        bsr     errte      ; Adressierung prfen
        bcc.b   typ58b0    ; C=0: kein Fehler
        subq    #2,a0      ; C=1: Fehler A0 auf nchstes Code-Wort zurck
        bra     dia1a      ; nicht zulssig: neuen Code versuchen 
typ58b0 move.l  #'MULU',d0 ; 0: MULU angenommmen  
        btst    #11,d2     ; 2.Codewort: 0: MULU  1: MULS
        beq.b   typ58b1    ; 0: MULU ausgeben
        move.l  #'MULS',d0 ; 1: MULS laden
typ58b1 bsr     dizei4     ; 1.Befehlstext ausgeben
        move.l  #'.L  ',d0 ; 2.Befehlstext laden
        bsr     dizei4     ; und ausgeben
        movem.l d2,-(a7)   ; 2. Codewort retten
        andi.b  #$3f,d1    ; %00 111 111  SIZE frei
        ori.b   #$80,d1    ; %10 000 000  Langwort fr #
        bsr     effa       ; <eff> ausgeben
        movem.l (a7)+,d1   ; D1.W = 2. Codewort
        bsr     dikomm     ; , Komma ausgeben
        btst    #10,d1     ; SIZE = 0: dl  SIZE = 1: dh:dl
        beq.b   typ58b2    ; -> nur dl
        andi.b  #$07,d1    ; dh maskieren
        bsr     effa       ; Dl rrr ausgeben
        bsr     didopp     ; : Doppelpunkt
typ58b2 rol.w   #4,d1      ;
        andi.b  #$07,d1    ; Dl rrr
        bsr     effa       ; dl ausgeben
        bra     diaex      ; 
* Typ59: TBLx.x <>,dx oder dym:dyn,dx Sonderfall LPSTOP #wort      
typ59   move.w  (a0)+,d2   ; D2.W = 2. Codewort Erweiterung
        cmpi.w  #$01c0,d2  ; = LPSTOP ?
        bne.b   typ591     ; nein: ist TBLx.x
        move.l  #'LPST',d0 ; Befehl LPSTOP laden
        bsr     dizei4     ;
        move.l  #'OP  ',d0 ; 
        bsr     dizei4     ;
        move.w  (a0)+,d0   ; Konstante #wort laden
        bsr     diwortr    ; #$wort
        bra     diaex      ; fertig mit LPSTOP
typ591  btst    #8,d2      ; <ea> oder dym:dyn ?
        bne.b   typ592     ; 1: <ea> testen mit D1.W = typ6
        move.w  #$0001,d0  ; nur Dn zugelassen
typ592  bsr     errte      ; Adressierung prfen
        bcc.b   typ592x    ; C=0: kein Fehler
        subq    #2,a0      ; C=1: Fehler A0 auf 2.Codewort zurck
        bra     dia1a      ; nicht zulssig: neuen Code versuchen 
typ592x move.l  #'TBLU',d0 ; TBLU angenommen
        btst    #11,d2     ; 1: TBLS 0: TBLU
        beq.b   typ593     ; 0: TBLU
        move.l  #'TBLS',d0 ; 1: TBLS
typ593  bsr     dizei4     ;
        btst    #10,d2     ; 1: N ausgeben
        beq.b   typ594     ; 0: nicht
        move.b  #'N',d0    ;
        bsr     dizei      ; N angehngt
typ594  btst    #7,d2      ; 1: .L
        beq.b   typ595     ; nein:
        move.w  #'.L',d0   ;
        bsr     dizei2     ; .L 
        bra.b   typ597     ;
typ595  move.w  #'.W',d0   ;
        btst    #6,d2      ; 0: .B   1: .W
        bne.b   typ596     ; 1: ausgeben
        move.w  #'.B',d0   ;
typ596  bsr     dizei2     ; .B oder .W ausgeben
typ597  move.w  #'  ',d0   ;
        bsr     dizei2     ; immer 2 Leerzeichen
        movem.l d1/d2,-(a7) ;
        btst    #8,d2      ; 1: <ea> oder 0: dym:dyn ?
        bne.b   typ598     ; 1: <ea> ausgeben
        movem.l d2,-(a7)   ;
        bsr     effa       ; 0: D1.B = Dym
        movem.l (a7)+,d2   ;
        bsr     didopp     ; : Doppelpunkt
        move.w  d2,d1      ; D1.B = 2.Codewort = Erweiterung
        andi.b  #$07,d1    ; %00 000 111 Dyn frei
        bsr     effa       ; Dyn ausgeben
        bra.b   typ599     ; 
typ598  bsr     effa       ; 1: <ea> ausgeben
typ599  movem.l (a7)+,d1/d2 ;
        move.w  d2,d1      ; D1.W = Erweiterung mit Dx
        rol.w   #4,d1      ; 
        andi.b  #$07,d1    ; %00 000 111 ddd frei
        bsr     keffa      ; , DX ausgeben
        bra     diaex      ; 
* MOVE quelle,ziel  Sonderflle CCR SR USP bereits behandelt
* Typ53a : MOVE.B     An als Ziel und Quelle nicht zulssig!
typ53a  move.w d1,d0       ; D0.W = Codewort
        andi.b #$38,d0     ; %00 111 000 Quelle mod = ?
        cmpi.b #$08,d0     ; %00 001 000 mod = An ?
        beq    typ53er     ; An fr MOVE.B nicht zugelassen
        move.w d1,d0       ; nochmal als Ziel prfen
        andi.w #$01c0,d0   ; %0000 000 111 000 000  Ziel mod = ?
        cmpi.w #$0040,d0   ; %0000 000 001 000 000 mod = An
        beq    typ53er     ; An fr MOVE.B nicht zugelassen
        move.w #$0000,d2   ; %0000 0000 00 000 000 SIZE .B
        bra    typ53       ; gemeinsam fr alle .x weiter
* Typ53b : MOVE.W
typ53b  move.w #$0040,d2   ; %0000 0000 01 000 000 SIZE .W
        bra    typ53       ;
* Typ53c : MOVE.L 
typ53c  move.w #$0080,d2   ; %0000 0000 10 000 000 SIZE .L
        bra    typ53       ;
* fr alle drei MOVE.x geht es hier weiter 
typ53   move.b  d1,d0      ; D0.B = Ziel-Code
        andi.b  #$3f,d0    ; %00 111 111 mod reg = ?
        cmpi.b  #$3c,d0    ; %00 111 100 > #kon ?
        bhi     typ53er    ; Fehler: mod = 111 reg = 101 bis 111
        move.w  d1,d0      ; D0.W = Quell-Code untersuchen
        move.w  d1,d3      ; D1.W = D3.W = xxxx rrr mmm xxx xxx 
        rol.w   #7,d3      ; D3.B = xxxx xrrr  
        andi.b  #7,d3      ; D3.B = 00 000 rrr
        lsr.w   #3,d0      ; D0.B = 00 mmm xxx
        andi.b  #$38,d0    ;        %00 111 000  D0.B = 00 mmm 000
        or.b    d0,d3      ; D3.B =  00 mmm rrr des Ziels
        cmpi.b  #$39,d3    ; 00 111 001 > abs.L ?
        bhi     typ53er    ; Fehler: mod = 111 reg = 010 bis 111
* hier keine Prfung des Erweiterungswortes volles Format !!!!!!
        move.l  4(a1),d0  ; 1. Befehlslangwort
        bsr     dizei4     ;
        move.l  8(a1),d0  ; 2. Befehlslangwort
        bsr     dizei4     ;
        andi.w  #$3f,d1    ; %00 111 111 SIZE frei
        or.w    d2,d1      ; SIZE dazu
        bsr     effa       ; Quelloperand ausgeben
        move.w  d3,d1      ; Code Zieloperand laden
        bsr     keffa      ; Komma und Zieloperand ausgeben
        bra     diaex      ;
typ53er move.w  -2(a0),d0  ; Fehler-Code laden
        bsr     diwortd    ; $wort ausgeben
        bra     diaex      ;
* Codetabelle: Maske+Grundcode:zul.Adr.:Symbol:Symbol:Sprungziel
tab     dc.l    $ffff4e71,0,'NOP ','    ',typ20 ; 1 Wort ohne Operand
        dc.l    $ffff4afc,0,'ILLE','GAL ',typ20 ;
        dc.l    $ffff4afa,0,'BGND','    ',typ20 ;
        dc.l    $ffff4e70,0,'RESE','T   ',typ20 ;
        dc.l    $ffff4e73,0,'RTE ','    ',typ20 ;
        dc.l    $ffff4e77,0,'RTR ','    ',typ20 ;
        dc.l    $ffff4e75,0,'RTS ','    ',typ20 ;
        dc.l    $ffff4e76,0,'TRAP','V   ',typ20 ;
        dc.l    $ffff50fc,0,'TRAP','T   ',typ20 ;
        dc.l    $ffff51fc,0,'TRAP','F   ',typ20 ;
        dc.l    $ffff52fc,0,'TRAP','HI  ',typ20 ;
        dc.l    $ffff53fc,0,'TRAP','LS  ',typ20 ;
        dc.l    $ffff54fc,0,'TRAP','CC  ',typ20 ;
        dc.l    $ffff55fc,0,'TRAP','CS  ',typ20 ;
        dc.l    $ffff56fc,0,'TRAP','NE  ',typ20 ;
        dc.l    $ffff57fc,0,'TRAP','EQ  ',typ20 ;
        dc.l    $ffff58fc,0,'TRAP','VC  ',typ20 ;
        dc.l    $ffff59fc,0,'TRAP','VS  ',typ20 ;
        dc.l    $ffff5afc,0,'TRAP','PL  ',typ20 ;
        dc.l    $ffff5bfc,0,'TRAP','MI  ',typ20 ;
        dc.l    $ffff5cfc,0,'TRAP','GE  ',typ20 ;
        dc.l    $ffff5dfc,0,'TRAP','LT  ',typ20 ;
        dc.l    $ffff4efc,0,'TRAP','GT  ',typ20 ;
        dc.l    $ffff4ffc,0,'TRAP','LE  ',typ20 ;
        dc.l    $ffff4e74,0,'RTD ','    ',typ21 ; 1 Wort + Wortkonstante
        dc.l    $ffff4e72,0,'STOP','    ',typ21 ;
        dc.l    $ffff50fa,0,'TRAP','T.W ',typ21 ;
        dc.l    $ffff51fa,0,'TRAP','F.W ',typ21 ;
        dc.l    $ffff52fa,0,'TRAP','HI.W',typ21 ;
        dc.l    $ffff53fa,0,'TRAP','LS.W',typ21 ;
        dc.l    $ffff54fa,0,'TRAP','CC.W',typ21 ;
        dc.l    $ffff55fa,0,'TRAP','CS.W',typ21 ;
        dc.l    $ffff56fa,0,'TRAP','NE.W',typ21 ;
        dc.l    $ffff57fa,0,'TRAP','EQ.W',typ21 ;
        dc.l    $ffff58fa,0,'TRAP','VC.W',typ21 ;
        dc.l    $ffff59fa,0,'TRAP','VS.W',typ21 ;
        dc.l    $ffff5afa,0,'TRAP','PL.W',typ21 ;
        dc.l    $ffff5bfa,0,'TRAP','MI.W',typ21 ;
        dc.l    $ffff5cfa,0,'TRAP','GE.W',typ21 ;
        dc.l    $ffff5dfa,0,'TRAP','LT.W',typ21 ;
        dc.l    $ffff4efa,0,'TRAP','GT.W',typ21 ;
        dc.l    $ffff4ffa,0,'TRAP','LE.W',typ21 ;
        dc.l    $ffff50fb,0,'TRAP','T.L ',typ22 ; 1 Wort + Langwortkonstante
        dc.l    $ffff51fb,0,'TRAP','F.L ',typ22 ;
        dc.l    $ffff52fb,0,'TRAP','HI.L',typ22 ;
        dc.l    $ffff53fb,0,'TRAP','LS.L',typ22 ;
        dc.l    $ffff54fb,0,'TRAP','CC.L',typ22 ;
        dc.l    $ffff55fb,0,'TRAP','CS.L',typ22 ;
        dc.l    $ffff56fb,0,'TRAP','NE.L',typ22 ;
        dc.l    $ffff57fb,0,'TRAP','EQ.L',typ22 ;
        dc.l    $ffff58fb,0,'TRAP','VC.L',typ22 ;
        dc.l    $ffff59fb,0,'TRAP','VS.L',typ22 ;
        dc.l    $ffff5afb,0,'TRAP','PL.L',typ22 ;
        dc.l    $ffff5bfb,0,'TRAP','MI.L',typ22 ;
        dc.l    $ffff5cfb,0,'TRAP','GE.L',typ22 ;
        dc.l    $ffff5dfb,0,'TRAP','LT.L',typ22 ;
        dc.l    $ffff4efb,0,'TRAP','GT.L',typ22 ;
        dc.l    $ffff4ffb,0,'TRAP','LE.L',typ22 ;
        dc.l    $ffff023c,0,'ANDI','    ',typ45a ; ANDI #byte,CCR
        dc.l    $ffff027c,0,'ANDI','    ',typ45b ; ANDI #wort,SR
        dc.l    $ffff0a3c,0,'EORI','    ',typ45c ; EORI #byte,CCR
        dc.l    $ffff0a7c,0,'EORI','    ',typ45d ; EORI #wort,SR
        dc.l    $ffff003c,0,'ORI ','    ',typ45e ; ORI  #byte,CCR
        dc.l    $ffff007c,0,'ORI ','    ',typ45f ; ORI  #wort,SR
                           ; LPSTOP Typ 23 -> Typ 59 TBLxx
        dc.l    $fff84848,0,'BKPT','    ',typ24a ; 1 Wort mit 3-bit-Code
        dc.l    $fff04e40,0,'TRAP','    ',typ24b ; 1 Wort mit 4-bit-Code
        dc.l    $fff84880,0,'EXT.','W   ',typ25 ; 1 Wort Dn
        dc.l    $fff848c0,0,'EXT.','L   ',typ25 ;
        dc.l    $fff849c0,0,'EXTB','.L  ',typ25 ;
        dc.l    $fff84840,0,'SWAP','    ',typ25 ;
        dc.l    $fff84e58,0,'UNLK','    ',typ25 ; Typ 26 -> typ 25 Wort An
        dc.l    $fff84e50,0,'LINK','.W  ',typ27 ; 1 Wort An + Wortkonstante
        dc.l    $fff84808,0,'LINK','.L  ',typ28 ; 1 Wort An + Langwortkonst.
        dc.l    $f1007000,0,'MOVE','Q   ',typ29 ; 1 Wort Dn mit Bytekonstante
        dc.l    $f1f8c140,0,'EXG ','    ',typ30a ; EXG Dn,Dn
        dc.l    $f1f8c148,0,'EXG ','    ',typ30b ; EXG An,An
        dc.l    $f1f8c188,0,'EXG ','    ',typ30a ; EXG Dn,An Typ 30c -> 30a
        dc.l    $ffff4e7a,0,'MOVE','C   ',typ31a ; MOVEC Rc,Rn
        dc.l    $ffff4e7b,0,'MOVE','C   ',typ31b ; MOVEC Rn,Rc
        dc.l    $f1f8b108,0,'CMPM','.B  ',typ32  ; CMPM.B (Ay)+,(Ax)+
        dc.l    $f1f8b148,0,'CMPM','.W  ',typ32  ; CMPM.W
        dc.l    $f1f8b188,0,'CMPM','.L  ',typ32  ; CMPM.L
        dc.l    $f1f8c100,0,'ABCD','    ',typ33a ; ABCD Dx,Dy
        dc.l    $f1f8c108,0,'ABCD','    ',typ33b ; ABCD -(Ax),-(Ay)
        dc.l    $f1f88100,0,'SBCD','    ',typ33a ; SBCD Dx,Dy
        dc.l    $f1f88108,0,'SBCD','    ',typ33b ; SBCD -(Ax),-(Ay)
        dc.l    $f1f8d100,0,'ADDX','.B  ',typ33a ; ADDX.B Dx,Dy
        dc.l    $f1f8d108,0,'ADDX','.B  ',typ33b ; ADDX.B -(Ax),-(Ay)
        dc.l    $f1f8d140,0,'ADDX','.W  ',typ33a ; ADDX.W Dx,Dy
        dc.l    $f1f8d148,0,'ADDX','.W  ',typ33b ; ADDX.W -(Ax),-(Ay)
        dc.l    $f1f8d180,0,'ADDX','.L  ',typ33a ; ADDX.L Dx,Dy
        dc.l    $f1f8d188,0,'ADDX','.L  ',typ33b ; ADDX.L -(Ax),-(Ay)
        dc.l    $f1f89100,0,'SUBX','.B  ',typ33a ; SUBX.B Dx,Dy
        dc.l    $f1f89108,0,'SUBX','.B  ',typ33b ; SUBX.B -(Ax),-(Ay)
        dc.l    $f1f89140,0,'SUBX','.W  ',typ33a ; SUBX.W Dx,Dy
        dc.l    $f1f89148,0,'SUBX','.W  ',typ33b ; SUBX.W -(Ax),-(Ay)
        dc.l    $f1f89180,0,'SUBX','.L  ',typ33a ; SUBX.L Dx,Dy
        dc.l    $f1f89188,0,'SUBX','.L  ',typ33b ; SUBX.L -(Ax),-(Ay)
        dc.l    $ffff6000,0,'BRA.','W   ',typ35  ; BRA.W Wortabstand BRA
        dc.l    $ffff6100,0,'BSR.','W   ',typ35  ; BSR.W
        dc.l    $ffff6200,0,'BHI.','W   ',typ35  ; BHI.W
        dc.l    $ffff6300,0,'BLS.','W   ',typ35  ; BLS.W 
        dc.l    $ffff6400,0,'BCC.','W   ',typ35  ; BCC.W
        dc.l    $ffff6500,0,'BCS.','W   ',typ35  ; BCS.W
        dc.l    $ffff6600,0,'BNE.','W   ',typ35  ; BNE.W
        dc.l    $ffff6700,0,'BEQ.','W   ',typ35  ; BEQ.W
        dc.l    $ffff6800,0,'BVC.','W   ',typ35  ; BVC.W 
        dc.l    $ffff6900,0,'BVS.','W   ',typ35  ; BVS.W
        dc.l    $ffff6a00,0,'BPL.','W   ',typ35  ; BPL.W
        dc.l    $ffff6b00,0,'BMI.','W   ',typ35  ; BMI.W 
        dc.l    $ffff6c00,0,'BGE.','W   ',typ35  ; BGE.W
        dc.l    $ffff6d00,0,'BLT.','W   ',typ35  ; BLT.W
        dc.l    $ffff6e00,0,'BGT.','W   ',typ35  ; BGT.W
        dc.l    $ffff6f00,0,'BLE.','W   ',typ35  ; BLE.W
        dc.l    $ffff60ff,0,'BRA.','L   ',typ36  ; BRA.L Langabstand
        dc.l    $ffff61ff,0,'BSR.','L   ',typ36  ; BSR.L
        dc.l    $ffff62ff,0,'BHI.','L   ',typ36  ; BHI.L
        dc.l    $ffff63ff,0,'BLS.','L   ',typ36  ; BLS.L 
        dc.l    $ffff64ff,0,'BCC.','L   ',typ36  ; BCC.L
        dc.l    $ffff65ff,0,'BCS.','L   ',typ36  ; BCS.L
        dc.l    $ffff66ff,0,'BNE.','L   ',typ36  ; BNE.L
        dc.l    $ffff67ff,0,'BEQ.','L   ',typ36  ; BEQ.L
        dc.l    $ffff68ff,0,'BVC.','L   ',typ36  ; BVC.L 
        dc.l    $ffff69ff,0,'BVS.','L   ',typ36  ; BVS.L
        dc.l    $ffff6aff,0,'BPL.','L   ',typ36  ; BPL.L
        dc.l    $ffff6bff,0,'BMI.','L   ',typ36  ; BMI.L 
        dc.l    $ffff6cff,0,'BGE.','L   ',typ36  ; BGE.L
        dc.l    $ffff6dff,0,'BLT.','L   ',typ36  ; BLT.L
        dc.l    $ffff6eff,0,'BGT.','L   ',typ36  ; BGT.L
        dc.l    $ffff6fff,0,'BLE.','L   ',typ36  ; BLE.L
        dc.l    $ff006000,0,'BRA.','B   ',typ37  ; BRA.B Byteabstand
        dc.l    $ff006100,0,'BSR.','B   ',typ37  ; BSR.B
        dc.l    $ff006200,0,'BHI.','B   ',typ37  ; BHI.B
        dc.l    $ff006300,0,'BLS.','B   ',typ37  ; BLS.B 
        dc.l    $ff006400,0,'BCC.','B   ',typ37  ; BCC.B
        dc.l    $ff006500,0,'BCS.','B   ',typ37  ; BCS.B
        dc.l    $ff006600,0,'BNE.','B   ',typ37  ; BNE.B
        dc.l    $ff006700,0,'BEQ.','B   ',typ37  ; BEQ.B
        dc.l    $ff006800,0,'BVC.','B   ',typ37  ; BVC.B 
        dc.l    $ff006900,0,'BVS.','B   ',typ37  ; BVS.B
        dc.l    $ff006a00,0,'BPL.','B   ',typ37  ; BPL.B
        dc.l    $ff006b00,0,'BMI.','B   ',typ37  ; BMI.B 
        dc.l    $ff006c00,0,'BGE.','B   ',typ37  ; BGE.B
        dc.l    $ff006d00,0,'BLT.','B   ',typ37  ; BLT.B
        dc.l    $ff006e00,0,'BGT.','B   ',typ37  ; BGT.B
        dc.l    $ff006f00,0,'BLE.','B   ',typ37  ; BLE.B
        dc.l    $fff850c8,0,'DBT ','    ',typ38  ; DBT
        dc.l    $fff851c8,0,'DBRA','    ',typ38  ; DBRA
        dc.l    $fff852c8,0,'DBHI','    ',typ38  ; DBHI
        dc.l    $fff853c8,0,'DBLS','    ',typ38  ; DBLS   
        dc.l    $fff854c8,0,'DBCC','    ',typ38  ; DBCC
        dc.l    $fff855c8,0,'DBCS','    ',typ38  ; DBCS
        dc.l    $fff856c8,0,'DBNE','    ',typ38  ; DBNE
        dc.l    $fff857c8,0,'DBEQ','    ',typ38  ; DBEQ
        dc.l    $fff858c8,0,'DBVC','    ',typ38  ; DBVC 
        dc.l    $fff859c8,0,'DBVS','    ',typ38  ; DBVS
        dc.l    $fff85ac8,0,'DBPL','    ',typ38  ; DBPL
        dc.l    $fff85bc8,0,'DBMI','    ',typ38  ; DBMI 
        dc.l    $fff85cc8,0,'DBGE','    ',typ38  ; DBGE
        dc.l    $fff85dc8,0,'DBLT','    ',typ38  ; DBLT
        dc.l    $fff85ec8,0,'DBGT','    ',typ38  ; DBGT
        dc.l    $fff85fc8,0,'DBLE','    ',typ38  ; DBLE
        dc.l    $f1f80108,0,'MOVE','P.W ',typ55a     ; MOVEP.W w(an),dn
        dc.l    $f1f80148,0,'MOVE','P.L ',typ55a     ; MOVEP.L 
        dc.l    $f1f80188,0,'MOVE','P.W ',typ55b     ; MOVEP.W dn,w(an)
        dc.l    $f1f801c8,0,'MOVE','P.L ',typ55b     ; MOVEP.L
        dc.l    $f1f8e000,0,'ASR.','B   ',typ49a ; ASR.B #kon,Dn
        dc.l    $f1f8e020,0,'ASR.','B   ',typ49b ; ASR.B   Dx,Dn
        dc.l    $f1f8e100,0,'ASL.','B   ',typ49a ; ASL.B #kon,Dn
        dc.l    $f1f8e120,0,'ASL.','B   ',typ49b ; ASL.B   Dx,Dn
        dc.l    $f1f8e040,0,'ASR.','W   ',typ49a ; ASR.W #kon,Dn
        dc.l    $f1f8e060,0,'ASR.','W   ',typ49b ; ASR.W   Dx,Dn
        dc.l    $f1f8e140,0,'ASL.','W   ',typ49a ; ASL.W #kon,Dn
        dc.l    $f1f8e160,0,'ASL.','W   ',typ49b ; ASL.W   Dx,Dn
        dc.l    $f1f8e080,0,'ASR.','L   ',typ49a ; ASR.L #kon,Dn
        dc.l    $f1f8e0a0,0,'ASR.','L   ',typ49b ; ASR.L   Dx,Dn
        dc.l    $f1f8e180,0,'ASL.','L   ',typ49a ; ASL.L #kon,Dn
        dc.l    $f1f8e1a0,0,'ASL.','L   ',typ49b ; ASL.L   Dx,Dn
        dc.l    $f1f8e008,0,'LSR.','B   ',typ49a ; LSR.B #kon,Dn
        dc.l    $f1f8e028,0,'LSR.','B   ',typ49b ; LSR.B   Dx,Dn
        dc.l    $f1f8e108,0,'LSL.','B   ',typ49a ; LSL.B #kon,Dn
        dc.l    $f1f8e128,0,'LSL.','B   ',typ49b ; LSL.B   Dx,Dn
        dc.l    $f1f8e048,0,'LSR.','W   ',typ49a ; LSR.W #kon,Dn
        dc.l    $f1f8e068,0,'LSR.','W   ',typ49b ; LSR.W   Dx,Dn
        dc.l    $f1f8e148,0,'LSL.','W   ',typ49a ; LSL.W #kon,Dn
        dc.l    $f1f8e168,0,'LSL.','W   ',typ49b ; LSL.W   Dx,Dn
        dc.l    $f1f8e088,0,'LSR.','L   ',typ49a ; LSR.L #kon,Dn
        dc.l    $f1f8e0a8,0,'LSR.','L   ',typ49b ; LSR.L   Dx,Dn
        dc.l    $f1f8e188,0,'LSL.','L   ',typ49a ; LSL.L #kon,Dn
        dc.l    $f1f8e1a8,0,'LSL.','L   ',typ49b ; LSL.L   Dx,Dn
        dc.l    $f1f8e010,0,'ROXR','.B  ',typ49a ; ROXR.B #kon,Dn
        dc.l    $f1f8e030,0,'ROXR','.B  ',typ49b ; ROXR.B   Dx,Dn
        dc.l    $f1f8e110,0,'ROXL','.B  ',typ49a ; ROXL.B #kon,Dn
        dc.l    $f1f8e130,0,'ROXL','.B  ',typ49b ; ROXL.B   Dx,Dn
        dc.l    $f1f8e050,0,'ROXR','.W  ',typ49a ; ROXR.W #kon,Dn
        dc.l    $f1f8e070,0,'ROXR','.W  ',typ49b ; ROXR.W   Dx,Dn
        dc.l    $f1f8e150,0,'ROXL','.W  ',typ49a ; ROXL.W #kon,Dn
        dc.l    $f1f8e170,0,'ROXL','.W  ',typ49b ; ROXL.W   Dx,Dn
        dc.l    $f1f8e090,0,'ROXR','.L  ',typ49a ; ROXR.L #kon,Dn
        dc.l    $f1f8e0b0,0,'ROXR','.L  ',typ49b ; ROXR.L   Dx,Dn
        dc.l    $f1f8e190,0,'ROXL','.L  ',typ49a ; ROXL.L #kon,Dn
        dc.l    $f1f8e1b0,0,'ROXL','.L  ',typ49b ; ROXL.L   Dx,Dn
        dc.l    $f1f8e018,0,'ROR.','B   ',typ49a ; ROR.B #kon,Dn
        dc.l    $f1f8e038,0,'ROR.','B   ',typ49b ; ROR.B   Dx,Dn
        dc.l    $f1f8e118,0,'ROL.','B   ',typ49a ; ROL.B #kon,Dn
        dc.l    $f1f8e138,0,'ROL.','B   ',typ49b ; ROL.B   Dx,Dn
        dc.l    $f1f8e058,0,'ROR.','W   ',typ49a ; ROR.W #kon,Dn
        dc.l    $f1f8e078,0,'ROR.','W   ',typ49b ; ROR.W   Dx,Dn
        dc.l    $f1f8e158,0,'ROL.','W   ',typ49a ; ROL.W #kon,Dn
        dc.l    $f1f8e178,0,'ROL.','W   ',typ49b ; ROL.W   Dx,Dn
        dc.l    $f1f8e098,0,'ROR.','L   ',typ49a ; ROR.L #kon,Dn
        dc.l    $f1f8e0b8,0,'ROR.','L   ',typ49b ; ROR.L   Dx,Dn
        dc.l    $f1f8e198,0,'ROL.','L   ',typ49a ; ROL.L #kon,Dn
        dc.l    $f1f8e1b8,0,'ROL.','L   ',typ49b ; ROL.L   Dx,Dn
        dc.l    $ffc04880,$01f4,'MOVE','M.W ',typ57a ; MOVEM.W liste,<>
        dc.l    $ffc048c0,$01f4,'MOVE','M.L ',typ57a ;      .L
        dc.l    $ffc04c80,$07ec,'MOVE','M.W ',typ57b ; MOVEM.W <>,liste
        dc.l    $ffc04cc0,$07ec,'MOVE','M.L ',typ57b ;      .L
        dc.l    $ffc00e00,$01fc,'MOVE','S.B ',typ56  ; MOVES.B + Erweit.
        dc.l    $ffc00e40,$01fc,'MOVE','S.W ',typ56  ; MOVES.W 
        dc.l    $ffc00e80,$01fc,'MOVE','S.L ',typ56  ; MOVES.L
        dc.l    $ffc04a40,$0fff,'TST.','W   ',typ40  ; TST Typ 1 alle
        dc.l    $ffc04a80,$0fff,'TST.','L   ',typ40  ; TST Typ 1 alle
        dc.l    $ffc04a00,$0ffd,'TST.','B   ',typ40  ; TST Typ 2 /An  
        dc.l    $ffc0e0c0,$01fc,'ASR ','    ',typ40  ; ASR Typ 3 /Dn/An/#/PC
        dc.l    $ffc0e1c0,$01fc,'ASL ','    ',typ40  ; ASL
        dc.l    $ffc0e2c0,$01fc,'LSR ','    ',typ40  ; LSR Typ 3 /Dn/An/#/PC
        dc.l    $ffc0e3c0,$01fc,'LSL ','    ',typ40  ; LSL
        dc.l    $ffc0e4c0,$01fc,'ROXR','    ',typ40  ; ROXR Typ 3 /Dn/An/#/PC
        dc.l    $ffc0e5c0,$01fc,'ROXL','    ',typ40  ; ROXL
        dc.l    $ffc0e6c0,$01fc,'ROR ','    ',typ40  ; ROR Typ 3 /Dn/An/#/PC
        dc.l    $ffc0e7c0,$01fc,'ROL ','    ',typ40  ; ROL
        dc.l    $ffc04200,$01fd,'CLR.','B   ',typ40  ; CLR Typ 4 /An/#/PC
        dc.l    $ffc04240,$01fd,'CLR.','W   ',typ40  ; CLR Typ 4 /An/#/PC 
        dc.l    $ffc04280,$01fd,'CLR.','L   ',typ40  ; CLR Typ 4 /An/#/PC 
        dc.l    $ffc04800,$01fd,'NBCD','L   ',typ40  ; NBCD Typ 4 /An/#/PC  
        dc.l    $ffc04400,$01fd,'NEG.','B   ',typ40  ; NEG Typ 4 /An/#/PC
        dc.l    $ffc04440,$01fd,'NEG.','W   ',typ40  ; NEG Typ 4 /An/#/PC 
        dc.l    $ffc04480,$01fd,'NEG.','L   ',typ40  ; NEG Typ 4 /An/#/PC 
        dc.l    $ffc04000,$01fd,'NEGX','.B  ',typ40  ; NEGX Typ 4 /An/#/PC
        dc.l    $ffc04040,$01fd,'NEGX','.W  ',typ40  ; NEGX Typ 4 /An/#/PC 
        dc.l    $ffc04080,$01fd,'NEGX','.L  ',typ40  ; NEGX Typ 4 /An/#/PC 
        dc.l    $ffc04600,$01fd,'NOT.','B   ',typ40  ; NOT Typ 4 /An/#/PC
        dc.l    $ffc04640,$01fd,'NOT.','W   ',typ40  ; NOT Typ 4 /An/#/PC 
        dc.l    $ffc04680,$01fd,'NOT.','L   ',typ40  ; NOT Typ 4 /An/#/PC 
        dc.l    $ffc04ac0,$01fd,'TAS ','    ',typ40  ; TAS Typ 4 /An/#/PC 
        dc.l    $ffc050c0,$01fd,'ST  ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc051c0,$01fd,'SF  ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc052c0,$01fd,'SHI ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc053c0,$01fd,'SLS ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc054c0,$01fd,'SCC ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc055c0,$01fd,'SCS ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc056c0,$01fd,'SNE ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc057c0,$01fd,'SEQ ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc058c0,$01fd,'SVC ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc059c0,$01fd,'SVS ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc05ac0,$01fd,'SPL ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc05bc0,$01fd,'SMI ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc05cc0,$01fd,'SGE ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc05dc0,$01fd,'SLT ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc05ec0,$01fd,'SGT ','    ',typ40  ; Scc Typ 4 /An/#/PC
        dc.l    $ffc05fc0,$01fd,'SLE ','    ',typ40  ; Scc Typ 4 /An/#/PC 
        dc.l    $ffc04ec0,$07e4,'JMP ','    ',typ40  ; JMP Typ 6 /Dn/An/A+/-A/#
        dc.l    $ffc04e80,$07e4,'JSR ','    ',typ40  ; JSR Typ 6 /Dn/An/A+/-A/#  
        dc.l    $ffc04840,$07e4,'PEA ','    ',typ40  ; PEA Typ 6 /Dn/An/A+/-A/#  
        dc.l    $f1c0b100,$01fd,'EOR.','B   ',typ41  ; EOR.B Typ4 /An/#/PC
        dc.l    $f1c0b140,$01fd,'EOR.','W   ',typ41  ; EOR.W
        dc.l    $f1c0b180,$01fd,'EOR.','L   ',typ41  ; EOR.L
        dc.l    $f1c0d0c0,$0fff,'ADDA','.W  ',typ42  ; ADDA.W Typ 1 alle
        dc.l    $f1c0b0c0,$0fff,'CMPA','.W  ',typ42  ; CMPA
        dc.l    $f1c03040,$0fff,'MOVE','A.W ',typ42  ; MOVEA
        dc.l    $f1c090c0,$0fff,'SUBA','.W  ',typ42  ; SUBA
        dc.l    $f1c041c0,$07e4,'LEA ','    ',typ42  ; LEA Typ 6 /Dn/An/+A/A-/#
        dc.l    $f1c0d1c0,$0fff,'ADDA','.L  ',typ43  ; ADDA.L Typ 1 alle
        dc.l    $f1c0b1c0,$0fff,'CMPA','.L  ',typ43  ; CMPA
        dc.l    $f1c02040,$0fff,'MOVE','A.L ',typ43  ; MOVEA
        dc.l    $f1c091c0,$0fff,'SUBA','.L  ',typ43  ; SUBA
        dc.l    $f1c05000,$01fd,'ADDQ','.B  ',typ44  ; ADDQ.B Typ 4 /An/#/PC
        dc.l    $f1c05100,$01fd,'SUBQ','.B  ',typ44  ; SUBQ.B
        dc.l    $f1c05040,$01ff,'ADDQ','.W  ',typ44  ; ADDQ.W typ 9 /#/PC
        dc.l    $f1c05080,$01ff,'ADDQ','.L  ',typ44  ; ADDQ.L
        dc.l    $f1c05140,$01ff,'SUBQ','.W  ',typ44  ; SUBQ.W
        dc.l    $f1c05180,$01ff,'SUBQ','.L  ',typ44  ; SUBQ.L
        dc.l    $ffc00600,$01fd,'ADDI','.B  ',typ46a ; ADDI.B typ4 /An/#/PC
        dc.l    $ffc00640,$01fd,'ADDI','.W  ',typ46b ; ADDI.W typ4
        dc.l    $ffc00680,$01fd,'ADDI','.L  ',typ46c ; ADDI.L typ4
        dc.l    $ffc00200,$01fd,'ANDI','.B  ',typ46a ; ANDI.B typ4 /An/#/PC
        dc.l    $ffc00240,$01fd,'ANDI','.W  ',typ46b ; ANDI.W typ4
        dc.l    $ffc00280,$01fd,'ANDI','.L  ',typ46c ; ANDI.L typ4
        dc.l    $ffc00a00,$01fd,'EORI','.B  ',typ46a ; EORI.B typ4 /An/#/PC
        dc.l    $ffc00a40,$01fd,'EORI','.W  ',typ46b ; EORI.W typ4
        dc.l    $ffc00a80,$01fd,'EORI','.L  ',typ46c ; EORI.L typ4
        dc.l    $ffc00000,$01fd,'ORI.','B   ',typ46a ; ORI.B typ4 /An/#/PC
        dc.l    $ffc00040,$01fd,'ORI.','W   ',typ46b ; ORI.W typ4
        dc.l    $ffc00080,$01fd,'ORI.','L   ',typ46c ; ORI.L typ4
        dc.l    $ffc00400,$01fd,'SUBI','.B  ',typ46a ; SUBI.B typ4 /An/#/PC
        dc.l    $ffc00440,$01fd,'SUBI','.W  ',typ46b ; SUBI.W typ4
        dc.l    $ffc00480,$01fd,'SUBI','.L  ',typ46c ; SUBI.L typ4
        dc.l    $ffc00c00,$07fd,'CMPI','.B  ',typ46a ; CMPI.B typ5 /An/#
        dc.l    $ffc00c40,$07fd,'CMPI','.W  ',typ46b ; CMPI.W typ5
        dc.l    $ffc00c80,$07fd,'CMPI','.L  ',typ46c ; CMPI.L typ5
        dc.l    $f1c04180,$0ffd,'CHK.','W   ',typ47a ; CHK.W typ2
        dc.l    $f1c04100,$0ffd,'CHK.','L   ',typ47b ; CHK.L typ2
        dc.l    $f1c0b000,$0ffd,'CMP.','B   ',typ47  ; CMP.B typ2
        dc.l    $f1c0b040,$0fff,'CMP.','W   ',typ47  ; CMP.W typ1
        dc.l    $f1c0b080,$0fff,'CMP.','L   ',typ47  ; CMP.L typ1 
        dc.l    $f1c081c0,$0ffd,'DIVS','.W  ',typ47a ; DIVS.W typ2 
        dc.l    $f1c080c0,$0ffd,'DIVU','.W  ',typ47a ; DIVU.W typ2     
        dc.l    $f1c0c1c0,$0ffd,'MULS','.W  ',typ47a ; MULS.W typ2     
        dc.l    $f1c0c0c0,$0ffd,'MULU','.W  ',typ47a ; MULU.W typ2
        dc.l    $f1c0d000,$0ffd,'ADD.','B   ',typ48a ; ADD.B <>,Dn typ2
        dc.l    $f1c0d100,$01fc,'ADD.','B   ',typ48b ; ADD.B Dn,<> typ3
        dc.l    $f1c0d040,$0fff,'ADD.','W   ',typ48a ; ADD.W <>,Dn typ1
        dc.l    $f1c0d140,$01fc,'ADD.','W   ',typ48b ; ADD.W Dn,<> typ3
        dc.l    $f1c0d080,$0fff,'ADD.','L   ',typ48a ; ADD.L <>,Dn typ1
        dc.l    $f1c0d180,$01fc,'ADD.','L   ',typ48b ; ADD.L Dn,<> typ3
        dc.l    $f1c0c000,$0ffd,'AND.','B   ',typ48a ; AND.B <>,Dn typ2
        dc.l    $f1c0c100,$01fc,'AND.','B   ',typ48b ; AND.B Dn,<> typ3
        dc.l    $f1c0c040,$0fff,'AND.','W   ',typ48a ; AND.W <>,Dn typ1
        dc.l    $f1c0c140,$01fc,'AND.','W   ',typ48b ; AND.W Dn,<> typ3
        dc.l    $f1c0c080,$0fff,'AND.','L   ',typ48a ; AND.L <>,Dn typ1
        dc.l    $f1c0c180,$01fc,'AND.','L   ',typ48b ; AND.L Dn,<> typ3
        dc.l    $f1c08000,$0ffd,'OR.B','    ',typ48a ; OR.B <>,Dn typ2
        dc.l    $f1c08100,$01fc,'OR.B','    ',typ48b ; OR.B Dn,<> typ3
        dc.l    $f1c08040,$0fff,'OR.W','    ',typ48a ; OR.W <>,Dn typ1
        dc.l    $f1c08140,$01fc,'OR.W','    ',typ48b ; OR.W Dn,<> typ3
        dc.l    $f1c08080,$0fff,'OR.L','    ',typ48a ; OR.L <>,Dn typ1
        dc.l    $f1c08180,$01fc,'OR.L','    ',typ48b ; OR.L Dn,<> typ3
        dc.l    $f1c09000,$0ffd,'SUB.','B   ',typ48a ; SUB.B <>,Dn typ2
        dc.l    $f1c09100,$01fc,'SUB.','B   ',typ48b ; SUB.B Dn,<> typ3
        dc.l    $f1c09040,$0fff,'SUB.','W   ',typ48a ; SUB.W <>,Dn typ1
        dc.l    $f1c09140,$01fc,'SUB.','W   ',typ48b ; SUB.W Dn,<> typ3
        dc.l    $f1c09080,$0fff,'SUB.','L   ',typ48a ; SUB.L <>,Dn typ1
        dc.l    $f1c09180,$01fc,'SUB.','L   ',typ48b ; SUB.L Dn,<> typ3
        dc.l    $f1c00100,$0ffd,'BTST','    ',typ50a ; BTST Dn,<> typ2
        dc.l    $ffc00800,$07fd,'BTST','    ',typ50b ; BTST #k,<> typ5
        dc.l    $f1c00140,$01fd,'BCHG','    ',typ50a ; BCHG Dn,<> typ4
        dc.l    $ffc00840,$01fd,'BCHG','    ',typ50b ; BCHG #k,<> typ4
        dc.l    $f1c00180,$01fd,'BCLR','    ',typ50a ; BCLR Dn,<> typ4
        dc.l    $ffc00880,$01fd,'BCLR','    ',typ50b ; BCLR #k,<> typ4
        dc.l    $f1c001c0,$01fd,'BSET','    ',typ50a ; BSET Dn,<> typ4
        dc.l    $ffc008c0,$01fd,'BSET','    ',typ50b ; BSET #k,<> typ4
        dc.l    $ffc042c0,$01fd,'MOVE','    ',typ52a ; MOVE CCR,<> typ4
        dc.l    $ffc044c0,$0ffd,'MOVE','    ',typ52b ; MOVE <>,CCR typ2
        dc.l    $ffc040c0,$01fd,'MOVE','    ',typ52c ; MOVE SR,<> typ4
        dc.l    $ffc046c0,$0ffd,'MOVE','    ',typ52d ; MOVE <>,SR typ2
        dc.l    $fff84e68,0,'MOVE','    ',typ52e     ; MOVE USP,An 
        dc.l    $fff84e60,0,'MOVE','    ',typ52f     ; MOVE An,USP
* Sonderflle Behandlung vor Symbolausgabe Marke neg. zul. <effa>
        dc.l    $ffc000c0,$800007e4,'CHK2','.B  ',typ51 ; CHK2/CMP2 typ6,Rn
        dc.l    $ffc002c0,$800007e4,'CHK2','.W  ',typ51 ; 
        dc.l    $ffc004c0,$800007e4,'CHK2','.L  ',typ51 ;
        dc.l    $ffc04c40,$80000ffd,'DIVx','.x  ',typ58a ; DIVx.x <>,D..typ2
        dc.l    $ffc04c00,$80000ffd,'MULx','.L  ',typ58b ; MULx.L <>,D..typ2
        dc.l    $ffc0f800,$800007e4,'TBLx','.x  ',typ59  ; TBLS/LPSTOP  typ6    
        dc.l    $f0001000,$80000ffd,'MOVE','.B  ',typ53a ; MOVE.B typ2,typ4
        dc.l    $f0003000,$80000fff,'MOVE','.W  ',typ53b ; MOVE.W typ1,typ9
        dc.l    $f0002000,$80000fff,'MOVE','.L  ',typ53c ; MOVE.L typ1,typ9
        dc.l    $0                                   ; Endemarke
* Liste der vordefinierten Bezeichner fr Systemregister
sytab   dc.l          $FFFFFA00
        dc.b          'SIMCR',0 
        dc.l          $FFFFFA04
        dc.b          'SYNCR',0
        dc.l          $FFFFFA07
        dc.b          'RSR',0 
        dc.l          $FFFFFA11
        dc.b          'PORTE0',0
        dc.l          $FFFFFA13
        dc.b          'PORTE1',0
        dc.l          $FFFFFA15
        dc.b          'DDRE',0 
        dc.l          $FFFFFA17
        dc.b          'PEPAR',0
        dc.l          $FFFFFA19
        dc.b          'PORTF0',0
        dc.l          $FFFFFA1B
        dc.b          'PORTF1',0
        dc.l          $FFFFFA1D
        dc.b          'DDRF',0
        dc.l          $FFFFFA1F
        dc.b          'PFPAR',0
        dc.l          $FFFFFA21
        dc.b          'SYPCR',0 
        dc.l          $FFFFFA22
        dc.b          'PICR',0
        dc.l          $FFFFFA24
        dc.b          'PITR',0 
        dc.l          $FFFFFA27
        dc.b          'SWSR',0  
        dc.l          $FFFFFA41
        dc.b          'PORTC',0 
        dc.l          $FFFFFA44
        dc.b          'CSPAR0',0 
        dc.l          $FFFFFA46
        dc.b          'CSPAR1',0   
        dc.l          $FFFFFA48
        dc.b          'CSBARBT',0
        dc.l          $FFFFFA4A
        dc.b          'CSORBT',0
        dc.l          $FFFFFA4C
        dc.b          'CSBAR0',0
        dc.l          $FFFFFA4E
        dc.b          'CSOR0',0 
        dc.l          $FFFFFA50
        dc.b          'CSBAR1',0
        dc.l          $FFFFFA52
        dc.b          'CSOR1',0
        dc.l          $FFFFFA54
        dc.b          'CSBAR2',0 
        dc.l          $FFFFFA56
        dc.b          'CSOR2',0
        dc.l          $FFFFFA58
        dc.b          'CSBAR3',0
        dc.l          $FFFFFA5A
        dc.b          'CSOR3',0 
        dc.l          $FFFFFA5C
        dc.b          'CSBAR4',0 
        dc.l          $FFFFFA5E
        dc.b          'CSOR4',0
        dc.l          $FFFFFA60
        dc.b          'CSBAR5',0
        dc.l          $FFFFFA62
        dc.b          'CSOR5',0  
        dc.l          $FFFFFA64
        dc.b          'CSBAR6',0 
        dc.l          $FFFFFA66
        dc.b          'CSOR6',0
        dc.l          $FFFFFA68
        dc.b          'CSBAR7',0
        dc.l          $FFFFFA6A
        dc.b          'CSOR7',0
        dc.l          $FFFFFA6C
        dc.b          'CSBAR8',0
        dc.l          $FFFFFA6E
        dc.b          'CSOR8',0
        dc.l          $FFFFFA70
        dc.b          'CSBAR9',0
        dc.l          $FFFFFA72
        dc.b          'CSOR9',0
        dc.l          $FFFFFA74
        dc.b          'CSBAR10',0
        dc.l          $FFFFFA76
        dc.b          'CSOR10',0
        dc.l          $FFFFFB00
        dc.b          'TRAMMCR',0
        dc.l          $FFFFFB04
        dc.b          'TRAMBAR',0
        dc.l          $FFFFFC00
        dc.b          'QSMCR',0
        dc.l          $FFFFFC04
        dc.b          'QILR',0
        dc.l          $FFFFFC05
        dc.b          'QIVR',0
        dc.l          $FFFFFC08
        dc.b          'SCCR0',0
        dc.l          $FFFFFC0A
        dc.b          'SCCR1',0
        dc.l          $FFFFFC0C
        dc.b          'SCSR',0
        dc.l          $FFFFFC0C
        dc.b          'SCSRH',0 
        dc.l          $FFFFFC0D
        dc.b          'SCSRL',0
        dc.l          $FFFFFC0E
        dc.b          'SCDR',0
        dc.l          $FFFFFC0F
        dc.b          'SCDRL',0
        dc.l          $FFFFFC15
        dc.b          'PORTQS',0
        dc.l          $FFFFFC16
        dc.b          'PQSPAR',0
        dc.l          $FFFFFC17
        dc.b          'DDRQS',0
        dc.l          $FFFFFC18
        dc.b          'SPCR0',0
        dc.l          $FFFFFC1A
        dc.b          'SPCR1',0
        dc.l          $FFFFFC1C
        dc.b          'SPCR2',0
        dc.l          $FFFFFC1E
        dc.b          'SPCR3',0
        dc.l          $FFFFFC1F
        dc.b          'SPSR',0
        dc.l          $FFFFFD00
        dc.b          'RR0',0
        dc.l          $FFFFFD20
        dc.b          'TR0',0
        dc.l          $FFFFFD40
        dc.b          'CR0',0
        dc.l          $FFFFFD02
        dc.b          'RR1',0 
        dc.l          $FFFFFD22
        dc.b          'TR1',0
        dc.l          $FFFFFD41
        dc.b          'CR1',0
        dc.l          $FFFFFD04
        dc.b          'RR2',0
        dc.l          $FFFFFD24
        dc.b          'TR2',0
        dc.l          $FFFFFD42
        dc.b          'CR2',0
        dc.l          $FFFFFD06
        dc.b          'RR3',0
        dc.l          $FFFFFD26
        dc.b          'TR3',0
        dc.l          $FFFFFD43
        dc.b          'CR3',0
        dc.l          $FFFFFD08
        dc.b          'RR4',0
        dc.l          $FFFFFD28
        dc.b          'TR4',0
        dc.l          $FFFFFD44
        dc.b          'CR4',0
        dc.l          $FFFFFD0A
        dc.b          'RR5',0
        dc.l          $FFFFFD2A
        dc.b          'TR5',0
        dc.l          $FFFFFD45
        dc.b          'CR5',0
        dc.l          $FFFFFD0C
        dc.b          'RR6',0
        dc.l          $FFFFFD2C
        dc.b          'TR6',0
        dc.l          $FFFFFD46
        dc.b          'CR6',0
        dc.l          $FFFFFD0E
        dc.b          'RR7',0
        dc.l          $FFFFFD2E
        dc.b          'TR7',0
        dc.l          $FFFFFD47
        dc.b          'CR7',0
        dc.l          $FFFFFD10
        dc.b          'RR8',0
        dc.l          $FFFFFD20
        dc.b          'TR8',0
        dc.l          $FFFFFD48
        dc.b          'CR8',0
        dc.l          $FFFFFD12
        dc.b          'RR9',0
        dc.l          $FFFFFD32
        dc.b          'TR9',0
        dc.l          $FFFFFD49
        dc.b          'CR9',0
        dc.l          $FFFFFD14
        dc.b          'RRA',0
        dc.l          $FFFFFD34
        dc.b          'TRA',0
        dc.l          $FFFFFD4A
        dc.b          'CRA',0
        dc.l          $FFFFFD16
        dc.b          'RRB',0
        dc.l          $FFFFFD36
        dc.b          'TRB',0
        dc.l          $FFFFFD4B
        dc.b          'CRB',0
        dc.l          $FFFFFD18
        dc.b          'RRC',0
        dc.l          $FFFFFD38
        dc.b          'TRC',0
        dc.l          $FFFFFD4C
        dc.b          'CRC',0
        dc.l          $FFFFFD1A
        dc.b          'RRD',0
        dc.l          $FFFFFD3A
        dc.b          'TRD',0
        dc.l          $FFFFFD4D
        dc.b          'CRD',0
        dc.l          $FFFFFD1C
        dc.b          'RRE',0
        dc.l          $FFFFFD3C
        dc.b          'TRE',0
        dc.l          $FFFFFD4E
        dc.b          'CRE',0
        dc.l          $FFFFFD1E
        dc.b          'RRF',0
        dc.l          $FFFFFD3E
        dc.b          'TRF',0
        dc.l          $FFFFFD4F
        dc.b          'CRF',0
        dc.l          $FFFFFE00
        dc.b          'TPUMCR',0
        dc.l          $FFFFFE08
        dc.b          'TICR',0 
        dc.l          $FFFFFE0A
        dc.b          'CIER',0
        dc.l          $FFFFFE20
        dc.b          'CISR',0
        dc.l          $FFFFFE0C
        dc.b          'CFSR0',0
        dc.l          $FFFFFE0E
        dc.b          'CFSR1',0
        dc.l          $FFFFFE10
        dc.b          'CFSR2',0
        dc.l          $FFFFFE12
        dc.b          'CFSR3',0
        dc.l          $FFFFFE14
        dc.b          'HSQR0',0
        dc.l          $FFFFFE16
        dc.b          'HSQR1',0
        dc.l          $FFFFFE18
        dc.b          'HSRR0',0
        dc.l          $FFFFFE1A
        dc.b          'HSRR1',0
        dc.l          $FFFFFE1C
        dc.b          'CPR0',0
        dc.l          $FFFFFE1E
        dc.b          'CPR1',0
        dc.l          $FFFFFF00
        dc.b          'CH0',0
        dc.l          $FFFFFF10
        dc.b          'CH1',0
        dc.l          $FFFFFF20
        dc.b          'CH2',0 
        dc.l          $FFFFFF30
        dc.b          'CH3',0
        dc.l          $FFFFFF40
        dc.b          'CH4',0
        dc.l          $FFFFFF50
        dc.b          'CH5',0 
        dc.l          $FFFFFF60
        dc.b          'CH6',0
        dc.l          $FFFFFF70
        dc.b          'CH7',0
        dc.l          $FFFFFF80
        dc.b          'CH8',0
        dc.l          $FFFFFF90
        dc.b          'CH9',0
        dc.l          $FFFFFFA0
        dc.b          'CH10',0 
        dc.l          $FFFFFFB0
        dc.b          'CH11',0
        dc.l          $FFFFFFC0
        dc.b          'CH12',0
        dc.l          $FFFFFFD0
        dc.b          'CH13',0
        dc.l          $FFFFFFE0
        dc.b          'CH14',0
        dc.l          $FFFFFFF0
        dc.b          'CH15',0
        dc.l          $0                     ; Langwort Endemarke
        dcb.b    16,-1      ; Endemarke fr Datei.BIN empfangen
* Hier Upros trap12 trap13 trap14 einbauen        
* Systemtimer D0.B=0 oder 1: STOP  D0.L=1: inint.  D0.L>1: Zeit in us
tra12   movem.l d0-d2/a0-a2,-(a7) ; Register retten
        clr.w   PITR        ; Timer abgeschaltet PTP = PITM = 0
        cmpi.b  #2,d0       ; D0.B = Funktion Interrupt ?
        beq.b   tr1200      ; ja: Interrupt eintragen
        cmpi.b  #3,d0       ; D0.B = Zeit eintragen ?
        beq.b   tr12a       ; ja: D1.L = Zeit einsetzen
        bra     tr12ex      ; nein: Timer STOP   
* kopiert Vektoren setzt VBR trgt Adresse ein         
tr1200  tst.b   d2          ; Vektor eintragen ?
        beq.b   tr120       ; nein:
        move.b  d2,PICR+1   ; D2.B = Vektor gesetzt            
tr120   bsr     vektor      ; Tabelle kopieren Adresse eintragen  
        bra.b   tr12ex      ; keine Timerwerte eintragen
* Timerwerte berechnen und eintragen
tr12a   cmpi.l  #122,d1     ; >= Minimalwert 122 ?
        bhs.b   tr12b       ; ja:
        move.l  #122,d1     ; nein: Minimalwert einsetzen
tr12b   cmpi.l  #31170,d1   ; > Bereich Vorteiler 1 ?
        bhi.b   tr12c       ; ja:
        move.b  #$00,PITR   ; nein: Vorteiler = 1 PTP = 0
        addi.l  #61,d1      ; halber Abstand fr Rundung
        divu.l  #122,d1     ; D3.L = Quotient, Rest verloren (Rundung)
        bra.s   tr12f       ; Teiler eintragen
tr12c   move.b  #$01,PITR   ; Vorteiler = 512 PTP = 1
        cmpi.l  #62500,d1   ; > Teiler = 1 ?
        bhi.s   tr12d       ; ja:
        move.l  #62500,d1   ; nein: Wert fr Teiler = 1 setzen
tr12d   cmpi.l  #15937500,d1 ; < Teiler = 255 ?
        blo.s   tr12e       ; ja:
        move.l  #15937500,d1 ; nein: Grenze Teiler = 255
tr12e   addi.l  #31250,d1   ; halber Abstand fr Rundung
        divu.l  #62500,d1   ; D3.L = Quotient, Rest verloren (Rundung)
tr12f   move.b  d1,PITR+1   ; PITM = Teiler
        move.b  #7,PICR     ; Timerinterrupt Ebene 7 frei
tr12ex  movem.l (a7)+,d0-d2/a0-a2 
        rts                 ; RTE bei TRAP #12 

* TRAP #13 QSPI fr serielle 12-bit-Analogperipherie
tra13  cmpi.b  #0,d0        ; Funktion #0 ?
       bne     trp13a       ; nein:
* initialisieren QSPI-Betrieb Interrupt gesperrt
       andi.w  #$1f7f,QSMCR ; STOP=FRZ1=FRZ0=SUPV=0
       andi.b  #$07,QILR    ; ILQSPI=%000 Interrupt gesperrt
       move.b  #$7f,PORTQS  ; %1111 1111 PORTQS Daten High
       move.b  #$7e,DDRQS   ; %0111 1110 PCSx MOSI aus MISO= ein
       move.b  #$7f,PQSPAR  ; %0111 1111 Betriebsart QSPI
       bra     trp13ex      ; fertig
trp13a cmpi.b  #1,d0        ; Funktion #1 ?
       bne     trp13c       ; nein:
* senden: 12 bit Ruhe High Vorderflanke 1 MHz 238ns vor 7,6 us nach
       move.w  d1,TR0       ; Sendedaten rechtsbndig
       move.b  #$7f,CR0     ; %0111 1111 CONT=0: PCS0 = 1 dann Port PQ3
       bset    #3,PORTQS    ; PQS3 = PCS0 = LOAD = High
       move.w  #$b308,SPCR0 ; %1 0 1100 1 1 | 0000 1000 1 MHz Flanken
       move.w  #$0404,SPCR1 ;      %0 00100 | 0000100  vor / nach
       move.w  #$0000,SPCR2 ; %0 0 0 0 0000 | 0000 0000 Sendung #0
       move.b  #$00,SPCR3   ;  %00000 0 0 0  
       bset    #7,SPCR1     ; Sendung starten
trp13b btst    #7,SPCR1     ; fertig ?
       bne     trp13b       ; nein:
       bclr    #3,PORTQS    ; PQS3 = PCS0 = LOAD = Low
       nop                  ; Lade-Impuls
       bset    #3,PORTQS    ; PQS3 = PCS0 = LOAD = High
       bra     trp13ex      ; ja:
trp13c cmpi.b  #2,d0        ; Funktion #2 ?
       bne     trp13e       ; nein
* empfangen: 15 bit Ruhe High Vorderflanke 200 kHz 238ns vor 7,6 us nach
       move.b  #$fd,CR1     ; %1111 1101 CONT=1: PCS1 = 0 
       move.w  #$bf15,SPCR0 ; %1 0 1111 1 1 | 0001 0101  200 kHz Flanken
       move.w  #$0404,SPCR1 ;     %0 000100 | 00000100   vor / nach
       move.w  #$0101,SPCR2 ; %0 0 0 0 0001 | 0000 0001  Sendung #1
       move.b  #$00,SPCR3   ;  %00000 0 0 0  
       bset    #7,SPCR1     ; Sendung starten
trp13d btst    #7,SPCR1     ; fertig ?
       bne     trp13d       ; nein:
       move.w  RR1,d1       ; D1.W <= Empfangsdaten
       andi.w  #$0fff,d1    ; Maske %0000 1111 1111 1111 
       bra     trp13ex      ; fertig
trp13e cmpi.b  #3,d0        ; Funktion #3 ?
       bne     trp13ex      ; nein:
* Test: bertragung #2  D1.W=Daten D2.W=SPCR0 D3.W=SPCR1 D4.W=CR0 Q-Port
       movem.l d2/d3/d4,-(a7) ; Register retten
       move.w  d1,TR2      ; Sendedaten rechtsbndig
       bset    #15,d2      ; MSTR = 1: Master
       bclr    #14,d2      ; WOMQ = 0: Totem-Pole
       move.w  d2,SPCR0    ; BITS und SPBR
       bclr    #15,d3      ; SPE = 0
       move.w  d3,SPCR1    ;
       move.b  d4,PORTQS   ; Q-Port
       lsr.w   #8,d4       ;
       move.b  d4,CR2      ; Steuerbyte
       move.w  #$0202,SPCR2 ; %0 0 0 0 0010 | 0000 0010 Sendung #2
       move.b  #$00,SPCR3  ;  %00000 0 0 0  
       bset    #7,SPCR1    ; Sendung starten
trp13f btst    #7,SPCR1    ; fertig ?
       bne     trp13f      ; nein:
       move.w  RR2,d1      ; D1.W <=Empfangsdaten
       movem.l (a7)+,d2/d3/d4 ; Register zurck
       bra     trp13ex     ; ja:
       nop                 ; hier weitere Funktionen
trp13ex rts                ;

* TRAP #14 TPU-Funktionen 0/1/2/3/  8/9/10/14/15/  16/17/18
tra14   movem.l d3-d7/a0,-(a7) ; D0 D1 D2 = Rckgabewerte
        cmpi.b  #0,d0       ; Funktion 0: sperren ?
        bne.b   tr142       ; nein: weitere Funktionen
* Funktion #0: Kanal und Interrupt sperren keine Rckgabe
        cmpi.b  #16,d1      ; ja: D1.B < 16: einer ?
        blo.b   tr1401      ; ja: nur 1 Kanal
        clr.w   CIER        ; alle: Interruptfreigaben lschen
        clr.l   CPR0        ; alle: Kanalprioritten %00
        bra     tr1402      ; fertig
tr1401  move.w  CIER,d3     ; Kanal-Interrupt-Freigabe-Bit lschen
        bclr    d1,d3       ; Kanal-Bit gelscht
        move.w  d3,CIER     ; Register wieder zurck
        move.b  d1,d3       ; D3.B = Kanal-Nr.
        lsl.b   #1,d3       ; *2 D3.B = 2-bit-Kanalposition
        move.l  #$fffffffc,d4 ; D4 = %1..100 Maske
        rol.l   d3,d4       ; D4.L = positionierte Maske
        and.l   d4,CPR0     ; Prioritt des Kanal %00 : aus
tr1402  bra     tr14ex      ; fertig
tr142   cmpi.b  #1,d0       ; Funktion 1: Teiler initialisieren ?
        bne     tr14g       ; nein: weitere Funktionen suchen
* Funktion #1: D1.W=Teiler Rck: D0=Systemtakt D1=Timerperiode D2=Timertakt
        cmpi.w  #4,d1       ; Teiler > 4 ?
        bhi.b   tr14a       ; ja: weiter 
        move.w  #$024f,TPUMCR  ; 0 00 00 0 1 0 | 0 1 00 1111 Teiler 4
        bra     tr14h       ; Rckgaben
tr14a   cmpi.w  #8,d1       ; Teiler > 8 ?
        bhi.b   tr14b       ; ja: weiter
        move.w  #$224f,TPUMCR  ; 0 01 00 0 1 0 | 0 1 00 1111 Teiler 8
        bra     tr14h       ; Rckgaben
tr14b   cmpi.w  #16,d1      ; Teiler > 16 ?
        bhi.b   tr14c       ; ja: weiter
        move.w  #$424f,TPUMCR  ; 0 10 00 0 1 0 | 0 1 00 1111 Teiler 16
        bra     tr14h       ; Rckgaben
tr14c   cmpi.w  #32,d1      ; Teiler > 32 ?
        bhi.b   tr14d       ; ja: weiter      
        move.w  #$624f,TPUMCR  ; 0 11 00 0 1 0 | 0 1 00 1111 Teiler 32
        bra     tr14h       ; Rckgaben
tr14d   cmpi.w  #64,d1      ; Teiler > 64
        bhi.b   tr14e       ; ja: weiter
        move.w  #$220f,TPUMCR  ; 0 01 00 0 1 0 | 0 0 00 1111 Teiler 64
        bra     tr14h       ; Rckgaben
tr14e   cmpi.w  #128,d1     ; Teiler > 128 ?
        bhi     tr14f       ; ja: nimm immer 256
        move.w  #$420f,TPUMCR  ; 0 10 00 0 1 0 | 0 0 00 1111 Teiler 128
        bra     tr14h       ; Rckgaben
tr14f   move.w  #$620f,TPUMCR  ; 0 11 00 0 1 0 | 0 0 00 1111 Teiler 256
        bra     tr14h       ; Rckgaben
tr14g   cmpi.b  #2,d0       ; Funktion 2: Rckgaben ?
        bne     tr14i       ; nein: weitere Funktionen
* Funktion #2: Rckgaben: D0<=Systemtakt D1<=Timerperiode D2<=Timertakt
tr14h   bsr     tr14fs      ; D0.L = Systemfrequenz in Hz
        move.l  d0,d1       ; D1.L = Systemfrequenz in Hz
        move.l  d0,d2       ; D2.L <= Systemfrequenz in Hz
        bsr     tr14tl      ; D0.B = Teilerexponent 2 bis 8
        lsr.l   d0,d2       ; D2.L = System/Teiler = Timertakt in Hz
        bsr     tr14tt      ; D0.L = Timerperiode in ps
        exg     d0,d1       ; D0.L <= Systemfre. D1.L <= Timerperiode
        bra     tr14ex      ; fertig mit Funktionen 1 und 2
tr14i   cmpi.b  #3,d0       ; Funktion 3: Interrupt intitialisieren ?
        bne     tr14j       ; nein: weiter
* Funktion #3: Vektortabelle kopieren Interruptadresse eintragen
* D1.B=Anzahl D2.B=Vektor-Nr. A0=Her A1=Ziel=>VBR A2=Adresse
        bsr     vektor      ; nur eintragen
        bra     tr14ex      ; TPUMCR TICR CIER CISR durch Benutzer
tr14j   cmpi.b  #16,d0      ; Funktion #16 TPU-Zustand ausgeben ?   
        bne     tr14k       ; nein: weiter
* Funktion #16: TPU-Register und Parameter-RAM fr Kanal ausgeben
        movem.l d0-d2,-(a7) ; Register retten
        move.l  #'TPUM',d0  ; TPUMCR
        bsr     dizei4n     ; TRAP #1 cr lf und 4 Zeichen
        move.l  #'CR=$',d0  ;
        bsr     dizei4      ;
        move.w  TPUMCR,d0   ;
        bsr     diwort      ; TRAP #4 Wort hexa
        move.l  #'  TI',d0  ; TICR
        bsr     dizei4      ; trap    #2
        move.l  #'CR=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  TICR,d0     ;
        bsr     diwort      ; trap    #4
        move.l  #'  CI',d0  ; CIER
        bsr     dizei4      ; trap    #2
        move.l  #'ER=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  CIER,d0     ;
        bsr     diwort      ; trap    #4
        move.l  #'  CI',d0  ; CISR
        bsr     dizei4      ; trap    #2
        move.l  #'SR=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  CISR,d0     ;
        bsr     diwort      ; trap    #4
        move.l  #' CFS',d0  ; neue Zeile CFSR0
        bsr     dizei4n     ; trap    #1 cr lf 4 Zeichen
        move.l  #'R0=$',d0  ;
        bsr     dizei4      ;  trap    #2
        move.w  CFSR0,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' CFS',d0  ; CFSR1
        bsr     dizei4      ; trap    #2
        move.l  #'R1=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  CFSR1,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' CFS',d0  ; CFSR2
        bsr     dizei4      ; trap    #2
        move.l  #'R2=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  CFSR2,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' CFS',d0  ; CFSR3
        bsr     dizei4      ; trap    #2
        move.l  #'R3=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  CFSR3,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' HSQ',d0  ; neue Zeile HSQR0
        bsr     dizei4n     ; trap    #1 cr lr 
        move.l  #'R0=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  HSQR0,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' HSQ',d0  ; HSQR1
        bsr     dizei4      ; trap    #2
        move.l  #'R1=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  HSQR1,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' HSR',d0  ; HSRR0
        bsr     dizei4      ; trap    #2
        move.l  #'R0=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  HSRR0,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #' HSR',d0  ; HSRR1
        bsr     dizei4      ; trap    #2
        move.l  #'R1=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  HSRR1,d0    ;
        bsr     diwort      ; trap    #4
        move.l  #'  CP',d0  ; CPR0
        bsr     dizei4      ; trap    #2
        move.l  #'R0=$',d0  ;
        bsr     dizei4      ; trap    #2
        move.w  CPR0,d0     ;
        bsr     diwort      ; trap    #4
        move.l  #'  CP',d0  ; CPR1
        bsr     dizei4      ; trap    #2
        move.l  #'R1=$',d0  ; 
        bsr     dizei4      ; trap    #2
        move.w  CPR1,d0     ;
        bsr     diwort      ; trap    #4
* Parameter-RAM ausgeben nur fr D1.B = Kanal-Nr.
        move.l  #'Kana',d0  ; Kanal #$xx  neue Zeile     
        bsr     dizei4n     ; trap    #1  cr lf
        move.l  #'l #$',d0  ;
        bsr     dizei4      ; trap    #2
        andi.l  #$0f,d1     ; D1 = Kanal-Nr. Maske 0..01111
        move.b  d1,d0       ;
        bsr     dibyte      ; trap    #3 Byte ausgeben
        lea     CH0,a0      ; A0 = RAM-Anfangs-Adresse
        lsl.l   #4,d1       ; * 14 D1.L = Abstand fr Kanal
        adda.l  d1,a0       ; A0 = Anfang Kanal-RAM
        move.w  #7,d3       ; D3.W = Zhler fr 8 Wrter   
tr1416a move.l  #'  =$',d0  ; =$wort ausgeben
        bsr     dizei4      ; 4 Zeichen
        move.w  (a0)+,d0    ; Wort laden
        bsr     diwort      ; trap #4 ausgeben 
        dbra    d3,tr1416a  ; Schleife 8 Wrter
        movem.l (a7)+,d0-d2 ; Register zurck
        bra     tr14ex      ; fertig mit Ausgabe
tr14k   cmpi.b  #17,d0      ; Funktion #17: Initialisierung ?
        bne     tr14l       ; nein:
* Funktion #17: Allgemeine Initialisierung D0.W = Funktion | #17
        movem.l d0,-(a7)    ;
        lsr.w   #8,d0       ; D0.B = Funktion
        bsr     tr14ini     ; D0=Funk D1=Kanal D2=Par. D3-D5=RAM-Par.
        movem.l (a7)+,d0    ;
        bra     tr14ex      ; fertig 
tr14l   cmpi.b  #18,d0      ; Funktion #18: Anforderung und RAM lesen
        bne     tr14m       ; nein
* Funktion #18: Anforderung HSRRx  D0 D1 D2 <= Kanal-RAM auslesen
        bsr     tr14anf     ; Anforderung D1.B = Kanal D2.B = %aa
        lea     CH0,a0      ; A0 = Anfangsadresse Parameter-RAM
        lsl.l   #4,d1       ; *16 = Kanal-Abstand
        adda.l  d1,a0       ; A0 = Kanal-RAM
        move.l  (a0)+,d0    ; D0 = CHx+0 und CHx+2
        move.l  (a0)+,d1    ; D1 = CHx+4 und CHx+6
        move.l  (a0)+,d2    ; D2 = CHx+8 und CHx+10
        bra     tr14ex      ; fertig
tr14m   cmpi.b  #8,d0       ; Funktion #8 DIO ?
        bne     tr14n       ; nein

* Funktion #8 DIO = diskrete Ein-/Ausgabe
        cmpi.b  #0,d2       ; Kommando #0: 0 ausgeben ?
        bne     tr148a      ; nein:
        move.w  #$2,d2      ; ja: Anforderung %10
        bsr     tr14anf     ; Anforderung: 0 ausgeben
        bra     tr148d      ; fertig
tr148a  cmpi.b  #1,d2       ; Kommand0 #1: 1 ausgeben ?
        bne     tr148b      ; nein:
        move.w  #$1,d2      ; ja: Anforderung %01
        bsr     tr14anf     ; Anforderung: 1 ausgeben
        bra     tr148d      ; fertig
tr148b  cmpi.b  #2,d2       ; Kommando #2: PINLEVEL lesen ?
        bne     tr148c      ; nein:
        bra     tr148d      ; fertig
tr148c  cmpi.b  #3,d2       ; Kommando #3: Anfordern und PINLEVEL ?
        bne     tr148e      ; nein:
        move.w  #$3,d2      ; ja: Anforderung %11
        bsr     tr14anf     ; Anforderung ausfhren
tr148d  bsr     tr14ram     ; A0 <= Anfangsadresse Parameter-RAM
        move.w  2(a0),d0    ; D0.W <= PINLEVEL
        bra     tr14ex      ; fertig
tr148e  cmpi.b  #10,d2      ; Kommando > #10 ?
        bhi     tr14ex      ; ja: nicht ausfhren
* Kommandos #4 bis #10: Initialisierungen
        movem.l d3/d4/d5,-(a7) ; Register retten
        clr.l   d4          ; CHx+4 | CHx+6
        clr.l   d5          ; CHx+8 | CHx+10
        cmpi.b  #7,d2       ; Kommando #7: D3=MATCHRATE?
        bne     tr148f      ; nein:
        movem.l d2/d3,-(a7) ; Hilfsregister retten
        move.l  d3,d2       ; D2=MATCHRATE Periode/Frequenz
        move.l  #$7fff,d3   ; D3=max. Wert
        bsr     tr14tk      ; D2.W <= MATCHRATE in Takten
        move.w  d2,d4       ; D4 = 00000 | MATCH
        swap    d4          ; D4 = MATCH | 00000 = CHx+4 | CHx+6
        movem.l (a7)+,d2/d3 ; Hilfsregister zurck
tr148f  clr.l   d3          ; CHx+0 | CHx+2
        andi.l  #$0ff,d2    ; Maske 0..0 1111 1111 Kommando maskiert
        subq.l  #4,d2       ; Bereich: 4..10 -> 0 ..6
        move.l  tr148ta(PC,d2.l*4),d2 ; Kommando => Steuerlangwort
        bsr     tr14ini     ; Register & RAM initialisieren und starten
        movem.l (a7)+,d3/d4/d5 ; Register zurck
        bra     tr14ex      ; Funktion #8 Initialisierung fertig
tr148ta dc.l    $0100130    ; Kommando 4: Eingabe steigende Flanke
        dc.l    $0200130    ; Kommando 5: Eingabe fallende Flanke
        dc.l    $0300130    ; Kommando 6: Eingabe beide Flanken
        dc.l    $0000131    ; Kommando 7: Eingabe periodisch D3=Rate
        dc.l    $0000132    ; Kommando 8: Eingabe anfordern
        dc.l    $4420120    ; Kommando 9:  Ausgabe mit Anf. 0
        dc.l    $4410110    ; Kommando 10: Ausgabe mit Anf. 1
tr14n   cmpi.b  #9,d0       ; Funktion #9 PWM ?
        bne     tr14o       ; nein: weiter

* Funktion #9 PWM Pulsweitenmodulierte Rechteckausgabe
        cmpi.b  #3,d2       ; Kommando #0 bis #3 neue Zeiten ?
        bhi     tr149a      ; nein:
        move.l  d3,d2       ; D2.L = neue Periode/Frequenz
        move.l  #$ffff,d3   ; D3.L = max. Wert fr Takte
        bsr     tr14tk      ; D2.W <= Takte fr Periode
        bsr     tr14ram     ; A0 = Anfang Kanal-RAM
        move.w  d2,6(a0)    ; Taktperioden
        lsr.w   #1,d2       ; Takt / 2
        move.w  d2,4(a0)    ; High-Taktzeit
        bra     tr14ex      ; fertig
tr149a  cmpi.b  #4,d2       ; Kommando #4 initialisieren ?
        bne     tr14ex      ; != 4 nicht ausfhren
        movem.l d2-d5,-(a7) ;
        move.l  d3,d2       ; D2.L = Periode/Frequenz
        move.l  #$ffff,d3   ; D3.L = max. Wert fr Takte
        bsr     tr14tk      ; D2.W <= Takte fr Periode
        clr.l   d3          ; CHx+0 | CHx+2
        move.w  d2,d4       ; xxxxx | Perio
        lsr.w   #1,d2       ; Highz
        swap    d4          ; Perio | xxxxx
        move.w  d2,d4       ; Perio | Highz
        swap    d4          ; Highz | Perio = CHx+4 | CHx+6
        clr.l   d5          ; CHx+8 | CHx+10
        move.l  #$4400220,d2 ; D2.L = Steuerparameter
        bsr     tr14ini     ;
        movem.l (a7)+,d2-d5 ;
        bra     tr14ex      ;
tr14o   cmpi.b  #10,d0      ; Funktion #10 ?
        bne     tr14p       ; nein:

* Funktion #10 ITC
        cmpi.b  #3,d2       ; Kommando #0 bis #3: Zhler lesen
        bhi     tr1410a     ; nein:
        bsr     tr14ram     ; A0 = Anfangsadresse Kanal-RAM
        move.w  6(a0),d0    ; D0.W = TRANSCOUNT
        move.l  8(a0),d1    ; D1.L = FINALTIME | LASTTIME
        move.w  CH15+12,d2  ; D2.W = BANK in CH15+12
        bra     tr14ex      ;
tr1410a cmpi.b  #9,d2       ; Kommando #4 bis #9: initialisieren ?
        bhi     tr14ex      ; nein: nicht ausfhren
        movem.l d2-d5,-(a7) ; Register retten
        clr.l   d4          ; CHx+4 | CHx+6
        move.w  d3,d4       ; 00000 | MAXCOUNT
        swap    d4          ; MAXCT | 00000 = CHx+4 | CHx+6
        clr.l   d3          ; CHx+0 | CHx+2   (kein LINK kein COUNT)
        move.b  #$fc,d3     ; BANKADDRESS = $FF.FFFC = CH15+12
        clr.w   CH15+12     ; BANK lschen
        clr.l   d5          ; CHx+8 | CHx+10
        andi.l  #$0ff,d2    ; Maske 0..0 1111 1111 Kommando maskiert
        subq.l  #4,d2       ; Bereich: 4..9 -> 0..5
        move.l  tr14ata(PC,d2.l*4),d2 ; Kommando => Steuerlangwort
        bsr     tr14ini     ; Register & RAM initialisieren und starten
        movem.l (a7)+,d2-d5 ; Register zurck
        bra     tr14ex      ;
tr14ata dc.l    $0130210    ; Kommando #4 einmal steigende Flanke
        dc.l    $0230210    ; Kommando #5 einmal fallende Flanke
        dc.l    $0330210    ; Kommando #6 einmal beide Flanken
        dc.l    $0130211    ; Kommando #7 fortlaufend steigende Flanke
        dc.l    $0230211    ; Kommando #8 fortlaufend fallende Flanke
        dc.l    $0330211    ; Kommando #9 fortlaufend beide Flanken
tr14p   cmpi.b  #14,d0      ; Funktion #14 ?
        bne     tr14q       ; nein:

* Funktion #14 OC
        cmpi.b  #3,d2       ; Kommando #0 bis #3 ?
        bhi     tr1414a     ; nein: initialisiere
        moveq   #1,d2       ; D2 = %01 Anforderung
        bsr     tr14anf     ; ausfhren
        bsr     tr14ram     ; ja: A0 = Anfang Kanal-RAM
        move.w  8(a0),d0    ; D0.W <= REF_TIME 
        move.w  10(a0),d1   ; D1.W <= ACTUAL_MATCH-TIME
        move.w  $ffffec,d2  ; D2.W <= TIMER_1 Kopie aus CH14+12
        bra     tr14ex      ;
tr1414a cmpi.b  #7,d2       ; Kommandos #4 bis #7 initialisieren ?
        bhi     tr14ex      ; > 7: nicht ausfhren
        movem.l d2-d5,-(a7) ; Register retten
        move.l  d2,d5       ; D5.L = Kommando gerettet
        move.l  d3,d2       ; D2.L = OFFSET
        move.l  #$7fff,d3   ; D3.W = max. Timertakte
        bsr     tr14tk      ; D2.W <= OFFSET Timertakte
        clr.l   d3          ; D3 = CHx+0 | CHx+2
        move.w  d2,d3       ; D3 = 00000 | OFFSET
        move.l  d5,d2       ; D2.L = Kommando zurck
        move.l  #$00ec0000,d4 ; D4 = 00 REFAD | CHx+6
        clr.l   d5          ; D5 = CHx+8 | CHx+10
        andi.l  #$0ff,d2    ; Maske 0..0 1111 1111 Kommando maskiert
        subq.l  #4,d2       ; Bereich: 4..9 -> 0..5
        move.l  tr14eta(PC,d2.l*4),d2 ; Kommando => Steuerlangwort
        bsr     tr14ini     ; Register & RAM initialisieren und starten
        movem.l (a7)+,d2-d5 ; Register zurck
        bra     tr14ex      ;
tr14eta dc.l    $4320210    ; Kommando #4 Ausgabe Low-Impuls
        dc.l    $4310210    ; Kommando #5 Ausgabe High-Impuls
        dc.l    $4330210    ; Kommando #6 Ausgabe Flanke
        dc.l    $4330203    ; Kommando #7 Timer nur auslesen
tr14q   cmpi.b  #15,d0      ; Funktion #15 ?
        bne     tr14r       ; nein:

* Funktion #15 PPWA Impuls- und Frequenzmessung
        cmpi.b  #3,d2       ; Kommando #0 bis #3: Zhler auslesen
        bhi     tr14fa      ; nein
        bsr     tr14ram     ; A0 = Anfangsadresse Kanal-RAM
        move.w  2(a0),d0    ; D0.W = CHx+2 =  MAX_COUNT | PERIOD_COUNT
        move.l  4(a0),d1    ; D1.L = CHx+4 | CHx+6 LAST | ACCUM
        move.l  8(a0),d2    ; D2.L = CHx+8 | CHx+10
        andi.w  #$ff00,8(a0) ; %1111 1111 0000 0000 PPWA-UB <= $00
        bra     tr14ex      ;
tr14fa  cmpi.b  #5,d2       ; Kommando #4 bis #5 ?
        bhi     tr14ex      ; > 5 : nicht ausfhrbar
        movem.l d2-d5,-(a7) ; Register retten D3.L = xxxx | MAXC ACCR
        clr.l   d4          ; D4 = CHx+4 | CHx+6  = 00000 | 00000
        clr.l   d5          ; D5 = CHx+8 | CHx+10 = 00000 | 00000
        move.b  d3,d5       ; D5 = 00000 | 00 ACCR
        ror.l   #8,d5       ; D5 = ACCR0 | 0000000
        andi.l  #$0ff00,d3  ; D3 = 00000 | MAXC 0000 = CHx+0 | CHx+2
        andi.l  #$0ff,d2    ; Maske 0..0 1111 1111 Kommando maskiert
        subq.l  #4,d2       ; Bereich: 4..9 -> 0..5
        move.l  tr14fta(PC,d2.l*4),d2 ; Kommando => Steuerlangwort
        bsr     tr14ini     ; Register & RAM initialisieren und starten
        movem.l (a7)+,d2-d5 ; Register zurck
        bra     tr14ex      ;
tr14fta dc.l    $0100322    ; Kommando #4: High-Impulslnge messen
        dc.l    $0200320    ; Kommando #5: Periode messen
tr14r   nop                 ; weitere Funktionen untersuchen
tr14ex  movem.l (a7)+,d3-d7/a0 ; Rckgaben in D0 D1 D2 je nach Funktion
        rts                ;

* Hilfs-Unterprogramme fr TRAP #14        
* tr14fs liefert D0.L = Systemfrequenz in Hz
tr14fs  movem.l d1,-(a7)  ; D1 retten
        move.b  SYNCR,d1   ; D1.B = Teiler Systemtakt
        lsr.b   #6,d1      ; 000000wx Faktor 2*w + x
        addq.b  #1,d1      ; Faktor 2
        clr.l   d0         ;
        move.b  SYNCR,d0   ; D0.L = wx yyyyyy
        andi.b  #$3f,d0    ; %0011 1111 wx ausblenden
        addq.b  #1,d0      ; (y + 1)
        lsl.w   d1,d0      ; * 2**(2*w + x + 1)
        swap    d0         ; * 2 * 32768
        movem.l (a7)+,d1   ; D1 zurck
        rts                ;
    
*tr14tl liefert D0.B = Teilerexponent 2 (2**2=4) bis 8 (2**8=256)          
tr14tl  clr.l   D0          ; D0.L = 0
        move.b  TPUMCR,d0   ; D0.B = x TCR1P x xxxx
        lsr.b   #5,d0       ; D0.B = x.x TCR1P
        andi.b  #$03,d0     ; %0000 0011 ausblenden
        addq.b  #2,d0       ; *4
        btst    #6,TPUMCR+1 ; PSCK
        bne.b   tr14tl1     ; PSCK = 1 : Teiler 4
        addq.b  #3,d0       ; PSCK = 0 : Teiler 32
tr14tl1 rts                 ;

* tr14tt liefert D0.L = Timer_1 Periode in ps = 1e-12 s    
tr14tt  movem.l d1/d2,-(a7) ; Register retten     
        bsr     tr14tl      ; D0.L = Teilerexponent 2..8
        move.l  d0,d1       ; D1.L = Teilerexponent
        move.l  #1000,d2    ; D2 = Faktor 1e3 fr Einheit ps
        lsl.l   d1,d2       ; * D1 = Teiler
        bsr     tr14fs      ; D0.L = Fsys
        mulu.l  #1000000000,d1:d2 ; #1e9 * D2.L -> D1:D2 (64 bit) 
        divu.l  d0,d1:d2    ; D1:D1 / Fsys -> D2 = Quot D1 = Rest
        move.l  d2,d0       ; D0.L = Ergebnis Timerperiode in ps
        movem.l (a7)+,d1/d2 ; Register zurck
        rts                 ;

* tr14ini: Initialisierung D0=Fkt D1=Kanal D2=Steuerpar. D3 D4 D5 RAM
tr14ini movem.l d0-d7/a0,-(a7) ; Register retten
        andi.l  #$0f,d0     ; D0 = %0..01111 Funktion maskieren
        andi.l  #$0f,d1     ; D1 = %0..01111 Kanal maskieren
* Kanal zunchst sperren durch Prioritt %00
        move.l  d1,d6       ; D6 = Kanal-Nr.
        lsl.l   #1,d6       ; D6 = 2-bit-Kanalposition
        move.l  #$fffffffc,d7 ; D7 = 2-bit-Maske %1..100
        rol.l   d6,d7       ; D7 = positionierte Maske
        and.l   d7,CPR0     ; Kanal gesperrt Prioritt = %00
* Felder TBS PAC PSC eintragen  D2.L = 0 TBS PAC PSC | 0 Pri Anf Zus
        swap    d2          ; D2.W = xxxx 4444 x333 xx22 TBS PAC PSC
        lsl.b   #1,d2       ; D2.W = xxxx 4444 333x x220
        lsl.w   #3,d2       ; D2.W = x444 4333 xx22 0000
        lsl.b   #2,d2       ; D2.W = x444 4333 2200 0000
        lsl.w   #1,d2       ; D2.W = 4444 3332 2000 0000
        lsr.w   #7,d2       ; D2.W = 0000 0004 4443 3322 TBS PAC PSC
        swap    d3          ; D3.L =  CHx+2  |  CHx+0
        or.w    d2,d3       ; D3.L =  CHx+2  |  x..x TBS PAC PSC
        swap    d3          ; D3.L =  CHx+0  |  CHx+2
        swap    d2          ; D2.L = TBS alt |  0 Pri Anf Zus
* Parameter aus D3 D4 D5 nach Parameter-RAM CHx+0 bis CHx+10
        move.l  d1,d6       ; D6.L = Kanal-Nr.
        lsl.l   #4,d6       ; D6.L = Kanal-Nr. * 16
        lea     CH0,a0      ; A0 = Anfangsadresse Parameter-RAM
        move.l  d3,0(a0,d6) ; D3.L nach CHx+0 und CHx+2
        move.l  d4,4(a0,d6) ; D4.L nach CHx+4 und CHx+5
        move.l  d5,8(a0,d6) ; D5.L nach CHx+8 und CHx+10
* Funktion nach CFSRx eintragen D3 D4 D5 sind jetzt frei
        lea     CFSR0,a0    ; A0 = Adresse Kanal-Reg. 15 bis 8
        move.l  d1,d6       ; D6.L = Kanal-Nr.
        cmpi.b  #8,d6       ; Kanal 8 bis 15 ?
        bhs.b   tr14in1     ; ja: Adresse richtig
        lea     CFSR2,a0    ; nein: A0 = Adresse Kanal-Reg. 7 - 0
tr14in1 andi.b  #$07,d6     ; %0000 0111 Bitgruppe 0 - 7 reduziert
        lsl.b   #2,d6       ; *4  D6.L = Position 0 - 28 in CFSRx
        move.l  #$fffffff0,d7 ; D7.L = %1..1 0000 4-bit-Maske
        rol.l   d6,d7       ; D7.L = 4-bit-Maske positioniert
        rol.l   d6,d0       ; D0.L = Funktion    positioniert
        and.l   d7,(a0)     ; alte Funktion durch Maske gelscht
        or.l    d0,(a0)     ; neue Funktion eingebaut
* Zusatzfunktion nach HSQRx eintragen
        lea     HSQR0,a0    ; A0 = Adresse HSQRx-Register
        move.l  d1,d6       ; D6.L = Kanal-Nr. 0 - 15
        lsl.b   #1,d6       ; *2 D6.L = Pos.0 - 30 2-bit-Maske
        move.l  #$fffffffc,d7 ; D7.L = %1..1 1100 2-bit-Maske
        move.l  d2,d5       ; D5.L = Parameter .... Zusatzfunkt.
        andi.l  #$03,d5     ; D5.L = 0..0zz
        rol.l   d6,d7       ; D7.L = 2-bit-Maske  %00 positioniert
        rol.l   d6,d5       ; D5.L = 2-bit-Zusatz %zz positioniert
        and.l   d7,(a0)     ; alte Zusatzfunktion gelscht
        or.l    d5,(a0)     ; neue Zusatzfunktion eingetragen
* Anforderungsfunktion nach HSRRx eintragen
        lsr.w   #4,d2       ; D2.W = Prioritt : Anforderung
        bsr     tr14anf     ; D1.B = Kanal  D2.B = %aa
* Prioritt eintragen und damit Kanal starten
        lsr.l   #4,d2       ; D2.L = Prioritt
        andi.l  #$03,d2     ; D2.L = 0...0pp maskiert
        rol.l   d6,d2       ; D2.L = Prioritt pp positioniert
        or.l    d2,CPR0     ; neue Prioritt eingetragen
        movem.l (a7)+,d0-d7/a0 ; Register zurck
        rts                 ;

* tr14anf = Anforderungsfunktion D1.B = Kanal D2.B = %aa
tr14anf movem.l d1/d2,-(a7) ; alle Register retten
        andi.l  #$03,d2     ; Maske %0..00011 Anforderung maskiert
        andi.l  #$0f,d1     ; Maske $0..01111 Kanal maskiert
        lsl.l   #1,d1       ; *2 = 2-bit-Positionierung
        rol.l   d1,d2       ; Anforderung aa positionieren
tr14an1 tst.l   HSRR0       ; Kanalsteuerung frei ?
        bne.b   tr14an1     ; nein:
        move.l  d2,HSRR0    ; ja: Anforderung ausfhren
        movem.l (a7)+,d1/d2 ; alle Register zurck
        rts
                         ;
*tr14ram: liefert in A0 = Anfangsadresse Kanal-Parameter-RAM
tr14ram movem.l d1,-(a7)    ; D1 mit Kanal retten
        lea     CH0,a0      ; A0 = Anfangsadresse Parameter-RAM
        andi.l  #$0f,d1     ; Maske %0..0 1111 fr Kanal
        lsl.l   #4,d1       ; *16 = Kanal-Abstand
        adda.l  d1,a0       ; A0 = Adresse Kanal-RAM
        movem.l  (a7)+,d1   ; D1 zurck
        rts                 ;

* tr14tk D2.L = +Periode/-Frequenz -> Timertakt D3.L = Max. Wert
tr14tk  movem.l  d0/d3/d4,-(a7) ; Register retten
        tst.l   d2          ; D2.L pos: Periode  D2.L neg: Frequenz
        bmi     tr14tkd     ; neg: Frequenz bergeben
        bsr     tr14tt      ; D0.L = Timer-Takt-Periode in ps
        mulu.l  #1000000,d4:d2 ; D2.L * 1e6 = D4 und D2 in ps
        divu.l  d0,d4:d2    ; D2.L = Quotient = Timertakte Periode
        bvs.b   tr14tkb     ; V=1: berlauf-Fehler
tr14tka cmp.l   d3,d2       ; Kontrollen max. 16-bit-Wert ? 
        bhi.b   tr14tkb     ; > d: berlauffehler
        cmpi.l  #2,d2       ; >= min 2 
        bhs.b   tr14tkc     ; ja: weiter    
        move.l  #2,d2       ; nein: auf min = 2 gesetzt
        bra.b   tr14tkc     ; weiter
tr14tkb move.l  d3,d2       ; D2 auf max = D3.L gesetzt
tr14tkc movem.l (a7)+,d0/d3/d4 ; Register zurck
        rts                 ; Ausgang des Unterprogramms
* Frequenz als neg. Zahl in D2.L bergeben
tr14tkd neg.l   d2         ; D2.L = Soll-Frequenz
        bsr     tr14fs     ; D0.L = Systemfrequenz in Hz
        divu.l  d2,d0      ; D0.L = Takte Rest verloren
        exg     d0,d2      ; D2.L = Takte
        bsr     tr14tl     ; D0.B = Teilerexponent
        lsr.l   d0,d2      ; Takte : Teiler
        bra     tr14tka    ; Kontrolle, eintragen und starten

* Unterprogramm aus TRAP #12 auch fr andere Funktionen
* vektor: D1.B=Anzahl (a0) -> (a1) VBR = a1  D2.W = Vekt. A2 = Adresse
vektor  movem.l d0-d2/a0-a3,-(a7)    ; Register retten
        tst.b   d1          ; D1.B = Anzahl max. 255
        beq.b   vektor2     ; D1.B = 0: nicht kopieren
* Vektortabelle kopieren VBR auf Tabellenanfang
        andi.w  #$00ff,d1   ; %0000 0000 ffff ffff Maske 
        subq.w  #1,d1       ; wegen DBRA
        movea.l a1,a3       ; A3 = Anfang_Ziel fr VBR
vektor1 move.l  (a0)+,(a1)+ ; kopieren
        dbra    d1,vektor1  ; 
        movec   a3,VBR      ; VBR auf neue Tabelle gesetzt
vektor2 tst.w   d2          ; D2.B = Vektor-Nr.
        beq.b   vektor3     ; D2.B = 0: nicht eintragen
* Eintrag nur in Vektortabelle  (Hauptprog: nach Systemregister !!!)       
        andi.l  #$000000ff,d2 ; %0000.... 0000 0000 1111 1111 
        lsl.l   #2,d2       ; Vektor * 4
        movec   VBR,a3      ; A3 = VBR
        adda.l  d2,a3       ; Abst. + VBR = Adresse in Tabelle
        move.l  a2,(a3)     ; Adresse Interruptprogramm nach Tabelle
vektor3 movem.l (a7)+,d0-d2/a0-a3    ; Register zurck
        rts                 ;
        end      start      ; Startadresse
